class rglConcurrent_task_base
{
public:
    rglConcurrent_task_base();
    bool is_ready();
    void set_ready();
    void set_name(const char *);
    void reset();
    void set_thread_id_mask(__int64 a2);
};

class rglShadowmap_occlusion_rasterize_task
{
public:
    ~rglShadowmap_occlusion_rasterize_task();
    void run();
    rglShadowmap_occlusion_rasterize_task(const rglShadowmap_occlusion_scene *a2, rglShadowmap_occlusion_checker *a3, int a4, int a5, const rglCamera *a6, const rglMatrix_frame *a7);
};

class rglLogger_task
{
public:
    rglLogger_task(int a2, __int64 a3);
    ~rglLogger_task();
    void run();
};

class rglCRF_folder_content
{
public:
    bool is_valid();
    __int64 is_initialized();
    char get_source_file_cache(const rglString_base *a2, rglFile_difference_cache *a3);
    char get_file_hash_value(const rglString_base *a2, unsigned int *a3);
    rglCRF_folder_content(const rglCRF_folder_content *);
    rglCRF_folder_content();
    ~rglCRF_folder_content();
    __int64 init(const rglString_base *a2, const rglString_base *a3);
    void set_crf_file_name(const rglVarString *);
    void set_data_folder_path(const rglVarString *);
    bool save_to_cache_file();
    __int64 load_from_cache_file();
    __int64 get_cache_filename(__int64 a2);
    bool pack_update_required();
    char recompute_from_folder();
    __int64 reload_from_cache_file();
    __int64 save_all_content_files_with_type(int a2);
    __int64 read_all_content_files(_QWORD *a2);
    void set_module_path(const rglVarString *);
    __int64 get_crf_folder_name(__int64 a2);
    void get_content_file_names_in_crf_folder(rglString_base *a2, __int64 a3);
    _QWORD get_content_file_names(__int64 *a2);
    void remove_dependent_crf(const rglVarString *);
    void add_dependent_crf(const rglVarString *);
    __int64 contains_only_textures();
    __int64 get_crf_path(__int64 a2);
};

class rglResource_file
{
public:
    rglResource_file(const rglString_base *);
    void set_file_path(const rglString_base *);
    rglResource_file(const rglResource_file *);
    rglResource_file(const rglReference_counted_object *a2);
};

class rglTrf_file
{
public:
    ~rglTrf_file();
    rglTrf_file(const rglString_base *);
    rglTrf_file(const rglTrf_file *);
    rglTrf_file(const rglReference_counted_object *a2);
};

class rglReplay_manager
{
public:
    __int64 write_ipos(rglFile *a2);
    rglVarString get_version_identifier_string(rglVarString *a2);
    bool supports_sound(int);
    ~rglReplay_manager();
    __int64 read_header_from_record_file(rglVarString *a2, rglVarString *a3);
    void set_particle_update_interval(float);
    float get_particle_update_interval();
    void set_recording_interval(int a2, int a3);
    __int64 get_state();
    void set_fps(float);
    float get_fps();
    __int64 get_frame_id();
    char start_record(rglScene *a2);
    char tick_record(float a2);
    void stop_record();
    char start_replay(rglScene *a2);
    void seek_replay(int a2);
    bool tick_replay(float);
    void stop_replay();
    void store_scene();
    __int64 store_entity(const rglEntity *a2, int a3);
    void store_skeleton(rglReplay_skeleton_data *, const rglSkeleton *);
    void store_component(rglReplay_component_data **, const rglEntity_component *);
    void store_light_component(rglReplay_component_data **, const rglLight *);
    void store_composite_component(rglReplay_component_data **, const rglComposite_component *);
    void store_custom_component(rglReplay_component_data **, const rglEntity_component *);
    void store_decal(const rglDecal_def *);
    __int64 store_tableau_texture(rglTexture *a2);
    __int64 store_gpu_morph_parameters(rglGPU_buffer *a2);
    __int64 store_unique_edit_data(const rglMesh::Edit_data *a2);
    void store_time();
    __int64 store_material(_QWORD);
    __int64 load_scene(int a2, int a3);
    __int64 load_entity(rglEntity **a2, const rglReplay_entity_data *a3, const rglReplay_entity_data *a4, unsigned int a5, unsigned int a6);
    __int64 load_skeleton(rglSkeleton **a2, const rglReplay_skeleton_data *a3, const rglReplay_skeleton_data *a4, unsigned int a5, unsigned int a6);
    __int64 load_component(rglEntity_component **a2, const rglReplay_component_data *a3, const rglReplay_component_data *a4, unsigned int a5, unsigned int a6);
    __int64 load_decal(rglDecal_def **a2, const rglReplay_decal_data *a3, int a4, unsigned int a5);
    __int64 load_light_component(rglLight *a2, const rglReplay_light_data *a3, int a4, unsigned int a5);
    __int64 load_particle_component(rglParticle_system_instanced *a2, const rglReplay_particle_system_data *a3, unsigned int a4, unsigned int a5);
    __int64 load_composite_component(rglComposite_component *a2, const rglReplay_composite_data *a3, const rglReplay_composite_data *a4, unsigned int a5, unsigned int a6);
    void load_time();
    void load_material(volatile signed __int32 **a2, rglString_base *a3);
    void load_gpu_morph_parameters(rglGPU_buffer **, unsigned int);
    void load_tableau_texture_parameters(rglTexture **, unsigned int);
    void load_unique_edit_data_parameters(rglMesh::Edit_data **, unsigned int);
    bool generate_flags();
    char generate_entity_flags(__int64 *a2, __int64 a3);
    bool generate_skeleton_flags(rglReplay_skeleton_data *, rglReplay_skeleton_data *);
    bool generate_bone_flags(rglReplay_bone_data *, rglReplay_bone_data *);
    char generate_component_flags(__int64 *a2, __int64 *a3);
    bool generate_light_flags(rglReplay_light_data *, rglReplay_light_data *);
    bool generate_particle_flags(rglReplay_particle_system_data *, rglReplay_particle_system_data *);
    bool generate_composite_flags(rglReplay_composite_data *, rglReplay_composite_data *);
    __int64 generate_custom_flags(rglReplay_component_data *a2, rglReplay_component_data *a3);
    char generate_decal_flags(__int64 *a2, __int64 a3);
    char generate_burst_particle_flags(__int64 *a2, __int64 *a3);
    void add_events(rglReplay_entity_data *, unsigned int, unsigned int, bool);
    void add_events(rglReplay_skeleton_data *, unsigned int, bool);
    void add_events(rglReplay_component_data *a2, int a3, char a4);
    void add_events(rglReplay_composite_data *, unsigned int, bool);
    void add_events(rglReplay_decal_data *a2, int a3);
    bool process_entity_flags(rglEntity **, const rglReplay_entity_data *, unsigned int);
    bool process_skeleton_flags(rglSkeleton **, const rglReplay_skeleton_data *, unsigned int);
    bool process_component_flags(rglEntity_component **, const rglReplay_component_data *, unsigned int);
    bool process_decal_flags(rglDecal_def **a2, const rglReplay_decal_data *a3);
    void clear();
    _QWORD get_frame_decals(__int64 a2, unsigned int a3);
    _QWORD get_frame_entities(__int64 a2, unsigned int a3, char a4);
    __int64 get_frame_child_entities(__int64 a2, unsigned int a3, unsigned int a4);
    __int64 get_or_create_id(const void *a2);
    _QWORD get_or_create_decal_ipo(unsigned int a2);
    _QWORD get_or_create_entity_ipo(unsigned int a2);
    __int64 find_component(_QWORD *a2, __int64 a3);
    __int64 add_flag_to_entity_difference(__int64 *a2, __int64 a3, unsigned int a4, unsigned int a5, int a6);
    __int64 add_flag_to_component_difference(_QWORD *a2, _QWORD *a3, unsigned int a4, char a5);
    __int64 add_flag_to_decal_difference(__int64 *a2, __int64 a3, unsigned int a4, int a5);
    void read_scene_from_file();
    void write_header_data(__int64 a2);
    void read_header_data(const rglString_base *);
    void read_frame_data(rglFile *, unsigned __int64, int, bool);
    void get_save_folder_path(__int64 a2);
    __int64 write_unique_edit_data_info(rglFile *, const rglString_base *);
    __int64 write_gpu_morph_textures(rglFile *, const rglString_base *);
    __int64 write_tableau_textures(rglFile *, const rglString_base *);
    void read_unique_edit_data_info(rglFile *, const rglString_base *);
    void read_gpu_morph_textures(rglFile *, const rglString_base *);
    void read_tableau_textures(rglFile *, const rglString_base *);
    void set_recording_frame_end(int a2);
    __int64 get_recording_frame_end();
    void set_recording_frame_start(int a2);
    __int64 get_recording_frame_start();
    void set_recording_skipped_frames(int a2);
    __int64 get_recording_skipped_frames();
    void set_scene_name(const rglString_base *);
    float get_in_frame_percent();
    __int64 get_interpolated_matrix(__int64 a2, _DWORD *a3, float *a4, float a5, char a6, char a7);
    float get_frame_floating_point();
    void write_frame_ipos(rglFile *a2, unsigned int a3);
    void read_frame_ipos(rglFile *a2, unsigned int a3);
    void delete_alive_frames();
    void validate_cur_frame_data_replaying_state();
    void read_frame_external(int);
    void set_frame_id(int);
    void invalidate_old_frames_recording(char a2);
    void delete_frame_data(unsigned int a2);
    void refresh_file_pointer(char a2, char a3);
    __int64 get_ipo_save_file_path(__int64 a2);
    void write_temp_data_to_final_file();
    __int64 get_replay_header_data_file_path(__int64 a2);
    void replay_manager_debug_log(const char *a2);
    void increment_frame_id();
    void get_version_from_file(rglFile *);
    void write_version_to_file(rglFile *);
    void record_oneshot_sound(const rglString_base *, const rglVec3 *, const rglSound_event_oneshot_parameters *);
    _QWORD get_frame_sounds(__int64 a2, unsigned int a3);
    void read_only_sound_frame_data(int a2);
    void load_skeleton_bone_frames(rglSkeleton *a2, const rglReplay_skeleton_data *a3, const rglReplay_skeleton_data *a4, unsigned int a5, unsigned int a6);
};

class rglFile_manager
{
public:
    void crf_packing_enabled();
    rglVarString mod_direct(const char *a2);
    void synchronize_memory(rglBuffer *);
    __int64 load_crf_file(char a2, __int64 a3, __int64 a4, __int64 a5);
    void lock_buffers(rglBuffer **);
    void get_current_module_path();
    rglVarString mod_direct(const rglString_base *a2);
    rglVarString mod_direct_trf(const rglString_base *a2);
    rglVarString mod_direct_for_resource(rglString_base *a2, int a3, rglString_base *a4);
    __int64 load_resource_pack(const rglString_base *a2, char a3, __int64 a4);
    void set_active_module();
    __int64 load_content_file(unsigned int a2, __int64 a3);
    char load_trf_file(char a2, __int64 a3);
    __int64 load_xtrf_file(unsigned int a2, __int64 a3);
    void get_file_name_and_extension(char *);
    void get_file_name_without_extension(char *a2);
    __int64 close_crf_file();
    void remove_all_files_with_extension(const rglString_base *);
    void copy_all_files_with_extension(const rglString_base *a2, const rglString_base *a3, unsigned __int8 a4);
    _BOOL8 is_file_exists();
    __int64 get_parent_folder(const rglString_base *a2);
    void ensure_directory_exists(char a2);
    _BOOL8 remove_directory();
    void get_full_modules_path();
    rglVarString get_configs_path();
    rglVarString get_game_saves_path();
    rglVarString get_editor_files_path();
    rglVarString get_screenshots_path();
    rglVarString get_recordings_path();
    void get_directory_list(void **a2);
    void get_folder_names_in_path(void **a2);
    void get_all_files_with_extension(void **a2, rglString_base *a3);
    void get_file_list(void **a2);
    __int64 get_modification_time();
    void extract_meta_mesh_name_from_resource_path(rglVarString *);
    __int64 create_resource_cache_file_of_trf(_QWORD *a2);
    __int64 read_resource_cache_file_of_trf(int a2, __int64 a3);
    __int64 read_resource_cache_file_of_trf(__int64 a2);
    __int64 search_filename(rglVarString *a2, _QWORD *a3);
    void get_free_workmem_pair(rglBuffer **);
    void return_workmem_pair(rglBuffer *);
    _BOOL8 pack_crf_files_slave_process();
    bool load_crf_file_and_all_dependent_crf_files_with_name(const rglString_base *, bool);
    __int64 get_dependencies_of_crf_file_by_name(rglString_base *a2, void **a3);
    rglVarString get_folder_path_of_crf_by_name(rglString_base *a2, rglString_base *a3);
    _BOOL8 is_from_future(const rglString_base *a2);
    _BOOL8 is_newer(const rglString_base *a2);
    __int64 file_size();
    _BOOL8 remove_file();
    __int64 has_known_content_file_extension();
    char is_known_content_file_extension();
    char is_well_known_content_file_extension();
    __int64 has_loadable_content_file_extension();
    __int64 is_loadable_content_file_extension();
    bool copy_directory(const rglString_base *);
    bool copy_folder_into(const rglString_base *);
    __int64 copy_file(const rglString_base *a2, unsigned __int8 a3);
    __int64 move(const rglString_base *a2);
    rglCRF_folder_content pre_load_crf_pack(rglString_base *a2, rglString_base *a3, _BYTE *a4, _BYTE *a5, _BYTE *a6);
    void generate_asset_file();
    char load_asset_file(char a2, __int64 a3);
    __int64 handle_content_file_update();
    void get_free_workmem();
    void return_workmem();
    rglVarString get_module_name_from_path(void *a2);
    rglVarString get_module_path_from_path(void *a2);
    __int64 get_index_of_module_path();
    __int64 get_module_path_index_of_scene_with_name();
    void set_module_path_index_of_scene_with_name(int a2, char a3);
    void get_module_path_at(int a2);
    __int64 is_dependency_list_different_from_current(rglString_base *a2, __int64 *a3);
    _BOOL8 touch();
    void pre_process_crf_folder();
};

class rglProject_item
{
public:
    ~rglProject_item();
    __int64 row();
    _DWORD operator=(_DWORD *a2);
    __int64 get_items(const rglString_base *a2, unsigned int a3, __int64 a4);
    __int64 find_item(const rglString_base *a2, unsigned int a3, char a4);
    __int64 add_item(const rglString_base *a2, int a3);
    rglProject_item(const rglString_base *a2, int a3, const rglString_base *a4, __int64 a5, int a6);
    rglProject_item();
    char remove_item(const rglString_base *a2);
    void remove_item(rglProject_item *);
    __int64 get_child_count_recursive();
    rglVarString get_item_type_and_name_appended(rglVarString *a2);
    rglVarString get_item_type_and_name_appended(const rglString_base *a2, int a3);
};

class rglVirtual_data_manager
{
public:
    ~rglVirtual_data_manager();
    rglVirtual_data_manager();
    rglVirtual_data_manager(const rglVirtual_data_manager *);
    rglVirtual_data_manager(void *a2);
    __int64 operator=(__int64 *a2);
    void operator=(void **a2);
    void deregister_data_object(rglVirtual_data *);
    void tick();
    void invalidate_all();
};

class rglProject
{
public:
    bool has_item();
    rglProject();
    ~rglProject();
    void reset();
    void open_project(const rglVarString *);
    _DWORD find_item(const rglString_base *a2, unsigned int a3, char a4);
    __int64 get_items(unsigned int a2, __int64 a3);
    __int64 get_items_with_extension(rglString_base *a2, __int64 a3, __int64 a4);
    __int64 get_project_item_type_of_resource(__int64 a2);
    __int64 check_cyclic_dependency_exist();
    __int64 cyclic_dependency_search(const rglVarString *a2, const rglVarString *a3);
    __int64 is_crf_folder_empty(const rglVarString *a2);
    void check_and_remove_empty_crf_folders();
    void post_process_crf_folder(const rglString_base *);
    void check_and_add_crf_items(const rglString_base *a2, const rglString_base *a3);
    void create_project_items_for_content_file(const rglString_base *, const rglString_base *, rglProject_item *);
    __int64 get_resource_type_of_project_item();
    rglVarString get_tres_path_of_resource(rglVarString *a2, __int64 a3);
};

class rglScene
{
public:
    void write_navigation_mesh_file(const rglString_base *);
    __int64 get_type_id();
    void Particle_manager(int);
    void Particle_manager();
    void set_scene_fog_falloff_offset(float);
    float get_scene_fog_falloff_offset();
    float get_prt_color_contrast();
    float get_prt_intensity_contrast();
    __int64 get_prt_fallback_probe_index(__int64 a2);
    void set_prt_fallback_probe_index(const rglInt_vec3 *);
    float get_prt_multiplier();
    float get_prt_point_light_multiplier();
    void wait_for_oro_rendering();
    void wait_for_oro_visibilities_finished();
    void get_module_path(void *a2);
    void set_module_path(const rglVarString *);
    void register_triggered_ambient_sound(struct ambient_sound_emitter *);
    void deregister_triggered_ambient_sound(struct ambient_sound_emitter *);
    __int64 get_triggered_ambient_sound_emitters();
    rglScene::Visibility Visibility(rglScene *a2);
    void set_performance_modifier(float);
    float get_performance_modifier();
    float get_hexagon_vignette_alpha();
    void set_hexagon_vignette_color(const rglVec3 *);
    void set_hexagon_vignette_alpha(float);
    void register_scene_view(rglScene_view *);
    void deregister_scene_view(rglScene_view *);
    __int64 get_using_skybox();
    void set_using_skybox(char a2);
    __int64 get_play_sound_events_after_render_ready();
    void set_play_sound_events_after_render_ready(char a2);
    __int64 get_ready_to_render();
    void set_ready_to_render(char a2);
    bool using_oros();
    void set_dynamic_shadowmap_cascades_radius_multiplier(float);
    void set_physics_world_limits(const rglVec2 *, const rglVec2 *);
    void set_spatial_grid_disabled();
    void update_bounding_box();
    float get_water_level();
    float get_water_strength();
    float get_water_wind_dependency();
    void set_use_constant_time(char a2);
    __int64 contains_terrain();
    void update_scene_live_version();
    void remove_entity(rglEntity **a2);
    void set_skybox(rglMemory_block_typeless **a2);
    void insert_terrain_map(rglTerrain_map *);
    rglEntity add_light_entity(rglEntity **a2, rglEntity_component **a3);
    void remove_game_entities_with_flags(int);
    void get_shadow_dir(const rglVec3 *, rglVec3 *);
    __int64 get_entities_with_managed_script_components_count();
    void Visibility();
    rglScene::Visibility Visibility(const rglScene::Visibility *a2);
    _QWORD Visibility(_QWORD *a2);
    __int64 get_type_name(__int64 a2);
    rglScene(const rglVarString *, int, bool, bool, bool);
    void tick_entities(float);
    ~rglScene();
    void update_atmosphere_entities();
    void get_sun_frame_rot(rglMat3 *);
    void add_to_delete_list(__int64 a2, int a3, __int64 a4, __int64 a5);
    void apply_atmosphere(const rglAtmosphere *a2, __int64 a3, char a4);
    __int64 add_entity(_QWORD, _QWORD);
    void remove_entity(rglEntity *a2, char a3, char a4);
    void attach_entity_for_replay(rglEntity *this);
    void detach_entity_for_replay(rglEntity *a2);
    void attach_decal_for_replay(rglDecal_def *);
    void detach_decal_for_replay(rglDecal_def *);
    char attach_entity(rglEntity **a2, char a3, __int64 a4, bool a5, char a6);
    __int64 create_path(__int64 a2, const rglVarString *a3, unsigned __int8 a4);
    __int64 create_path(_QWORD, _QWORD, _QWORD);
    void tick(float);
    void prepare_scene_statistics();
    _QWORD get_terrain_size(_QWORD *a2);
    void start_early_render_jobs(rglRender_context *a2, unsigned __int8 a3);
    void render(rglRender_context *a2, unsigned __int8 a3);
    void save_scene_objects(__int64 a2, const rglString_base *a3);
    rglVarString get_scene_data_xml_file_name(const rglString_base *a2);
    void prepare_scene_after_read(__int64 a2, char a3);
    rglMeta_mesh create_road_mesh(__int64 *a2);
    __int64 create_decals_on_skeletal_entities(float *a2, float *a3, int a4, __int64 *a5, float a6);
    void create_blood_trail_on_terrain(const rglVec3 *, const rglVec3 *);
    __int64 create_water_path_mesh(int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, void *);
    void clear_entities_lights_particles();
    void clear_particles();
    void clear_all();
    void clear_decals();
    __int64 get_all_decal_definitions(__int64 a2);
    void add_decal_to_editor_set(rglDecal_def *);
    void add_decal_to_default_set(rglDecal_def *);
    void add_decal_to_set(rglDecal_def *, rglDecal_set *);
    void clear_render_thread_shared_data();
    __int64 check_resources(const rglCheck_resource_params *);
    void create_decal_on_terrain(const rglVec3 *, const rglVec2 *, const rglVec2 *, bool, rglMaterial *, bool);
    void create_footstep_on_terrain(const rglVec3 *, const rglVec3 *, const rglVec2 *, rglMaterial *, bool);
    char check_collision_and_create_decal_on_entities(const rglVec3 *a2, const rglVec3 *a3, const rglVec2 *a4, const rglVec2 *a5, bool a6, rglMaterial *a7, bool a8, bool a9);
    void create_decal_on_entities(const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, bool, rglMaterial *, bool, bool);
    __m128 calculate_bounding_box(rglBounding_box *a2, __int64 a3);
    void read_navmesh();
    void update_physics();
    void update_entity_bounding_boxes();
    void read_camera_data(__int64 a2);
    void read_entities();
    float read(rglPrefab_manager *a2, const rglVarString *a3, BOOL a4, __int128 *a5, bool a6, bool a7, rglTerrain *a8, rglTerrain_map *a9);
    __int64 check_needs_water_reflection();
    char get_first_height_and_normal_beneath_3d_point(__int128 *a2, _OWORD *a3, _OWORD *a4, int a5);
    __int64 get_intersections_with_capsule();
    char get_height_at_point(const rglVec2 *a2, float *a3);
    __int64 get_ground_height_at_with_radius(__int64 a2, __int64 a3, __int64 a4, int a5, int a6, int a7);
    __int64 get_ground_height_at(__int64 a2, __int64 a3, char a4, int a5, char a6);
    __int64 get_ground_height_at_internal(_QWORD, _QWORD, _QWORD, _DWORD, _DWORD, _DWORD);
    void on_config_change();
    rglVarString get_nav_mesh_file_name(const rglString_base *a2, __int64 a3);
    rglVarString get_nav_mesh_prefab_file_name(const rglString_base *a2, __int64 a3);
    __int64 get_object_reference_file_path(__int64 a2);
    void create_scene_directories(__int64 a2);
    void load_navigation_mesh();
    void create_terrain(unsigned __int8 a2, unsigned __int8 a3);
    bool ray_cast_for_closest(const rglVec3 *a2, const rglVec3 *a3, __int64 a4, __int64 a5, float a6);
    bool box_cast_for_closest_only_for_camera(__int64 a2, __int128 *a3, float a4, __int64 a5, __int64 a6, unsigned __int8 a7, char a8, char a9);
    char check_skeleton_collides_with_scene(__int64 a2, float *a3, __int64 a4, int a5, float a6);
    bool check_point_can_see_point(__int64 a2, __int64 a3);
    bool check_point_can_see_point(float *a2, float *a3, float a4, __int64 a5);
    float get_ground_height_at(__int128 *a2, __int64 a3, char a4);
    __int64 get_closest_body_part_that_collides_with_ray();
    __int64 capsule_sweep();
    __int64 sphere_sweep();
    __int64 box_sweep();
    __int64 box_sweep_only_for_camera();
    bool ensure_physics_initialized(__int128 *a2);
    void release_gpu_resources();
    void update_oro_visibilities(rglRender_context *a2);
    void render_oros(rglRender_context *);
    bool is_entity_visible(rglEntity *, rglRender_context *, rglRender_context *, const rglMatrix_frame *, bool, float);
    char render_entity(rglEntity *a2, rglRender_context *a3, const rglMatrix_frame *a4);
    char render_entity_if_visible(rglEntity *a2, rglRender_context *a3, rglRender_context *a4, const rglMatrix_frame *a5, bool a6, float a7);
    void render_entities(rglRender_context *);
    void render_particle_systems(rglRender_context *);
    void finalize_flora_renderer(char a2);
    void create_flora_bodies();
    void update_grass_density();
    __int64 get_sunlight_for_view_angle(__int64 a2, float a3, _OWORD *a4);
    __int64 read_and_calculate_initial_camera(__int64 a2);
    void finalize_nav_mesh();
    __int64 get_alternate_position_for_navmeshless_position(__int64 a2, float *a3, __int64 a4, float *a5, int a6, int a7, int a8);
    void validate_render_params(rglScene_view *a2, __int64 a3, char a4);
    __int64 size_of();
    void update_outer_mesh(char a2, char a3, char a4, bool a5);
    __int64 get_all_entities_with_tag(const rglString_base *a2, volatile signed __int32 ***a3);
    void ensure_entity_list_valid();
    void update_water_entity(bool);
    void apply_water_parameters_to_mesh(rglMesh *);
    void update_performance_modifier();
    void remove_entity_while_keeping_physics(rglEntity **a2, char a3);
    void ensure_flora_renderer();
    void delete_flora_renderer();
    void handle_hardcore_entity_removal(rglEntity *);
    void set_is_indoor(char a2);
    __int64 get_is_indoor();
    char entity_exists(rglEntity *a2);
    __int64 get_root_entities(__int64 a2);
    rglEntity create_game_entity(rglEntity **a2, int *a3, _QWORD *a4, rglMatrix_frame *a5);
    void resize_spatial_grid(__int64 *a2, __int64 a3, __int128 *__struct_ptr a4);
    void reload_entities_from_scene_file(bool);
    void set_prt_color_contrast(float);
    void set_prt_intensity_contrast(float);
    void set_prt_multiplier(float);
    void set_prt_point_light_multiplier(float);
    void create_environment_deformer();
    void destroy_environment_deformer();
    void destroy_water_renderer();
    void update_water_renderer_for_scene();
    void validate_prt_data();
    void set_scene_controller(rglScene_controller *);
    __int64 read_properties(_QWORD, _QWORD);
    void set_owner_thread();
    void set_scene_barrier();
    void set_name(const rglString_base *);
    void clear_terrain_single_pass_shader();
    void update_skybox_mesh_params(__int64 a2);
    void initialize_skybox_entity();
    void remove_skybox_entity();
    void set_editor_objects_visibility(char a2);
    void build_oros();
    void clear_oro_entities();
    float get_ao_at_point(float *a2, __int64 a3, float *a4, float a5, float a6);
    void fetch_module_path_from_xml_path(rglVarString *);
    void clear_edit_mode_entities();
    _QWORD get_entity_with_guid(__int64 a2, const rglString_base *a3);
    void attach_oro_list_to_rc(rglRender_context *);
    __int64 get_grass_density();
    __int64 get_decal_life_multiplier();
    __int64 get_current_flora_kind_names(_QWORD *a2, char a3);
    void replace_flora_kind_with(const rglVarString *, const rglVarString *);
    void invalidate_cpu_render_buffers();
    void invalidate_terrain_physics_materials();
    _QWORD get_all_entity_tags(_QWORD *a2);
    void list_entities_with_non_orthogonal_frame_and_physics(rglFile *);
    void check_terrain_overdraw();
    _QWORD get_all_textures_used_in_scene(_QWORD *a2);
    bool have_sun_shadows();
    bool have_dynamic_sun_shadows();
    void try_to_fetch_physics_results();
    __int64 is_object_reference_file_exists();
    __int64 find_scene_object_xml_file_full_path(rglVarString *a2);
    __int64 get_loading_state();
    __int64 increment_loading_state(int a2);
    void handle_weather_change();
    void lazy_calculate_atmosphere_params();
    bool is_body_required_at_position(const rglVec3 *);
    float read_binary(rglPrefab_manager *, const rglVarString *, bool, bool, bool, rglTerrain *, rglTerrain_map *);
    void write_binary(const rglString_base *, const rglVarString *);
    void finalize_scene();
    __int64 get_current_season();
    void create_navigation_mesh_entities();
    void rebuild_navigation_mesh_if_required();
    __int64 is_replay_scene();
    void set_is_replay_scene(char a2);
    void close_light_shadows_at_outdoor_scenes();
    __int64 get_number_of_terrain_mesh_blend_layers();
    bool should_render_shadows_for_scene_rc(rglRender_context *);
    bool should_bake_terrain_data();
    bool should_render_envmaps();
    bool should_render_decals(rglRender_context *);
    bool should_do_main_rendering(rglRender_context *);
    void check_loading_state(rglRender_context *);
    void on_managed_script_component_created(rglManaged_script_component *);
    void on_managed_script_component_deleted(rglManaged_script_component *);
    void call_on_scene_saved_callbacks_on_script_components(const rglString_base *);
    void register_ragdoll_skeleton(rglSkeleton *);
    void deregister_ragdoll_skeleton(rglSkeleton *);
    void add_to_all_physics_bodies(rglPhysics_engine_body *);
    void remove_from_all_physics_bodies(rglPhysics_engine_body *);
    __int64 Visibility(__int64 a2, __int64 a3, char a4, char a5, float a6);
    __int64 Visibility(__int64 a2, __int64 a3);
    bool Visibility(float);
    __int64 Visibility(__int64 a2, rglObject_bounds_cache *a3, float *a4, rglMatrix_frame *a5, float a6, char a7, char a8);
    void set_interpolated_atmosphere(rglInterpolated_atmosphere *a2);
    void Particle_manager(rglRender_context *);
    __int64 Particle_manager();
    void Particle_manager(float a2, char a3);
    void Particle_manager();
    void Particle_manager(float);
    void Particle_manager();
    void Particle_manager(unsigned int a2);
    void Particle_manager(float);
    bool Particle_manager(int, const rglMatrix_frame *);
    void Particle_manager(__int64 a2, _OWORD *a3);
    void Particle_manager();
    __int64 Particle_manager(_QWORD);
    __int64 Particle_manager(_QWORD);
    void Particle_manager();
};

class TiXmlHelper
{
public:
    __int64 LoadDocument();
    _QWORD SetAttribute(__int64 a2, _BYTE *a3, rglString_base *a4);
    __int64 get_child_value_node_with_name(const rglString_base *a2);
    __int64 get_child_node_with_attribute_value(rglString_base *a2, rglString_base *a3, rglString_base *a4);
};

class rglOption_file_base
{
public:
    rglOption_file_base(const rglOption_file_base *);
    rglOption_file_base(const rglVarString *);
    ~rglOption_file_base();
    void set_read_flag(int);
    __int64 get_read_flag();
    void write(rglFile *);
    void write_string(rglFile *, const char *, const char *);
    void write_float(rglFile *, const char *, const float *);
    void write_uint64(rglFile *, const char *, const unsigned __int64 *);
    void write_int(rglFile *, const char *, const int *);
    _BOOL8 read(rglFile *a2);
    void parse_line(char *const, rglVarString *, rglVarString *);
    float get_float_value(const rglVarString *);
    int get_int_value(const rglVarString *a2);
    __int64 get_uint64_value(const rglVarString *a2);
    __int64 process_item(const rglString_base *a2, rglVarString *a3);
    void get_plain_value_of_config_param(void *a2, const rglString_base *a3);
    __int64 populate_array_with_config_param_names(void **a2);
    void add_forced_option(const rglString_base *);
    _BOOL8 is_forced_option(const rglString_base *a2);
    void show_options_with_imgui(__int64 a2, float a3);
};

class rglUser_config
{
public:
    void set_last_mission_name(__int64 a2);
    void set_latest_mesh_names_0(__int64 a2);
    void set_latest_skel_names_0(__int64 a2);
    void set_latest_anim_names_0(__int64 a2);
    void set_latest_head_names_0(__int64 a2);
    void set_latest_mesh_names_1(__int64 a2);
    void set_latest_skel_names_1(__int64 a2);
    void set_latest_anim_names_1(__int64 a2);
    void set_latest_head_names_1(__int64 a2);
    void set_debug_login_username(__int64 a2);
    void set_debug_login_password(__int64 a2);
    void set_latest_scene_path(__int64 a2);
    void set_cloth_editor_preview_mesh(__int64 a2);
    void set_cloth_editor_helper_mesh(__int64 a2);
    void set_cloth_editor_preview_skeleton(__int64 a2);
    void set_cloth_editor_preview_animation_name(__int64 a2);
    void set_cloth_editor_preview_animation_start_frame(int);
    void set_cloth_editor_preview_animation_end_frame(int);
    void set_cloth_editor_preview_animation_duration(float);
    void set_main_window_rect(__int64 a2);
    void set_main_console_window_rect(__int64 a2);
    void set_qt_console_window_rect(__int64 a2);
    void set_disable_gui_messages(int);
    void set_disable_error_reporting(int);
    void set_use_live_cpp_editing(int);
    rglUser_config(const rglUser_config *);
    rglUser_config();
    ~rglUser_config();
    char is_tooltip_already_shown(const rglVarString *a2);
    void init();
    char on_process_item(const rglString_base *a2, rglVarString *a3);
    void on_write(rglFile *);
};

class rglConfig
{
public:
    void set_number_of_ragdolls(int);
    __int64 get_default_number_of_ragdolls(int a2);
    __int64 get_current_config_number_of_ragdolls();
    char is_config_set_number_of_ragdolls(int a2);
    void set_grass_density(int);
    __int64 get_default_grass_density(int a2);
    __int64 get_current_config_grass_density();
    char is_config_set_grass_density(int a2);
    __int64 get_default_decal_life_multiplier(int a2);
    __int64 get_current_config_decal_life_multiplier();
    char is_config_set_decal_life_multiplier(int a2);
    __int64 get_default_anisotropic_filtering(int a2);
    __int64 get_current_config_anisotropic_filtering();
    char is_config_set_anisotropic_filtering(int a2);
    __int64 get_default_texture_detail(int a2);
    __int64 get_current_config_texture_detail();
    char is_config_set_texture_detail(int a2);
    __int64 get_default_quality_reflections(int a2);
    __int64 get_current_config_quality_reflections();
    bool is_config_set_quality_reflections(int a2);
    __int64 get_default_antialiasing_technique(int a2);
    __int64 get_current_config_antialiasing_technique();
    char is_config_set_antialiasing_technique(int a2);
    void set_occlusion_technique(int);
    __int64 get_default_occlusion_technique(int a2);
    __int64 get_current_config_occlusion_technique();
    bool is_config_set_occlusion_technique(int a2);
    void set_enable_cloth_simulation(int);
    __int64 get_default_enable_cloth_simulation(int a2);
    __int64 get_current_config_enable_cloth_simulation();
    bool is_config_set_enable_cloth_simulation(int a2);
    void set_enable_flora_sway(int);
    __int64 get_default_enable_flora_sway(int a2);
    __int64 get_current_config_enable_flora_sway();
    bool is_config_set_enable_flora_sway(int a2);
    void set_shader_quality(int);
    __int64 get_default_shader_quality(int a2);
    __int64 get_current_config_shader_quality();
    bool is_config_set_shader_quality(int a2);
    void set_postfx_sssss(int);
    __int64 get_default_postfx_sssss(int a2);
    __int64 get_current_config_postfx_sssss();
    bool is_config_set_postfx_sssss(int a2);
    void set_postfx_ssr(int);
    __int64 get_default_postfx_ssr(int a2);
    __int64 get_current_config_postfx_ssr();
    bool is_config_set_postfx_ssr(int a2);
    void set_postfx_dof(int);
    __int64 get_default_postfx_dof(int a2);
    __int64 get_current_config_postfx_dof();
    bool is_config_set_postfx_dof(int a2);
    void set_postfx_hdr(int);
    __int64 get_default_postfx_hdr(int a2);
    __int64 get_current_config_postfx_hdr();
    bool is_config_set_postfx_hdr(int a2);
    void set_postfx_sunshafts(int);
    __int64 get_default_postfx_sunshafts(int a2);
    __int64 get_current_config_postfx_sunshafts();
    bool is_config_set_postfx_sunshafts(int a2);
    void set_postfx_grain(int);
    __int64 get_default_postfx_grain(int a2);
    __int64 get_current_config_postfx_grain();
    bool is_config_set_postfx_grain(int a2);
    void set_postfx_motion_blur(int);
    __int64 get_default_postfx_motion_blur(int a2);
    __int64 get_current_config_postfx_motion_blur();
    bool is_config_set_postfx_motion_blur(int a2);
    void set_tesselation(int);
    __int64 get_default_tesselation(int a2);
    __int64 get_current_config_tesselation();
    bool is_config_set_tesselation(int a2);
    __int64 get_default_particle_quality(int a2);
    __int64 get_current_config_particle_quality();
    char is_config_set_particle_quality(int a2);
    void set_flora_degrade_distance(float);
    float get_default_flora_degrade_distance(int a2);
    __int64 get_current_config_flora_degrade_distance();
    bool is_config_set_flora_degrade_distance(int a2);
    void set_lighting_quality(int);
    __int64 get_default_lighting_quality(int a2);
    __int64 get_current_config_lighting_quality();
    bool is_config_set_lighting_quality(int a2);
    void set_shadowmap_type(int);
    __int64 get_default_shadowmap_type(int a2);
    __int64 get_current_config_shadowmap_type();
    bool is_config_set_shadowmap_type(int a2);
    __int64 get_default_shadowmap_resolution(int a2);
    __int64 get_current_config_shadowmap_resolution();
    char is_config_set_shadowmap_resolution(int a2);
    void set_shadowmap_filtering(int);
    __int64 get_default_shadowmap_filtering(int a2);
    __int64 get_current_config_shadowmap_filtering();
    bool is_config_set_shadowmap_filtering(int a2);
    __int64 get_default_environment_detail(int a2);
    __int64 get_current_config_environment_detail();
    char is_config_set_environment_detail(int a2);
    __int64 get_default_character_detail(int a2);
    __int64 get_current_config_character_detail();
    char is_config_set_character_detail(int a2);
    __int64 get_default_postfx_lens_flares(int a2);
    __int64 get_current_config_postfx_lens_flares();
    bool is_config_set_postfx_lens_flares(int a2);
    void set_postfx_streaks(int);
    __int64 get_default_postfx_streaks(int a2);
    __int64 get_current_config_postfx_streaks();
    bool is_config_set_postfx_streaks(int a2);
    void set_postfx_chromatic_aberration(int);
    __int64 get_default_postfx_chromatic_aberration(int a2);
    __int64 get_current_config_postfx_chromatic_aberration();
    bool is_config_set_postfx_chromatic_aberration(int a2);
    void set_postfx_hexagon_vignette(int);
    __int64 get_default_postfx_hexagon_vignette(int a2);
    __int64 get_current_config_postfx_hexagon_vignette();
    bool is_config_set_postfx_hexagon_vignette(int a2);
    void set_postfx_vignette(int);
    __int64 get_default_postfx_vignette(int a2);
    __int64 get_current_config_postfx_vignette();
    bool is_config_set_postfx_vignette(int a2);
    void set_brightness(float);
    void set_music_volume(float);
    void set_sound_volume(float);
    void set_sound_device(int);
    void set_mouse_sensitivity_coefficient(float);
    void set_invert_mouse(int);
    void set_check_duplicate_floras(int);
    void set_show_qt_console(int);
    void set_use_imgui_console(int);
    void set_print_degenerate_bodies(int);
    void set_weapon_trail_amount(float);
    void set_use_fmod_profiler(int);
    void set_crf_pack_process_count(int);
    void set_compile_shaders_at_scene_loading(int);
    void set_map_center_point_x(int);
    void set_map_center_point_y(int);
    void set_map_max_allowed_distance_from_center_point_x(int);
    void set_map_max_allowed_distance_from_center_point_y(int);
    void set_map_max_allowed_camera_height(int);
    void set_show_tooltips_at_startup(int);
    void set_use_blob_shadow(int);
    void set_force_single_threading(int);
    void set_graphics_adapter(int);
    void set_gamma(float);
    void set_control_mouse_movement_y_scale(float);
    void set_first_time(int);
    void set_show_framerate(int);
    void set_show_debug_text(int);
    void set_max_framerate(int);
    void set_skip_tutorial(int);
    void set_enable_edit_mode(int);
    void set_debug_mode(int);
    void set_cheat_mode(int);
    void set_development_mode(int);
    void set_disable_content_warnings(int);
    void set_disable_modification_checker(int);
    void set_disable_frequency_variation(int);
    void set_disable_sound(int);
    void set_display_width(int);
    void set_display_height(int);
    void set_display_refresh_rate(int);
    void set_display_mode(int);
    void set_selected_monitor(int);
    void set_force_vsync(int);
    void set_use_secure_connection(int);
    void set_max_number_of_connections(int);
    void set_look_for_server_on_this_machine(int);
    void set_enable_version_check(int);
    void set_enable_aspect_ratio_control(int);
    void set_give_performance_warnings(int);
    void set_disable_scene_save_warnings(int);
    void set_disable_warning_lines(int);
    void set_enforce_crc_checks(int);
    void set_pack_only_anims_and_bodies(int);
    void set_enforce_multipass_terrain(int);
    void set_dont_pack_texture_only_crfs(int);
    void set_use_local_coordinates_in_editor(int);
    void set_use_camera_frame_placement_in_editor(int);
    void set_use_fast_combat_inputs(int);
    void set_use_contour_selection_in_editor(int);
    void set_editor_gizmo_scale(float);
    void set_editor_gizmo_fallback_render(int);
    void set_editor_locale(__int64 a2);
    void set_server_ip(__int64 a2);
    void set_system_debug_filter(__int64 a2);
    void set_user_debug_filter(__int64 a2);
    void set_shader_compile_with_left_ctrl(int);
    void set_ui_debug_mode(int);
    void set_shader_development_mode(int);
    void set_output_missing_shaders(int);
    void set_window_repositioning(int);
    void set_mesh_selection_mode(int);
    void set_auto_save_in_minutes(int);
    void set_sharpen_amount(float);
    float get_mouse_sensitivity();
    bool need_motion_vectors();
    rglConfig(const rglConfig *);
    rglConfig();
    ~rglConfig();
    __int64 get_real_number_of_ragdolls();
    __int64 get_real_max_simultaneous_sound_event_count();
    void load_defaults();
    void write_log(rglIO_Stream *);
    bool same_as(rglConfig *);
    void graphics_options_auto_set_options(int a2);
    void set_config_wrt_hardware(char a2);
    void apply_config_changes(char a2);
    char on_process_item(const rglString_base *a2, rglVarString *a3);
    void on_read_file();
    void on_write(rglFile *a2, __int64 a3, __int64 a4, __int64 a5);
    bool shadows_are_enabled();
    bool dynamic_shadows_are_enabled();
    __int64 get_auto_gfx_quality();
    bool should_save_config();
};

class rglModule_ini_options
{
public:
    void set_log_level(int);
    void set_use_texture_tags(int);
    void set_use_edit_data_backup_system(int);
    void set_screenshot_format(int);
    void set_disable_map_simplification(int);
    void set_screenshot_mod(int);
    void set_use_depth_flipping(int);
    void set_record_missions(int);
    void set_show_scene_terrain_layer_errors(int);
    void set_use_physics_engine(int);
    void set_supports_postfx_lens_flares(int);
    void set_supports_postfx_streaks(int);
    void set_supports_postfx_chromatic_aberration(int);
    void set_high_quality_screenshot_width(int);
    void set_enable_amp_server(int);
    void set_supports_postfx_hexagon_vignette(int);
    void set_supports_postfx_vignette(int);
    void set_prt_edit_data_folder(__int64 a2);
    ~rglModule_ini_options();
    rglModule_ini_options(const rglModule_ini_options *);
    rglModule_ini_options(const rglOption_file_base *a2);
    rglModule_ini_options();
    char on_process_item(const rglString_base *a2, rglVarString *a3);
    void on_read_file();
};

class rglShader
{
public:
    __int64 get_vector_argument_w_name();
    __int64 get_type_id();
    void set_technique(rglHLSLTechnique *);
    void set_filename(const rglString_base *);
    void set_gbuffer_shader_name(const rglString_base *);
    void set_shadow_shader_name(const rglString_base *);
    void set_pointlight_shadow_shader_name(const rglString_base *);
    void set_constant_output_shader_name(const rglString_base *);
    void set_overdraw_shader_name(const rglString_base *);
    __int64 get_filename();
    __int64 get_gbuffer_shader_name();
    __int64 get_shadow_shader_name();
    __int64 get_pointlight_shadow_shader_name();
    __int64 get_constant_output_shader_name();
    __int64 get_diffuse_bake_shader_name();
    __int64 get_normal_bake_shader_name();
    __int64 get_overdraw_shader_name();
    __int64 get_texture_slot_names();
    __int64 get_default_texture_slot_names();
    __int64 get_always_require_texture();
    __int64 get_default_texture(int a2);
    __int64 get_vector_argument_x_name();
    __int64 get_vector_argument_y_name();
    __int64 get_vector_argument_z_name();
    __int64 get_vector_argument_2_x_name();
    __int64 get_vector_argument_2_y_name();
    __int64 get_vector_argument_2_z_name();
    __int64 get_vector_argument_2_w_name();
    __int64 get_enforcement_shader(int a2);
    void set_enforcement_shader(int a2, rglMemory_block_typeless **a3);
    bool uses_deferred();
    bool using_decal_rendering();
    bool uses_gbuffer();
    bool uses_optional_gbuffer();
    bool uses_albedo();
    bool uses_world_inverse_cpu();
    bool uses_world_inverse_gpu();
    bool uses_local_wind_dir();
    bool uses_custom_world_inverse();
    bool enforces_vector_arguments_to_mesh();
    bool uses_geometry_pass();
    bool disables_early_depth_stencil();
    bool uses_tesselation_for_material();
    __int64 is_generated();
    void set_flags(int a2);
    void add_flags(int a2);
    void clear_flags(int a2);
    ~rglShader();
    __int64 get_type_name(__int64 a2);
    void read(__int64 a2);
    void read_flags(__int64 a2);
    void update(rglBuffer *a2, unsigned int a3);
    _QWORD write(__int64 a2, __int64 a3);
    __int64 write_flags(__int64 a2, __int64 a3);
    __int64 write_head(rglBuffer *, unsigned int *);
    void read_head(rglCrf_file *, rglBuffer *);
    rglShader();
    __int64 get_possible_system_flags();
    void reset_enforcement_shaders();
    void read_material_flag_names(__int64 a2);
    __int64 get_material_shader_flag_mask(const rglString_base *a2, char a3);
    __int64 check_if_mat_shader_flags_are_same(rglShader *a2);
    __int64 get_material_flag_definitions();
    void create_enforcement_shader(char a2, char a3, rglString_base *a4, __int64 a5);
    void handle_generated_enforcement_shaders(char a2, char a3, __int64 a4);
    void validate_enforcement_shader_names_for_generated_shader();
    void handle_templated_generation();
    void prepare_after_reading_xtrf(__int64 a2, unsigned int a3, __int64 a4);
    void init_header();
    _QWORD write_system_flag_names(__int64 a2, __int64 a3);
    bool can_be_rendered_at_deferred_pass();
    void validate_material_shader_flag_masks();
    __int64 get_slot_index_from_name(const rglString_base *a2, char a3);
};

class rglLibrary
{
public:
    _DWORD ignore_main_threadid_debug_on_thread();
    void set_exit_code();
    rglVarString get_memory_string(__int64 a2);
    void save_global_config_file();
    void save_single_config_file(rglFile *);
    bool check_is_main_thread();
    rglVarString get_build_number_str();
    void copy_crf_packer_log_to_main_log();
    void get_logger_name(char a2);
    rglVarString get_crf_packer_slave_log_name();
    rglLibrary::_Main_threadid_debug_redirector _Main_threadid_debug_redirector();
    void _Main_threadid_debug_redirector();
};

class *rglLibrary
{
public:
    struct get_task_manager();
};

class rglCloth_cook_task_progress_handler
{
public:
    _DWORD operator=(_DWORD *a2);
    rglCloth_cook_task_progress_handler();
    float get_progress();
    _DWORD operator=(_DWORD *a2);
};

class rglTask_manager
{
public:
    void set_maximum_thread_count(int);
    __int64 get_num_worker_threads();
    rglTask_manager();
    ~rglTask_manager(__int64 a2);
    void initialize();
    void add_task(__int64 a2);
    void add_main_thread_task(__int64 *a2);
    void add_render_thread_task(__int64 *a2);
    void add_private_worker_thread_task(__int64 *a2);
    void add_task_to_thread(__int64 *a2, int a3);
    rglWorker_thread create_background_worker_thread(rglString_base *a2);
    void remove_background_worker_thread(rglWorker_thread *a2);
    void wait_main_thread_tasks();
    void wait_render_thread_tasks();
    void wait_private_worker_thread_tasks();
    void wait_task(void *a2, char a3);
    __int64 execute_queued_tasks_on_current_thread(char a2);
    _DWORD get_main_thread_id(_DWORD *a2);
    _DWORD get_render_thread_id(_DWORD *a2);
    __int64 get_render_thread_native_id();
    void start_profiling();
    void end_profiling();
    void print_profiling();
};

class rglApplication_base
{
public:
    rglApplication_base(const rglApplication_base *);
    ~rglApplication_base();
};

class rglWorker_thread
{
public:
    __int64 get_private_work_count();
    _DWORD get_thread_id(_DWORD *a2);
    rglWorker_thread(rglString_base *a2, __int64 a3);
    rglWorker_thread(rglString_base *a2, __int64 a3, int a4);
    ~rglWorker_thread();
    void prepare_to_delete();
    void initialize();
    void add_task(__int64 *a2);
    void add_task_to_private_queue(__int64 *a2);
    __int64 execute_next_task(char a2);
    void wait_private_queue_tasks();
};

class rglParticle_emitter_definition
{
public:
    __int64 get_version();
    bool get_is_decal_creation_active();
    _QWORD get_sample_mesh(_QWORD *a2);
    float get_estimated_peak_particle_count();
    __int64 get_children_count();
    _QWORD get_child_emitter(_QWORD *a2, int a3);
    void increment_version();
    ~rglParticle_emitter_definition();
    rglParticle_emitter_definition(const rglParticle_emitter_definition *);
    rglParticle_emitter_definition(const rglReference_counted_object *a2);
    __int64 estimated_particle_count();
    char write(__int64 a2, __int64 a3, __int64 a4, int a5);
    rglReference_counted_object create_copy(rglReference_counted_object **a2);
    void reset_basic_parameters();
    rglParticle_emitter_definition();
    rglParticle_emitter_definition();
    void set_material(rglMaterial **a2);
    void set_sample_mesh(const rglMeta_mesh *a2);
    void recompute_all_curve_cache();
    char remove_child(const rglParticle_emitter_definition *a2);
    void add_child(__int64 *a2);
    void get_material_shader_flags(const rglRender_context *, unsigned __int64 *);
    void cache_uses_atlas_shading();
    __int64 uses_atlas_shading();
};

class rglEngine_interface
{
public:
    void set_dump_server_path(const rglString_base *);
    void touch_deadlock_checker();
    void set_min_frame_period(float);
    __int64 is_running();
    void delayed_exit_app_with_errorcode(int);
    float get_fps();
    float get_main_fps();
    float get_frame_time();
    __int64 get_frame_no();
    float get_smooth_fps();
    void set_loading_finished(char a2);
    void set_window_title(const rglVarString *);
    __int64 get_pause_count();
    void set_application_ptr(rglApplication_base *);
    __int64 get_dot_net_mode();
    float get_mesh_lod_distance_sq();
    __int64 get_mesh_lod_bias();
    float get_world_multiplier();
    void set_use_delayed_window_resize_operation(char a2);
    __int64 get_use_delayed_window_resize_operation();
    __int64 get_use_non_blocking_frame_limiter();
    void set_use_non_blocking_frame_limiter(char a2);
    float get_iterative_raycast_dist();
    __int64 get_return_code();
    __int64 should_save_config();
    void set_should_save_config(char a2);
    float get_max_iterative_raycast_dist_with_terain();
    __int64 core_resources_loaded();
    void add_global_lod_visibility_mask(int a2);
    void remove_global_lod_visibility_mask(int a2);
    void set_global_lod_visibility_mask(int a2);
    void set_render_particles(char a2);
    void set_render_flora(char a2);
    void set_render_lights(char a2);
    void set_render_shadows(char a2);
    void set_do_animation_sampling(char a2);
    void set_do_integrate_skeleton(char a2);
    void set_tick_script_components(char a2);
    void set_draw_forward_pass(char a2);
    void set_draw_deferred_pass(char a2);
    void set_shader_fetch_textures(char a2);
    void set_use_occlusion_checkers(char a2);
    __int64 get_render_particles();
    __int64 get_render_flora();
    __int64 get_render_lights();
    __int64 get_render_shadows();
    __int64 get_do_integrate_skeleton();
    __int64 get_tick_script_components();
    __int64 get_draw_forward_pass();
    __int64 get_draw_deferred_pass();
    __int64 get_game_specific_profile_tools();
    __int64 get_shader_fetch_textures();
    __int64 get_use_occlusion_checkers();
    __int64 get_global_lod_visibility_mask();
    __int64 get_console_host_machine();
    __int64 get_read_only_mode();
    __int64 get_lod_offset();
    __int64 get_offset_per_lod(int);
    __int64 get_last_opened_scene_module_path_id();
    void set_last_opened_scene_module_path_id(int);
    rglEngine_interface();
    void compute_lod_distances();
    ~rglEngine_interface();
    void set_initialization_data(rglEngine_initialization_data *);
    void process_application_arguments(const rglString_base *);
    void begin_frame();
    void handle_frame_limiter();
    void update();
    void show_light_calibration_window(float a2, double a3);
    void pause(char a2);
    void update_frame_stats();
    void handle_resize(unsigned int, unsigned int);
    void set_running(char a2);
    void one_time_init();
    void final_cleanup();
    void frame_move();
    __int64 create_steam_appid(const char *a2);
    void frame_move_step(float);
    void prepare_scene_after_module_recompile(rglScene *a2);
    _BOOL8 command_line_argument_exists(const rglString_base *a2);
    void get_full_command_line_argument(void *a2);
    rglVarString prepare_crash_folder();
    __int64 get_modules();
    void get_modules_names(__int64 *a2);
    void get_modules_code(void *a2);
    bool render_debug_text_on_screen();
    void bake_uniform_sample_data_of_anim_resources();
    void on_config_change();
    bool render_fps_text_on_screen();
    void get_pc_info(rglVarString *);
    void set_world_multiplier(float);
    rglVarString process_window_title(rglVarString *a2, void *a3);
    __int64 crash_upload_enforced();
    void init_legacy_globals();
    _OWORD get_resolution_at_index(_OWORD *a2, int a3);
    __int64 get_possible_resolution_count();
    void show_overdraw_info();
    void show_light_debug_mode_window(__int64 a2, float a3);
    bool imgui_greyout(char a2, const struct ImVec4 *a3);
    bool imgui_greyout_end(char a2);
    void show_texture_density_window(__int64 a2, float a3);
    void show_tiled_light_overdraw_window(__int64 a2, float a3);
    void show_tiled_decal_overdraw_window(__int64 a2, float a3);
    void disable_forced_dt_mode();
    void enable_forced_dt_mode(float);
    rglEngine_interface::rglDeadlock_checker_task rglDeadlock_checker_task();
    void rglDeadlock_checker_task();
    void clear_old_resources_and_objects();
    char application_take_screenshot(__int64 a2, int a3);
    void delete_device_objects();
    void init_device_objects();
    void load_project_check_crf_files();
    void load_core_content();
    void load_all_crfs();
    void set_async_loading_barrier(int);
    void start_async_loading_of_game();
    __int64 async_loading_done();
    __int64 do_load();
    void increment_async_loader_step_no();
    void load_module_ini_file();
    void optimize_skeleton_anim_resources();
    void set_replay_manager(rglReplay_manager *);
    bool is_replay_manager_recording();
    bool is_replay_manager_replaying();
};

class rglMesh
{
public:
    __int64 get_material();
    __int64 get_type_id();
    __int64 get_mesh_id();
    void set_custom_clip_plane_at(const rglCustom_clip_plane *a2, __int64 a3);
    __int64 get_gpu_morph_buffer_offset();
    __int64 num_bones();
    void set_num_bones(char a2);
    void set_gpu_morph_buffer_offset(int a2);
    _QWORD cloth_simulation_state(_QWORD *a2);
    void set_cloth_simulation_state(_QWORD *a2);
    __int64 mesh_render_order();
    void set_mesh_render_order(const unsigned int *);
    void add_flags(int);
    void remove_flags(int);
    void set_flags(int);
    bool get_use_cur_frames_as_prev_frames();
    void set_meta_mesh(rglMeta_mesh *);
    __int64 get_billboarding();
    rglMesh::Edit_data_read_write_accessor Edit_data_read_write_accessor();
    __int64 Mesh_edit_operations(__int64 a2);
    void Mesh_edit_operations(int, const rglVec3 *, const rglVec3 *);
    void Mesh_edit_operations(int, const rglVec3 *);
    _OWORD Mesh_edit_operations(_OWORD *a2, int a3);
    void Mesh_edit_operations();
    void Mesh_edit_operations();
    void Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    __int64 Mesh_edit_operations();
    void Mesh_edit_operations(int, const rglCorner *);
    rglMesh::Mesh_edit_operations Mesh_edit_operations(const rglMesh::Mesh_edit_operations *a2);
    const Edit_data();
    void set_external_bounding_box(const rglBounding_box *);
    __int64 has_unique_data();
    __int64 num_vertices_cached();
    __int64 required_vertex_buffer_element_count();
    __int64 num_faces_cached();
    void hint_vertices_dynamic();
    void hint_vertices_static();
    void hint_indices_dynamic();
    void hint_indices_static();
    void update_vertices_required();
    __int64 add_vertex(const rglVec3 *);
    __int64 add_face_corner(int, const rglVec2 *, const rglColor *, const rglVec3 *);
    __int64 add_face_corner(int a2, const rglVec2 *a3, const rglVec2 *a4, const rglColor *a5, const rglVec3 *a6);
    __int64 add_face(int, int, int);
    void add_triangle(const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void add_triangle(const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *, const rglColor *, const rglColor *);
    void scale_vertices(const rglVec3 *a2, char a3, float a4);
    void translate_vertices(const rglVec3 *);
    void set_vertex_color(int a2);
    _DWORD get_vertex_color(_DWORD *a2, int a3);
    void set_vertex_color_alpha(float);
    float get_vertex_color_alpha();
    void add_mesh(rglMesh *, const rglMatrix_frame *);
    void add_rectangle(const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void compute_corner_normals(char a2, char a3);
    void rescale_mesh_2d(const rglVec2 *, const rglVec2 *);
    void rescale_mesh_2d_repeat_x_with_tiling(const rglVec2 *, const rglVec2 *, const float *, const int *, float);
    void rescale_mesh_2d_repeat_y_with_tiling(const rglVec2 *, const rglVec2 *, const float *, const int *, float);
    void rescale_mesh_2d_without_changing_uv(const rglVec2 *, const rglVec2 *, float);
    void deform_to_morph_targets(rglMorph_anim::Morph_target *const, int);
    void deform_to_morph_targets(rglMorph_anim::Morph_target *const a2, int *a3, int a4, rglMesh *a5, const rglMatrix_frame *a6);
    bool have_bones();
    __int64 get_real_bone_index_from_mapped(char a2);
    void set_factor_color(unsigned int);
    void set_factor_color(_OWORD *a2);
    void set_factor_color_alpha(float);
    void set_factor2_color(unsigned int);
    void set_factor2_color(_OWORD *a2);
    _OWORD get_factor_color(_OWORD *a2);
    _OWORD get_factor2_color(_OWORD *a2);
    __int64 get_cull_mode();
    bool uses_indirect_skinning();
    void set_second_material(rglMaterial *);
    __int64 get_contour_state();
    const Render_buffers();
    __int64 get_mesh_tags();
    const Skinned_render_data();
    void set_skinned_render_data(int a2, int a3, char a4);
    __int64 get_custom_bone_frame_count();
    __int64 get_additional_bone_frame_count();
    __int64 get_prev_global_skinned_vertex_buffer_index();
    __int64 get_global_bone_frame_buffer_index();
    __int64 get_additional_bone_frame_global_buffer_index();
    rglMesh::Edit_data_read_write_accessor Edit_data_read_write_accessor(const rglMesh::Edit_data_read_write_accessor *a2);
    __int64 Edit_data_read_write_accessor(__int64 a2);
    void `default();
    __int64 get_shader();
    bool has_base_mesh();
    void set_contour_color(const rglVec3 *);
    void set_contour_state(char a2);
    void set_contour_state(char a2);
    void disable_contour();
    bool is_always_valid();
    void set_previous_frame(const rglMatrix_frame *);
    void set_use_cur_frames_as_prev_frames();
    __int64 get_render_matrix(float *a2, char a3, __int64 a4);
    __int16 get_input_layout_id();
    __int64 get_type_name(__int64 a2);
    rglMesh(bool);
    void create_body_from_render_data(rglTriangle_mesh_desc *a2, char a3, char a4);
    void add_tag(const rglString_base *);
    __int64 has_tag(const rglString_base *a2);
    void set_frame(const rglMatrix_frame *);
    void set_frame_local_scale(float);
    ~rglMesh();
    __int64 get_lod_number();
    __int64 get_lod_number();
    __int64 get_vertex_key_size();
    __int64 get_skin_data_size();
    void set_visibility_mask(const unsigned int *);
    char hint_vertices(int a2);
    char hint_indices(int a2);
    void fill_index_buffer_from_edit_data();
    void recompute_bounding_box();
    float get_radius();
    bool has_vertex_keys();
    void deform_to_time(const float *);
    char needs_deform_to_time();
    void check_deform_to_time();
    __int64 create_copy(__int64 *a2);
    void clear();
    void delete_edit_data();
    void debug_draw_normals(rglRender_context *a2, char a3, float a4);
    void set_material(__int64 *a2);
    void add_edit_data_user();
    void release_edit_data_user();
    __int64 check_resources(const rglCheck_resource_params *);
    void clear_gpu_resources();
    void check_gpu_billboarding();
    void set_cull_mode(int a2);
    bool needs_32bit_index_buffer();
    bool has_32bit_index_buffer();
    void set_normals_inverted(char a2);
    void apply_culling_changes();
    void update(rglBuffer *a2, unsigned int a3);
    void update_parameters(const rglMesh *);
    __int64 fill_frames_to_bones_mapping(signed __int8, rglMesh::Edit_data *);
    void release();
    __int64 get_data_count();
    bool edit_data_wont_be_used();
    void write(rglIO_Stream *);
    __int64 write_head(rglBuffer *, unsigned int *);
    void read_head(rglCrf_file *, rglBuffer *);
    __int64 write_data(rglBuffer *a2, int a3);
    void read_vertex_stream(int a2, int a3);
    void update(const rglResource *);
    char make_ready_to_render(rglRender_context *a2);
    char render(rglRender_context *a2, const rglMatrix_frame *a3, rglScene *a4, const rglEntity_render_params *a5);
    void initilaize_render_related_members();
    void deinitilaize_render_related_members();
    bool render_into_oro(rglOrol *, int, const rglMatrix_frame *, int, int);
    void init_header();
    void apply_material_changes();
    void load_edit_data_from_crf();
    __int64 required_index_buffer_element_count();
    void generate_edit_data_from_buffers();
    void set_vector_argument(const rglVec3 *);
    void set_vector_argument_2(const rglVec3 *);
    void update_edit_data_cache_validity();
    __int64 get_resource_name();
    bool is_lod_zero_mesh();
    bool uses_gpu_face_animation();
    void increase_face_corner_count(int a2);
    void increase_face_count(int a2);
    void set_as_contour_mask_mesh();
    void bend_mesh(const rglMesh_bend_params *);
    void handle_skinning(const rglEntity_render_params *);
    __int64 get_material_name(char a2);
    void invalidate_cpu_side_render_buffers();
    void set_material_name(const rglString_base *);
    void invert_cull_mode();
    void set_frames_to_bone_mappings(signed __int8 *);
    void Mesh_edit_operations(int a2, int a3);
    void Mesh_edit_operations();
    void Mesh_edit_operations(const int *, const rglVec2 *, int);
    __int64 Mesh_edit_operations(bool);
    rglString_base get_meta_mesh_name(rglVarString *a2);
    int get_system_flags_of_mesh();
    void set_billboarding(char a2);
    void validate_render_buffers();
    void validate_render_buffers_internal();
    void read_all_vertex_streams(unsigned __int16 a2);
    void read_edit_data();
    void prepare_for_packing();
    void commit_vertex_buffer();
    void commit_index_buffer();
    void fill_vertex_buffer_from_edit_data(unsigned __int16 a2);
    void read_index_buffer();
    char validate_tangents();
    bool is_valid_for_contour();
    bool mesh_needs_head_matrix_scaling();
    void set_mesh_needs_head_matrix_scaling(char a2);
    void read_edit_data_aux(rglBuffer *);
    void setup_custom_skinning(char a2, unsigned __int8 *a3);
    void disable_custom_skinning();
    void set_as_ui_mesh();
    void resolve_runtime_skinning_map();
    void setup_additional_bone_buffer(int);
    void setup_private_bone_buffer(int);
    void set_edit_data_policy(int a2);
    void validate_edit_data();
    void finalize_edit_data_access(char a2);
    void fill_gpu_morph_data_if_not_filled_before();
    void set_override_morph_targets(rglMorph_anim::Morph_target *, int);
    void make_unique();
    rglMesh::Edit_data_read_write_accessor Edit_data_read_write_accessor(rglMesh *a2, int a3);
    void Edit_data_read_write_accessor(rglMesh *a2, int a3);
    void Edit_data_read_write_accessor();
    void Edit_data_read_write_accessor();
    void Edit_data_read_write_accessor();
    void Edit_data_read_only_accessor(rglMesh *a2, int a3);
    rglMesh::Edit_data_read_only_accessor Edit_data_read_only_accessor(rglMesh *a2, int a3);
    void Edit_data_read_only_accessor();
    void Edit_data_read_only_accessor();
    void Edit_data_read_only_accessor();
    rglMesh::Mesh_edit_operations Mesh_edit_operations(rglMesh *a2);
    __int64 Mesh_edit_operations(rglPhysics_engine_body **a2);
    void Mesh_edit_operations(rglMesh *);
    void Mesh_edit_operations(const rglMesh_face *);
    void Mesh_edit_operations();
    void Mesh_edit_operations();
    _DWORD Mesh_edit_operations(_QWORD *a2, int a3, int a4, float a5);
    void Mesh_edit_operations();
    void Mesh_edit_operations(const rglSkeleton *);
    void Mesh_edit_operations();
    void Mesh_edit_operations(rglMesh *a2, const rglMatrix_frame *a3, char a4);
    void Mesh_edit_operations(const rglVec3 *, const rglVec3 *, const rglColor *, const float *);
    void Mesh_edit_operations(const float *a2, const float *const a3, int a4, int a5, const rglColor *a6);
    void Mesh_edit_operations(const rglVec2 *, const rglVec2 *);
    void Mesh_edit_operations(const rglVec2 *, const rglVec2 *, const float *, const int *);
    void Mesh_edit_operations(const rglVec2 *, const rglVec2 *, const float *, const int *);
    void Mesh_edit_operations(const rglVec2 *, const rglVec2 *, float);
    void Mesh_edit_operations(const rglVec2 *, const rglVec2 *, const float *, const int *, float);
    void Mesh_edit_operations(const rglVec2 *, const rglVec2 *, const float *, const int *, float);
    void Mesh_edit_operations(const rglInt_vec2 *a2, const rglVec2 *a3, char a4, float a5);
    void Mesh_edit_operations(rglMesh *, const rglMatrix_frame *, float);
    void Mesh_edit_operations(const int *, const rglColor *);
    void Mesh_edit_operations(int);
    void Mesh_edit_operations(int);
    void Mesh_edit_operations(int);
    void Mesh_edit_operations(int);
    void Mesh_edit_operations();
    __int64 Mesh_edit_operations(_QWORD, _QWORD);
    __int64 Mesh_edit_operations(char a2);
    __int64 Mesh_edit_operations(char a2);
    void Mesh_edit_operations(char a2, char a3);
    __int64 Mesh_edit_operations(const rglVec3 *);
    __int64 Mesh_edit_operations(int, const rglVec2 *, const rglColor *, const rglVec3 *);
    __int64 Mesh_edit_operations(int a2, const rglVec2 *a3, const rglVec2 *a4, const rglColor *a5, const rglVec3 *a6);
    __int64 Mesh_edit_operations(const rglCorner *);
    __int64 Mesh_edit_operations(int, int, int);
    void Mesh_edit_operations(const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void Mesh_edit_operations(const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *, const rglColor *, const rglColor *);
    void Mesh_edit_operations(const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *, const rglColor *, const rglColor *);
    void Mesh_edit_operations(const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void Mesh_edit_operations(const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void Mesh_edit_operations(const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void Mesh_edit_operations(const rglVec3 *, const rglVec3 *, const rglVec2 *, const rglVec2 *, const rglColor *);
    void Mesh_edit_operations(rglMesh *, const rglMatrix_frame *);
    void Mesh_edit_operations(__int64 a2, __int64 a3, __int128 *a4, char a5);
    void Mesh_edit_operations(rglMesh *a2, const rglMatrix_frame *a3, char a4);
    void Mesh_edit_operations(rglMesh *, const rglMatrix_frame *);
    void Mesh_edit_operations(rglMesh *, const rglMatrix_frame *);
    void Mesh_edit_operations(__int64 a2, __int64 a3, __int128 *a4);
    void Mesh_edit_operations(__int64 a2, __int64 a3, __int128 *a4, char a5);
    void Mesh_edit_operations(__int64 a2, __int64 a3, char a4, __int128 *a5, char a6, char a7, char a8, char a9);
    void Mesh_edit_operations();
    void Mesh_edit_operations(float);
    void Mesh_edit_operations(const float *);
    void Mesh_edit_operations(const rglVec3 *a2, char a3, float a4);
    void Mesh_edit_operations(const rglVec3 *);
    void Mesh_edit_operations(const rglMat3 *);
    __int64 Mesh_edit_operations(float *a2);
    __int64 Mesh_edit_operations(float *a2);
    __int64 Mesh_edit_operations(int a2);
    _DWORD Mesh_edit_operations(_DWORD *a2, int a3);
    void Mesh_edit_operations(float);
    float Mesh_edit_operations();
    __int64 Mesh_edit_operations(char a2);
    void Mesh_edit_operations();
    void Mesh_edit_operations();
    void Mesh_edit_operations(rglMorph_anim::Morph_target *const a2, int *a3, int a4, rglMesh *a5, const rglMatrix_frame *a6);
    __int64 Mesh_edit_operations(const rglVec3 *, const rglCorner_skin_data *);
    __int64 add_face(int, int, int);
    void clear();
    void set_frame(const rglMatrix_frame *);
    void recompute_bounding_box();
};

class rglLight
{
public:
    void set_shadows(int a2);
    float get_scaled_radius();
    float get_shadow_radius();
    __int64 get_type_id();
    void invalidate_shadow_map();
    rglLight(rglLight *);
    __int64 get_type_name(__int64 a2);
    rglLight();
    rglLight(__int64 a2);
    ~rglLight();
    float get_screen_space_radius(const rglCamera *a2);
    char render_static_light_shadowmap_face(__int64 a2, __int64 a3, _QWORD *a4, int a5, __int64 a6, __int64 a7, int a8, int a9);
    __int64 render_dynamic_light_shadowmap_face(__int64 a2, __int64 a3, int a4, __int64 a5, __int64 a6, int a7, int a8);
    void set_position(const rglVec3 *);
    bool needs_to_render_shadowmap();
    void set_hotspot_angle(float);
    void set_falloff_angle(float);
    void set_volumetric(char a2);
    bool is_volumetric();
    __int64 get_diffuse_light(__int64 a2);
    void handle_sprite(rglRender_context *);
    __int64 get_diffuse_at_point(__int64 a2, float *a3);
    void set_radius(const float *);
    void set_shadow_radius(const float *);
    float get_scaled_shadow_radius();
    void set_light_color(const rglVec3 *);
    _OWORD get_light_color(_OWORD *a2);
    bool shadow_is_enabled();
    void return_shadowmap();
    void init();
    void read(__int64 a2);
    char write(__int64 a2, __int64 a3, __int64 a4, int a5);
    void set_visibility_mask(const unsigned int *);
    void set_frame(const rglMatrix_frame *);
    rglLight create_copy(rglLight **a2);
    void get_shadow_camera(int a2, rglCamera *a3);
    void get_shadow_camera_for_culling(int a2, rglCamera *a3);
    char replay_initialize(rglReplay_manager *a2, rglReplay_component_data *a3);
    void replay_load_data(rglReplay_manager *a2, rglReplay_component_data *a3, rglReplay_component_data *a4);
    __int64 replay_compare_data(rglReplay_component_data *a2, rglReplay_component_data *a3);
    void update_light_properties();
    void update_local_and_global_frame(const rglMatrix_frame *);
    void set_is_spot_light(char a2);
    rglVarString get_type_string(rglVarString *a2);
    void write_binary(rglBuffer *);
    void read_binary(rglBuffer *);
};

class rglView
{
public:
    void set_render_on_demand(char a2);
    __int64 get_enable();
    __int64 render_on_demand();
    __int64 get_file_type_to_save();
    __int64 get_type_id();
    rglView(const rglView *);
    void on_window_size_change();
    __int64 get_type_name(__int64 a2);
    rglView();
    __int64 set_scale(__int64 a2);
    __int64 set_offset(__int64 a2);
    void refresh_viewport();
    void set_render_options(int a2, char a3);
    void set_render_order(int);
    ~rglView();
    void set_texture_targets_to_rc(rglRender_context *);
    void set_depth_target(rglTexture *);
    void set_enable(char a2);
    void set_clear_color(int a2);
    void set_rc_invisibility_flags(int a2);
    void register_event(int a2);
    bool check_event(int a2);
    void clear_events();
    bool position_inside_view(__int64 a2);
    void set_auto_depth_creation(char a2);
    rglVarString get_desc(rglVarString *a2);
    void set_save_final_result_to_disk(char a2);
    void set_save_callback_to_rc(rglRender_context *);
    void set_file_name_to_save(const rglString_base *);
    __int64 get_save_result_to_disk_async();
    void set_file_path_to_save_result(const rglString_base *);
    void set_file_type_to_save(int);
    void set_save_result_to_disk_async(char a2);
    void display(rglRender_context *);
    void pre_display(rglRender_context *);
    void set_render_options(int, bool);
};

class rglResource
{
public:
    __int64 get_type_id();
    __int64 is_ignored();
    void set_as_ignored();
    void get_trf_path(__int64 a2);
    void set_resource_file(rglResource_file *);
    void set_resource_file(_QWORD *a2);
    __int64 get_status();
    void set_status(int a2);
    bool has_data();
    __int64 get_name();
    void set_name(const char *);
    void set_name(const rglString_base *);
    ~rglResource();
    __int64 get_type_name(__int64 a2);
    rglResource();
    void check_data_and_print_warnings();
    __int64 get_trf_filename(_QWORD, _QWORD);
    __int64 get_resource_type_string(int a2);
    void get_resource_type_as_string(void *a2);
    void get_resource_type_string(__int64 a2);
    __int64 get_resource_type_from_string();
    __int64 get_resource_size();
    bool can_contain_data();
};

class rglScene_view
{
public:
    float get_width();
    __int64 get_type_id();
    void set_focused_shadowmap(char a2, __int128 *a3, float a4);
    void set_postfx_graph_name(void *a2);
    rglScene_view(const rglScene_view *);
    __int64 get_type_name(__int64 a2);
    rglScene_view();
    void set_continuous_screen_shot(char a2);
    __int64 get_continuous_screen_shot();
    void set_screenshot_folder_prefix(const rglVarString *);
    rglVarString get_desc(rglVarString *a2);
    void on_window_size_change(int, int);
    void set_scene(rglScene *);
    void set_camera(const rglCamera *);
    float world_point_to_screen_point(float *a2, float *a3);
    void reset_light_managers();
    rglRay get_mouse_ray(__int64 a2);
    float screen_point_to_viewport_point(float *a2, float *a3);
    void translate_mouse(rglVec3 *a2, rglVec3 *a3, const float *a4);
    float get_screen_unified_size(float *a2);
    float get_screen_unified_position(float *a2, float a3, float a4);
    float get_height();
    void on_shader_compile();
    void render_cleaner_rc(rglRender_context *);
    void load_scene_resources();
    void set_scene_uses_skybox(char a2);
    void renders_skybox(char a2);
    ~rglScene_view();
    void set_dont_modify_screen_while_loading(char a2);
    void set_clear_and_disable_after_succesfull_render(char a2);
    void set_reset_after_render(char a2);
    void set_shadowmap_resolution_multiplier(float);
    void on_config_change();
    void on_physics_related_resource_change();
    void set_render_with_postfx(char a2);
    __int64 get_render_with_postfx();
    void set_disable_granite_rendering(char a2);
    void set_accept_global_debug_render_objects_(char a2);
    void set_linear_space_rendering(char a2);
    void set_scene_uses_shadows(char a2);
    void set_scene_uses_contour(char a2);
    void do_not_clear(char a2);
    void ensure_postfx_params(unsigned int a2, const rglRender_context *a3);
    void register_render_context_usage(rglRender_context *);
    __int64 get_oro_register_id();
    void clear_all(char a2, char a3);
    void clear_gpu_resources();
    void set_force_shader_compilation(char a2);
    void set_use_virtual_texturing(char a2);
    __int64 is_ready_to_render();
    void print_used_postfx_memory(rglVarString *a2, __int128 a3);
    void set_clear_gbuffer(char a2);
    void set_scene(rglScene *);
};

class rglCapsule_data
{
public:
    __int64 box_min(__int64 a2);
    __int64 box_max(__int64 a2);
    void set(const rglVec3 *, const rglVec3 *, float);
    void invalidate();
    bool is_valid();
    bool encapsulates_sphere(const rglVec3 *a2, float a3, const rglVec3 *a4);
    bool encapsulates_capsule(const rglCapsule_data *a2, __int64 a3, const rglVec3 *a4);
    float get_volume();
    void set_frame_wo_scale(const rglMatrix_frame *);
    void set_frame_identity();
    void set_frame(const rglMatrix_frame *);
    void update_local_positions();
    rglBounding_box get_bounding_box_in_frame(rglBounding_box *a2, float *a3);
    bool operator==(float *a2);
    void display(rglRender_context *, const rglColor *);
    void set_p1(const rglVec3 *);
    void set_p2(const rglVec3 *);
    void set_radius(float);
    __int64 compute_support_vertex(__int64 a2, float *a3);
    __int64 get_capsule_data(__int64 a2);
};

class rglIntersection_with_vertex_info
{
public:
    __int64 operator=(__int64 a2);
    rglIntersection_with_vertex_info();
    rglIntersection_with_vertex_info(__int64 a2, _OWORD *a3, __int128 *a4, int a5, int a6, __int64 a7);
    __int64 operator=(__int64 a2);
};

class rglIntersection
{
public:
    rglIntersection();
    rglIntersection(const rglPhysics_material *, const rglVec3 *, const rglVec3 *, float);
    __int64 operator=(__int64 a2);
    float intersect_ray_triangle_optimized(const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, const rglVec3 *, rglVec3 *);
    float distance_sq_point_ray_2d(const rglVec2 *, const rglVec2 *);
    float distance_sq_point_line_segment_2d(const rglVec2 *, const rglVec2 *, const rglVec2 *);
    float distance_sq_triangle_to_point_double(const rglVec3 *, const rglVec3 *, const rglVec3 *);
    char intersect_quad_data_capsule_aux(int a2, const rglVec3 *a3, const rglVec3 *a4, const rglCapsule_data *a5, rglIntersection *a6, bool a7);
    char intersect_quad_data_up_capsule_aux(int a2, const rglVec3 *a3, const rglVec3 *a4, const rglCapsule_data *a5, rglIntersection *a6, bool a7);
    __int64 closest_point_triangle_to_point_double(float *a2, float *a3, float *a4, float *a5);
    float get_intersection_between_rays(const rglVec2 *, const rglVec2 *, const rglVec2 *, rglVec2 *);
    bool intersect_box_circle_2d(const rglVec2 *, const rglVec2 *, const float *);
    bool intersect_box_point_2d(const rglVec3 *, const rglVec3 *);
    bool intersect_box_point(const rglVec3 *, const rglVec3 *);
    char intersect_box_box_dim(const rglVec3 *a2, const rglVec3 *a3, const rglVec3 *a4, const enum rglDimension *a5);
    bool intersect_box_box(const rglVec3 *, const rglVec3 *, const rglVec3 *);
    bool intersect_box_box_2d(const rglVec3 *, const rglVec3 *, const rglVec3 *);
    char intersect_plane_segment(const rglVec3 *a2, const rglVec3 *a3, rglVec3 *a4);
};

class rglScene_spatial_grid
{
public:
    __int64 operator=(__int64 a2);
    void init(rglScene *, rglVec3 *, const rglVec2 *, const rglVec2 *, int, int);
    void reset();
    __int64 resize_nav_mesh_grid(__int64 a2, __int64 a3);
    void clear_nav_mesh_records();
    rglScene_spatial_grid();
    ~rglScene_spatial_grid();
    void insert_nav_mesh_face(rglNav_mesh_face *);
    void remove_nav_mesh_face(rglNav_mesh_face *);
    void insert_nav_mesh_face(rglNav_mesh_face *, const rglVec3 *, const rglVec3 *);
    void remove_nav_mesh_face(rglNav_mesh_face *, const rglVec3 *, const rglVec3 *);
    __int64 get_nav_mesh_faces_near_point(float *a2);
    bool get_closest_ray_intersection_with_parts(__int64 a2, __int64 a3);
    __int64 get_body_parts_near_box();
    bool capsule_sweep(__int64 a2, __int64 a3);
    bool sphere_sweep(__int64 a2, __int64 a3);
    bool box_sweep(__int64 a2, __int64 a3);
    bool box_sweep_only_for_camera(__int64 a2, __int64 a3);
    __int64 get_body_parts_collided_with_capsule();
    __int64 get_ground_height_at(__int64 a2, __int64 a3);
    void debug_render_nav_mesh_grid();
};

class rglXMLObject
{
public:
    ~rglXMLObject();
    rglXMLObject();
};

class rglPhysics_material
{
public:
    rglPhysics_material();
    void set_index(int);
    ~rglPhysics_material();
    rglPhysics_material(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    void read_pace_sounds(__int64 a2, rglString_base *a3, int a4, rglString_base *a5);
    void read(__int64 a2);
};

class rglMeta_mesh
{
public:
    __int64 get_lod_bias();
    __int64 get_type_id();
    void Edit_data_read_write_accessor();
    void Edit_data_read_write_accessor();
    void Edit_data_read_only_accessor();
    void Edit_data_read_only_accessor();
    void set_second_material(rglMaterial *);
    __int64 get_game_flags();
    void set_game_flags(int a2);
    __int64 get_head_bone_id();
    __int64 get_mesh_index(const rglMesh *);
    _QWORD get_mesh_at_index(_QWORD *a2, int a3);
    __int64 get_max_lod_no_of_lod_mask();
    bool apply_smooth_lod_cur_frame();
    _QWORD get_cloth_simulation_mesh(_QWORD *a2);
    _QWORD get_cloth_collision_body(_QWORD *a2);
    rglMeta_mesh::Edit_data_read_only_accessor Edit_data_read_only_accessor();
    __int64 get_type_name(__int64 a2);
    rglMeta_mesh();
    rglMeta_mesh();
    ~rglMeta_mesh();
    __int64 set_policy(int a2);
    void clear_meshes();
    void divide_mesh_into_grid(rglMesh *a2, const rglVec3 *a3, __int64 a4, int *a5);
    void copy_to(rglMeta_mesh *a2, char a3);
    void add_lod_mesh(int a2, _QWORD *a3, char a4);
    void add_lod_mesh_with_mask(int a2, _QWORD *a3, char a4);
    char render(rglRender_context *a2, rglScene *a3, const rglMatrix_frame *a4, const rglEntity_render_params *a5);
    char render_into_oro(rglOrol *a2, int a3, const rglMatrix_frame *a4);
    void set_factor_color(const rglVec3 *);
    void set_factor2_color(const rglVec3 *);
    void set_factor_alpha(float);
    void set_vertex_color(int a2);
    void set_vector_argument(const rglVec3 *);
    void set_vector_argument_2(const rglVec3 *);
    void deform_to_time(const float *);
    void transform_vertices_to_parent(const rglMatrix_frame *);
    void set_material(__int64 *a2);
    __int64 get_visibility_mask();
    void set_visibility_mask(const unsigned int *);
    void create_decal_on_skeletal_entities(rglSkinned_decal_buffer *a2, const rglVec3 *a3, const rglVec3 *a4, int a5, int a6, const rglEntity *a7, signed __int8 a8);
    void get_recomputed_bounding_box(rglBounding_box *a2, char a3);
    void recompute_bounding_box();
    void recompute_bounding_box(char a2);
    __int64 check_invalid_meshes(rglMesh ****a2);
    void set_previous_frame_invalid();
    void release_edit_data_user();
    __int64 set_billboarding(char a2);
    void scale_vertices(float);
    void scale_vertices(const rglVec3 *a2, char a3, float a4);
    __int64 set_cull_mode(int a2);
    void compute_tangents();
    void hint_vertices_dynamic();
    void hint_vertices_static();
    void hint_indices_dynamic();
    void hint_indices_static();
    __int64 check_resources(const rglCheck_resource_params *a2);
    void clear_gpu_resources();
    void clear_inside_meshes();
    void set_mesh_render_order(const unsigned int *);
    void add_empty_mesh_as_last_lod();
    __int64 get_meshes_for_lod(char a2, __int64 a3);
    __int64 get_meshes_count_for_lod(char a2);
    void clear_meshes_for_lod(char a2);
    void clear_meshes_for_lod_mask(int);
    void clear_meshes_for_other_lods(int);
    bool is_empty();
    void get_all_meshes(__int64 a2, int a3);
    void get_all_meshes_with_frames(__int64 a2, void **a3, float *a4, int a5);
    void fill_empty_lods();
    void remove_empty_meshes();
    void set_using_season(char a2);
    void set_using_smooth_lod(char a2);
    void init();
    void read(__int64 a2);
    void reset_vertex_colors(const rglString_base *, int);
    char is_optimizable();
    void post_read(const rglString_base *, bool);
    char write(__int64 a2, __int64 a3, const rglMeta_mesh *a4, int a5);
    void post_write(const rglString_base *);
    void set_frame(const rglMatrix_frame *);
    void set_normals_inverted(char a2);
    __int64 get_face_count();
    __int64 get_face_count(char a2);
    __int64 add_mesh_flag(int a2, int a3);
    void merge_with_meta_mesh(rglMeta_mesh *this);
    void add_meta_mesh(const rglMeta_mesh *);
    char replay_initialize(rglReplay_manager *a2, rglReplay_component_data *a3);
    void replay_load_data(rglReplay_manager *, rglReplay_component_data *, rglReplay_component_data *, unsigned int);
    __int64 replay_compare_data(rglReplay_component_data *a2, rglReplay_component_data *a3);
    void start_smooth_lod_transition();
    void set_contour_color(const rglVec3 *);
    __int64 set_contour_state(char a2);
    void set_contour_state(char a2);
    void disable_contour();
    char remove_mesh_from_meta_mesh(rglMesh *a2);
    char has_cloth_mesh();
    void make_materials_unique();
    void invalidate_cloth_states();
    char has_skinned_mesh();
    void set_cloth_collision_body(__int64 *a2);
    void set_cloth_simulation_mesh(__int64 *a2);
    rglVarString get_type_string(rglVarString *a2);
    void read_binary(rglBuffer *);
    void write_binary(rglBuffer *);
    void set_edit_data_policy(int a2);
    void add_edit_data_user();
    __int64 get_meshes_for_lod_mask(int a2, __int64 a3);
    void use_head_bone_scaling(rglSkeleton *a2, char a3, const rglMatrix_frame *a4);
    void clear_meshes_for_lower_lods(char a2);
    void Edit_data_read_only_accessor();
    void Edit_data_read_only_accessor(rglMeta_mesh *a2, int a3);
    rglMeta_mesh::Edit_data_read_only_accessor Edit_data_read_only_accessor(rglMeta_mesh *a2, int a3);
    void Edit_data_read_write_accessor(rglMeta_mesh *a2, int a3);
    rglMeta_mesh::Edit_data_read_write_accessor Edit_data_read_write_accessor(rglMeta_mesh *a2, int a3);
    rglMeta_mesh::Edit_data_read_write_accessor Edit_data_read_write_accessor();
    void Edit_data_read_write_accessor();
    void clear_meshes_for_other_lods(int);
    void clear_meshes_for_lower_lods(int);
    void copy_to(rglMeta_mesh *, bool);
    void add_meta_mesh(const rglMeta_mesh *);
    void set_contour_state(bool);
};

class rglParticle_system_instanced
{
public:
    __int64 get_visibility_mask();
    __int64 get_type_id();
    void set_visibility_mask(const unsigned int *);
    void set_frame(const rglMatrix_frame *);
    void get_type_string(void *a2);
    __int64 get_collision_entities();
    void set_entity(const rglEntity *);
    _QWORD get_particle_effect(_QWORD *a2);
    void set_enable_emitters(char a2);
    __int64 get_enabled();
    void enable_sound(char a2);
    void clear_particles();
    rglParticle_system_instanced(rglParticle_system_instanced *);
    void `default();
    __int64 get_type_name(__int64 a2);
    rglParticle_system_instanced(char a2);
    ~rglParticle_system_instanced();
    void tick(float, const rglMatrix_frame *);
    void read(__int64 a2);
    char write(__int64 a2, __int64 a3, __int64 a4);
    char get_all_meshes(__int64 a2);
    _QWORD create_copy(__int64 a2);
    void set_particle_effect(rglMemory_block_typeless **a2);
    void tick_internal(float, const rglMatrix_frame *);
    void on_emission_start();
    void on_emission_end();
    void reset_emitters();
    void clear_emitters();
    __int64 get_all_emitters(__int64 a2);
    void set_previous_global_frame(const rglMatrix_frame *);
    char has_alive_emitter();
    char should_be_deleted();
    void set_enabled(char a2);
    void reset();
    char has_alive_particle();
    void tick_from_frame_to_frame(float, const rglMatrix_frame *, const rglMatrix_frame *);
    __int64 get_curve_op_type_from_string();
    __int64 get_emit_volume_type_from_string();
    __int64 get_billboard_type_from_string();
    _BOOL8 get_emit_velocity_model_type_from_string();
    __int64 get_collision_behaviour_type_from_string();
    void set_scene(rglScene *);
    void set_enabled(bool);
    void reset();
};

class rglPhysics_material_manager
{
public:
    __int64 get_sound_class_count();
    rglPhysics_material_manager(const rglPhysics_material_manager *);
    rglPhysics_material_manager(_QWORD *a2);
    __int64 operator=(char **a2);
    __int64 operator=(__int64 *a2);
    ~rglPhysics_material_manager();
    __int64 get_material_index_by_name(const rglVarString *);
    __int64 get_monster_sound_index_by_monster_sound_class(const rglVarString *);
    void clear();
    void init(int);
    void restore_materials();
};

class rglImage
{
public:
    rglImage(const rglImage_header *a2, void *a3, int a4);
    rglImage();
    ~rglImage();
    void deallocate();
    void get_all_surface_details(rglImage_surface_detail *);
    __int64 operator=(__int64 a2);
    __int64 dxgi_to_rgl_if();
    __int64 bits_per_pixel();
    __int64 bits_per_pixel();
    void transfer_to_other_image(rglImage *);
    float sample(__int64 a2, __int64 a3, __int64 a4, int a5, int a6);
    void get_sub_image(rglImage *this, unsigned int);
    bool allocate_space(rglBuffer *);
    void create_copy();
    bool rgl_if_has_alpha();
};

class rglVirtual_data
{
public:
    __int64 get_size();
    rglVarString get_filename(rglVarString *a2);
    bool has_valid_cpu_memory();
    rglVirtual_data(const rglVirtual_data *);
    __int64 operator=(__int64 a2);
    rglVirtual_data(const char *);
    ~rglVirtual_data();
    void delete_data();
    void initialize(int a2);
    void validate_cpu_memory_pointer();
    void invalidate_cpu_memory_pointer();
    void on_used();
    void get_whole_data_to_write();
};

class rglTch_file
{
public:
    rglTch_file();
    ~rglTch_file();
    _OWORD operator=(_OWORD *a2);
    char Reader(rglTch_file *a2, rglBuffer *a3);
    char Reader(rglTch_file *a2, int a3, rglBuffer *a4);
    char Reader(rglBuffer *a2);
    char Reader(rglBuffer *a2);
    char Reader(rglBuffer *a2);
    char Reader(unsigned int *a2);
    char Reader(rglImage_header *Src, unsigned int *a3);
    char Writer(rglTch_file *a2);
    char Writer(rglBuffer *a2);
};

class rglMemory_profiler
{
public:
    rglMemory_profiler(const rglMemory_profiler *);
    __int64 operator=(_DWORD *a2);
    rglMemory_profiler();
    ~rglMemory_profiler();
    void add_resource_type_memory_usage(int, int);
    void add_custom_memory_usage(int, const rglString_base *);
    void get_custom_usage_by_index(int a2, rglVarString *a3);
    void print_memory_usages(rglIO_text_stream *);
    rglVarString get_memory_usage_message(double a2);
    __int64 get_memory_usage(int a2);
};

class rglRender_thread_task
{
public:
    rglRender_thread_task(rglRender_thread_message *);
    ~rglRender_thread_task();
    void run(__int64 a2, float a3);
};

class rglRender_thread_simple_task
{
public:
    rglRender_thread_simple_task(_QWORD *a2);
    void run();
    ~rglRender_thread_simple_task();
};

class rglRender_thread_block_task
{
public:
    rglRender_thread_block_task(_QWORD *a2, __int64 a3);
    void run();
};

class rglTexture
{
public:
    __int64 get_type_id();
    __int64 get_depth_target(int a2, int a3);
    __int64 get_source_crc_value();
    void set_atlas_param_values(__int64 a2, __int64 a3);
    void clear_atlas_param_values();
    void set_full_texture_path(const rglString_base *);
    __int64 get_video_buffer_version();
    void set_video_buffer_version(int);
    void set_tableau_status_needs_update();
    void decrement_tableau_status_needs_update(unsigned __int8 a2);
    __int64 get_runtime_status();
    __int64 get_width();
    __int64 get_height();
    __int64 get_mipmap_count();
    __int64 get_surface_format();
    void set_width_height(__int16 a2, __int16 a3);
    void set_surface_format(int a2);
    void set_array_count(__int16 a2);
    __int64 get_array_count();
    void set_mipmap_count(int);
    bool texture_info_valid();
    void add_flag(int a2);
    void `default();
    __int64 get_flags();
    bool is_valid();
    void set_flags(int a2);
    __int64 is_ondemand_texture();
    bool is_dynamic_image();
    bool is_lockable();
    bool is_cubemap();
    __int64 get_type_name(__int64 a2);
    rglTexture(int a2);
    rglTexture(const rglTexture *);
    ~rglTexture();
    void is_ondemand_texture_calc();
    void init_data();
    void create_image_texture();
    void create_image_texture_Imp_blocking(const rglVarString *);
    bool fill_texture_object_with_image_data(rglImage *);
    void release();
    void update(const rglResource *);
    __int64 write_head(rglBuffer *, unsigned int *);
    void read_head(rglCrf_file *, rglBuffer *);
    int read(__int64 a2, char a3);
    void read_flags(__int64 a2);
    void update(rglBuffer *a2);
    __int64 update(__int64 a2);
    void write(rglIO_Stream *);
    __int64 write(__int64 a2, __int64 a3);
    void write_flags(__int64 a2, __int64 a3);
    bool get_tableau_status_needs_update();
    void transform_render_target_to_resource_texture(const rglString_base *);
    void lock_crf_get_buffer(rglBuffer **a2, unsigned int *a3, rglBuffer **a4, rglBuffer **a5);
    void unlock_crf_release_buffer(rglBuffer **a2, rglBuffer *a3, rglBuffer *a4);
    void update_header_from_file();
    void update_header_from_render_target_desc(const rglRender_texture_desc *);
    void update_header_from_depth_target_desc(const rglDepth_texture_desc *);
    void update_header_from_data_texture_desc(const rglData_texture_desc *);
    void update_header_from_gpu_handle();
    rglEngine_interface set_runtime_status(int a2);
    void render_tableau_view(rglRender_context *);
    void add_flags(int a2);
};

class rglPhysX_physics_engine_world
{
public:
    char world_initialized();
    ~rglPhysX_physics_engine_world();
    void remove_collision_shape(rglPhysics_engine_shape *);
    void remove_constraint(rglPhysics_engine_constraint *);
    _DWORD rglvec3_to_pxvec3(_DWORD *a2);
    _DWORD pxvec3_to_rglvec3(_DWORD *a2);
    _DWORD rglvec_to_pxvec(_DWORD *a2);
    _DWORD pxvec_to_rgl_vec(_DWORD *a2);
    _DWORD rglmat3_to_pxmat3(_DWORD *a2);
    __m128 rgl_pxmat3_mat3(float *a2);
    _DWORD rgl_matrix_to_px_transform(const rglMat3 *a2);
    __int64 px_transform_to_rgl_matrix(unsigned int *a2);
    void set_gravity(const rglVec3 *);
    rglPhysX_physics_engine_world();
    void remove_ragdoll(rglRagdoll *a2);
    void init_physics_world(const rglVec3 *, const rglVec3 *);
    void clear_physics_world();
    void start_update(__int64 a2, float a3, char a4, float a5);
    void try_to_fetch_results();
    void fetch_results();
    __int64 get_total_rigid_bodies();
    rglRagdoll_bone add_actor(rglRagdoll_bone *a2, struct physx::PxRigidActor *a3);
    void remove_collision_object(rglPhysics_engine_body *);
    __int64 generate_contacts_with_capsule(__int64 a2, __int64 a3);
    __int64 ray_cast(__int64 a2, __int64 a3);
    __int64 capsule_sweep(__int64 a2, __int64 a3);
    __int64 box_sweep_only_for_camera(float **a2, __int64 a3, unsigned __int8 a4, unsigned __int8 a5, char a6);
};

class rglRenderer
{
public:
    bool show_nodes_required_for_debug_shader_visualization();
    __int64 get_current_rc_count();
    __int64 get_new_meshf0_index();
    __int64 get_new_meshf1_index();
    __int64 get_new_ui_index();
    bool deferred_lighting_pass_required(const rglRender_context *);
    bool half_res_combine_pass_required(const rglRender_context *);
    __int64 get_mesh_render_records_count();
    void set_render_type_flags(int a2);
    __int64 get_render_type_flags();
    void enable_shaded_wireframe_mode();
    void disable_shaded_wireframe_mode();
    void update_mesh_params_buffers();
    void render_static_mesh_motion_vectors(rglRender_context *a2);
    char process_render_job(rglRender_context *a2);
    void draw_rt_to_screen(__int64 a2, __int64 a3, int a4, int a5, const char *a6, unsigned int a7, int a8);
    void update_renderer_fps();
    void set_dynamic_shadow_values(rglRender_context *);
    void set_static_shadow_values(rglRender_context *);
    void set_atmosphere_values(rglRender_context *);
    void set_camera_values(rglRender_context *);
    void set_global_textures(rglRender_context *);
    void prepare_tiled_lights_and_envmaps(rglRender_context *);
    void set_first_time_states(rglRender_context *this);
    void set_tiled_culling_values(rglRender_context *);
    void set_misc_values(rglRender_context *);
    void set_prt_render_data(const rglRender_context *a2, unsigned __int8 a3);
    void set_render_context_states(rglRender_context *a2, char a3, char a4);
    void process_render_context(const rglRender_context *);
    void rc_post_rendering(rglRender_context *a2, unsigned __int8 a3, char a4, unsigned int a5);
    void sort_and_setup_render_rc(rglRender_context *, bool, int);
    void pre_draw_process(rglRender_context *, int);
    __int64 get_effect(__int64 a2, __int64 a3, __int64 *a4, int a5, __int64 a6, __int64 a7, _BYTE *a8);
    char set_shader_for_rrec(__int64 a2, __int64 a3, int a4, __int64 a5, char a6);
    char prepare_rrec(const rglRender_context *a2, __int64 a3, __int64 a4, int a5, char a6);
    __int64 get_terrain_draw_pass(__int64 a2, __int64 a3, char a4, __int64 a5);
    void draw_terrain(const rglRender_context *a2, const rglTerrain_render_record *a3, bool a4, bool a5);
    void begin_deferred_rendering(const rglRender_context *a2, rglTexture *a3, rglTexture *a4);
    void end_deferred_rendering(const rglRender_context *a2);
    float get_debug_font_char_texture_width();
    char init_resources();
    void delete_resources();
    void set_terrain_textures(const rglRender_context *, const rglTerrain_render_record *);
    void set_terrain_shader_constants(const rglRender_context *, const rglTerrain_render_record *);
    ~rglRenderer();
    void reset();
    rglRenderer();
    void clear_render_context(rglRender_context *);
    __int64 populate_list(__int64 a2, __int64 a3);
    __int64 get_size_of_meshf0_buffer(int);
    __int64 get_size_of_meshf1_buffer(int);
    __int64 get_size_of_ui_buffer(int);
    void ensure_target_is_valid(volatile signed __int32 **a2, int a3, int a4, int *a5, char a6);
    void ensure_cubemap_is_valid(volatile signed __int32 **a2, int a3, int a4, char a5, int *a6);
    void begin_postfx_rendering();
    void end_postfx_rendering();
    void start_new_frame();
    void render_ssao(const rglRender_context *this);
    void render_postfx(const rglRender_context *);
    void display_postfx_nodes(rglRender_context *);
    void render_main_deferred_pass(const rglRender_context *a2);
    void handle_refraction(rglMesh_render_record *a2, const rglRender_context *a3);
    void render_ui_meshes(const rglRender_context *a2);
    void render_opaque_forward_meshes(const rglRender_context *a2, char a3);
    void render_dark_ambient_lights(const rglRender_context *);
    void render_gbuffer_pass(const rglRender_context *);
    void render_occluder_gbuffer_prepass(const rglRender_context *);
    void render_occluder_shadow_prepass(const rglRender_context *);
    void set_generic_postfx_params(const rglRender_context *a2, char a3);
    void compute_sorting_key(rglMesh_render_record *a2, const rglRender_context *a3, char a4);
    bool draw_fullscreen_lighting_pass(const rglRender_context *, unsigned int);
    void render_shaded_wireframe_meshes(const rglRender_context *);
    void render_contour_mask(const rglRender_context *);
    __int64 get_cur_frame_no();
    void reset_debug_visualization_options();
    void handle_high_quality_seperate_pass_screenshot(const rglRender_context *a2);
    void set_debug_texture_to_show(rglTexture *);
    void swap_double_buffered_pool_pointers();
    bool gbuffer_pass_required(const rglRender_context *);
    void combine_pointlight_shadows(const rglRender_context *);
    __int64 update_vertex_buffer(_QWORD, _QWORD, _QWORD, _DWORD, _QWORD);
    void update_index_buffer(__int64 a2, int a3, int a4, int a5, __int64 a6);
    void tiled_culling_pass(rglRender_context *a2);
    __int64 dxt_compress_texture(_QWORD, _QWORD, _QWORD);
    void allocate_meshf_buffers(__int64 a2, unsigned int *a3, int a4);
    void allocate_ui_buffers(__int64 a2, unsigned int *a3, int a4);
    __int64 setup_params(__int64 a2, unsigned int *a3);
    bool tiled_culling_pass_required(const rglRender_context *);
    void gpu_skinning_pass(rglRender_context *);
    void render_diffuse_ambient(const rglRender_context *);
    void particle_shading_atlas_generation_pass(const rglRender_context *a2);
    void render_alpha_blended_half_res_forward_meshes(const rglRender_context *);
};

class rglTexture_data_loader_task
{
public:
    rglTexture_data_loader_task(rglTexture *, rglImage *);
    ~rglTexture_data_loader_task();
    void run();
};

class rglMaterial
{
public:
    __int64 get_type_id();
    void set_use_virtual_texturing(unsigned __int8 a2);
    __int64 get_texture(int a2);
    __int64 flags();
    void add_flags(int a2);
    void remove_flags(int a2);
    void set_flags(int a2);
    __int64 alpha_blend_mode();
    __int64 is_original();
    void set_render_order(int);
    void set_alpha_blend_mode(const enum rglAlpha_blend_mode *);
    void set_alpha_blend_mode(int);
    void invalidate_render_pass_caches();
    void fix_namings();
    bool using_skinning();
    bool using_doubleuv();
    bool using_bumpmap();
    bool is_terrain();
    _BOOL8 get_alpha_test_mode();
    __int64 is_mipmap_streaming_enabled();
    __int16 get_input_layout_id();
    __int64 get_type_name(__int64 a2);
    rglMaterial();
    ~rglMaterial();
    void prefetch_streaming_texture(unsigned int a2);
    __int64 get_mipmap_streaming_texture_min_residency(int);
    void use_mipmap_streaming_texture(int);
    void validate_streaming_texture();
    void reset();
    _BYTE read(__int64 a2);
    void read_shader_flags(__int64 a2);
    void read_flags(__int64 a2);
    void update(rglBuffer *a2, unsigned int a3);
    __int64 update(__int64 a2, unsigned int a3);
    void write(__int64 a2, __int64 a3, _QWORD *a4);
    char check_instancing(rglMaterial *a2);
    __int64 write_flags(__int64 a2, __int64 a3);
    __int64 write_shader_flags(__int64 a2, __int64 a3);
    __int64 write_head(rglBuffer *, unsigned int *);
    void read_head(rglCrf_file *, rglBuffer *);
    void update_shader(bool);
    void update(const rglResource *);
    void init_header();
    void set_textures();
    bool alpha_blending_enabled();
    void copy_parameters_from(const rglMaterial *);
    bool using_deferred_pass();
    bool using_decal_rendering();
    bool using_albedo();
    bool using_gbuffer();
    bool using_optional_gbuffer();
    rglResource create_copy(rglResource **a2);
    void set_shader_by_name(rglString_base *a2);
    void set_texture(int a2, rglPhysics_engine_body *a3);
    bool can_be_rendered_at_standart_deferred_pass();
    void validate_virtual_texture_usage();
    bool can_use_virtual_texturing(int);
    void validate_textures();
    __int16 recompute_input_layout();
    void read_vertex_layout_flags(__int64 a2);
    _QWORD write_vertex_layout_flags(__int64 a2, __int64 a3);
    bool can_be_rendered_with_depth_only_pass();
    bool should_be_rendered_to_shadow_pass();
    void modify_shader_flag(const rglString_base *a2, char a3);
    bool has_shader_flag(const rglString_base *);
    void remove_shader_flag(const rglString_base *);
    __int64 check_resources(const rglCheck_resource_params *);
    void set_enable_skinning(char a2);
    void set_texture_to_texture_slot(const rglString_base *a2, rglTexture *a3, char a4);
    void add_shader_flag(const rglString_base *a2, char a3);
    void refresh_shader_flag_masks();
    void validate_shader_flag_names();
    void add_runtime_mesh_record(rglMesh *);
    void remove_mesh_record(rglMesh *);
    void add_shader_flags(__int64 a2);
    void remove_shader_flags(__int64 a2);
    void set_shader_flags(__int64 a2);
};

class rglIpo<rglQuaternion>
{
public:
    void make_uniform();
};

class rglIpo<rglVec3>
{
public:
    char make_uniform();
};

class rglCamera
{
public:
    void set_precision_offset(const rglVec3 *);
    void reset_precision_offset();
    __int64 using_precision_offset();
    __int64 is_perspective();
    float get_left();
    float get_right();
    float get_top();
    float get_bottom();
    float get_near();
    float get_far();
    void adjust_near_plane(float);
    void adjust_far_plane(float);
    rglCamera(const rglCamera *);
    __int64 operator=(__int128 *a2);
    __int64 operator=(__int64 a2);
    rglCamera();
    void reset();
    void set_frame(const rglMatrix_frame *);
    void set_position(const rglVec3 *);
    float get_horizontal_fov();
    float get_vertical_fov();
    float get_aspect_ratio();
    __int64 get_direction(__int64 a2);
    rglMatrix_frame get_projection_matrix(rglMatrix_frame *a2, char a3);
    void compute_for_cubemap(int a2, __int128 *a3, float a4, float a5, char a6);
    void compute_for_dualmap(int a2, __int128 *a3, float a4);
    void compute_clip_planes();
    void set_fov_horizontal(float, float, float, float);
    void set_fov_vertical(float, float, float, float);
    void set_view_volume(char a2, float a3, float a4, float a5, float a6, float a7, float a8);
    _DWORD get_view_matrix(__m128 *a2);
    __m128 get_precise_view_matrix(__int64 a2);
    __int64 look_at(float *a2, float *a3, __m128 *a4);
    float world_point_to_viewport_point(float *a2, float *a3);
    void viewport_point_to_world_ray(rglVec3 *, rglVec3 *, const rglVec2 *, const float *);
    void relax_orthagonal_camera_with_bounding_box(const rglMatrix_frame *, const rglBounding_box *);
    __m128 get_plane_at_distance(__m128 *a2, float a3);
    float construct_camera_from_position_elevation_bearing(_OWORD *a2);
    void set_direction(const rglVec3 *);
};

class rglData_backup_manager
{
public:
    ~rglData_backup_manager();
    rglData_backup_manager();
    void return_handle(rglData_backup_handle *a2);
};

class rglClothing_material
{
public:
    rglClothing_material(const rglClothing_material *);
    rglClothing_material(_DWORD *a2);
    _DWORD operator=(_DWORD *a2);
    void read(__int64 a2);
    _QWORD write(__int64 a2, __int64 a3);
    rglClothing_material();
};

class rglSkinned_decal_records
{
public:
    rglSkinned_decal_records();
    ~rglSkinned_decal_records();
    rglSkinned_decal_records(const rglSkinned_decal_records *);
    void add_record_with_proximity_check(rglSkinned_decal_buffer *, const rglSkinned_decal_record *);
    void validate(rglSkinned_decal_buffer *a2, unsigned int a3);
};

class rglFlora_kind
{
public:
    __int64 get_variation_count();
    __int64 default_random_size_max(__int64 a2);
    __int64 compute_visibility_mask();
    float get_randomized_wind_effect(rglRandom_generator *);
    bool is_fading_out_flora();
    __int64 get_maximum_bounds(rglVec3 *a2, rglVec3 *a3);
    rglFlora_kind(const rglFlora_kind *);
    __int64 operator=(__int64 a2);
    rglFlora_kind();
    ~rglFlora_kind();
    rglEntity init_flora_entity(__int64 a2, const rglMatrix_frame *a3, unsigned int a4, int a5, int a6);
    void set_flag_with_name(const rglString_base *);
    void read(__int64 a2);
    void read_materials(int a2, __int64 a3);
    void read_variations(int a2, __int64 a3);
    void post_read(__int64 a2);
};

class rglCollision_effects_manager
{
public:
    rglCollision_effects_manager();
    ~rglCollision_effects_manager();
    void clear();
    void init_collision_effects();
    void load_collision_effects(__int64 a2, int a3);
    void get_collision_effect(__int64 a2, __int64 a3, rglCollision_effect_info *a4);
};

class rglEntity
{
public:
    bool is_guid_valid();
    __int64 get_type_id();
    void release_occluder_handle_ownership();
    void set_mobility(int a2);
    void set_enforced_maximum_lod_level(int);
    bool is_global_bounds_dirty();
    __int64 get_occluder_flags();
    void set_object_type(int a2);
    void set_parent_entity(rglEntity *a2);
    void set_name(const rglString_base *);
    void set_name(const char *a2);
    __int64 get_object_id();
    void set_object_id(int);
    __int64 get_object_type();
    float get_lod_bias_factor();
    void set_lod_bias_factor(float);
    float get_view_distance();
    float get_view_distance_squared();
    void set_view_distance(float);
    void set_script_components_active(char a2);
    __int64 get_script_components_active();
    __int64 get_flags();
    __int64 get_flags_to_save();
    void set_flags(int);
    void add_flags(int a2, char a3);
    void remove_flags(int a2, char a3);
    __int64 get_visibility_mask_flags();
    void set_visibility_mask_flags(int);
    void add_visibility_mask_flags_new(int);
    void set_render_called();
    __int64 get_render_called();
    __int64 physics_registered();
    void update_global_frame();
    void update_global_frame_without_parent();
    void set_radius_of_biggest_child_mesh(float);
    float get_global_volume();
    float get_global_volume_xy();
    void validate_global_bounds_cache();
    __int64 cur_frame_changed_externally();
    void reset_frame_changed_externally();
    void set_frame_changed_externally();
    __int64 get_local_scale(float *a2);
    __int64 get_global_scale(float *a2);
    void set_tags(const rglVarString *);
    __int64 get_visibility_exclude_parents();
    bool is_visible_for_render();
    __int64 get_scene_upgrade_level_mask();
    __int64 get_season_mask();
    __int64 get_managed_script_component_count();
    rglEntity(const rglEntity *);
    void `default();
    float get_radius();
    __int64 get_first_mesh();
    bool frame_changed();
    void add_component(rglEntity_component **a2, char a3);
    __int64 get_component_index(int a2);
    void add_mesh(void *a2, char a3);
    void add_meshes(__int64 *a2);
    __int64 get_type_name(__int64 a2);
    rglEntity(int a2);
    ~rglEntity();
    void register_components(rglScene *a2);
    void deregister_components(rglScene *);
    void get_guid(void *a2);
    bool uses_mesh_lod();
    float get_lod_level_for_distance_sq_static(float);
    void get_lod_level_for_distance_sq(float a2);
    __int64 compute_current_lod_quality(const rglVec3 *, rglRender_context *);
    void render(rglRender_context *a2, const rglEntity_render_params *a3);
    void render_into_oro(rglOrol *a2, unsigned int a3);
    void prefetch_for_virtual_texturing(int a2);
    __int64 check_resources(const rglCheck_resource_params *);
    void validate_bounding_box();
    __m128 calculate_simple_bounding_box(rglBounding_box *a2);
    void set_scene_for_replay(rglScene *);
    void attach_child_for_replay(rglEntity *this);
    void detach_child_for_replay(rglEntity *a2);
    void recompute_bounding_box();
    __int64 get_face_count();
    void update_global_bounds();
    bool get_physics_state();
    void set_physics_state(_BOOL8 a2, bool a3);
    void make_physics_body_static(bool);
    void remove_physics();
    void remove_engine_physics();
    bool is_engine_body_sleeping();
    void add_child(rglEntity *a2, char a3, char a4);
    __int64 get_all_children_with_skeleton(__int64 a2);
    void delete_all_children();
    __int64 get_all_meshes(__int64 a2, __int64 a3, unsigned int a4);
    char get_all_meshes(__int64 *a2, __int64 a3, unsigned int a4);
    __int64 get_all_meshes_of_component_type(__int64 a2, int a3, char a4, unsigned int a5);
    char get_all_meshes_with_frames(__int64 a2, __int64 a3, float *a4, int a5);
    void clear_only_own_components();
    void clear_components(bool, bool, bool);
    void deform_to_time(const float *);
    void check_deform_to_time();
    __int64 set_cull_mode(unsigned int a2);
    void set_factor_color(const rglVec3 *);
    void set_factor2_color(const rglVec3 *);
    void set_factor_alpha(float);
    __int64 get_factor_color();
    void set_local_frame(const rglMatrix_frame *);
    void set_local_frame_rot(const rglMat3 *);
    void set_local_position(const rglVec3 *);
    void set_global_frame(const rglMatrix_frame *);
    void set_frame_changed_without_engine_physics_body();
    void set_frame_changed();
    void set_scene(__int64 a2, char a3, __int64 a4, char a5, char a6);
    __m128 get_global_frame_no_cache(__m128 *a2);
    void detach_from_scene(char a2);
    char detach_child_entity(rglEntity *a2, char a3, char a4, bool a5);
    void get_bounding_quad_xz(rglVec3 *);
    void tick_for_parallel_operations(float a2, __int64 a3, char a4);
    void tick(float);
    void update_normals_inverted();
    void on_frame_changed();
    void set_material_for_all_meshes(rglMemory_block_typeless **a2);
    void create_skeleton(const rglSkeleton_model *, rglAnim_tree *);
    void freeze_skeleton_animation(char a2);
    void set_as_contour_entity(const rglVec3 *a2, __int64 a3);
    void set_contour_state(char a2, __int64 a3);
    void disable_contour(__int64 a2, __int64 a3);
    void initialize_with_entity(const rglEntity *a2, char a3, char a4, bool a5);
    void update_physics_desc(const rglPhysics_context_desc *);
    void update_physics_desc(rglPhysics_shape *a2, int a3);
    void update_physics(rglPhysics_engine_body *);
    void set_occlusion_body(rglPhysics_shape *a2, int a3);
    __int64 get_meta_mesh_component_count();
    __int64 get_component_count(int a2);
    void update_visibility_mask();
    void add_visibility_mask_for_components(unsigned __int64 a2);
    void remove_children_with_false_upgrade_level_and_season_mask(int, int);
    void copy_children_from(const rglEntity *a2, char a3, bool a4);
    void copy_components_from(const rglEntity *);
    void break_prefab();
    __int64 get_base_body_flags();
    void detach_light_component();
    void set_override_physics_material(const rglPhysics_material *);
    rglMeta_mesh convert_to_single_meta_mesh(rglMeta_mesh **a2, char a3);
    void on_visibility_updated();
    void set_upgrade_level_mask_from_valid_levels(void *a2, __int64 a3, char a4);
    void add_component_for_replay(rglEntity_component *a2);
    void add_component(rglEntity_component *a2, char a3);
    char check_collision_with_skeleton(const rglCapsule_data *a2, rglVec3 *a3, rglVec3 *a4, signed __int8 *a5);
    __int64 get_current_visibility_mask();
    __int64 size_of();
    bool check_point_with_oriented_bounding_box(const rglVec3 *);
    void set_vector_argument_of_components(const rglVec3 *);
    void remove_from_entity_or_skeleton_or_bones_if_exist(rglEntity_component *a2);
    char remove_component(rglEntity_component *a2);
    bool has_component(rglEntity_component *);
    char has_prefab_connection_in_hierarchy();
    void set_visible(char a2);
    void set_ready_to_render(char a2);
    void apply_flags_to_components(int);
    void apply_flags_to_skeleton(int);
    void handle_debug_render(rglRender_context *);
    void update_physics_body_flags(int a2);
    void update_physics_desc_flags(int a2);
    void update_physics_desc_shape(rglPhysics_shape **a2);
    void update_physics_desc_mass(float);
    void update_physics_desc_center_of_mass(const rglVec3 *);
    void set_skeleton(rglSkeleton *);
    void set_boundingbox_dirty_flag();
    void set_global_bounds_dirty_flag_only_itself();
    void set_global_bounds_dirty_flag();
    void recompute_components_bounding_box();
    __int64 get_game_entity_id(__int64 a2);
    __int64 remove_component_with_mesh(rglMesh *a2);
    char has_tag(const rglVarString *a2);
    char has_tag_expression(const rglVarString *a2);
    void copy_managed_variables_from(const rglEntity *a2, char a3);
    void create_script_components_from_prefab(const rglEntity *a2, char a3, char a4);
    void resume_particle_system(bool);
    void pause_particle_system(bool);
    void burst_entity_particle(bool);
    char check_prefab_pointer_correctness();
    void reload_script_variables_recursively(__int64 a2);
    char is_prefab_manager_entity();
    void set_prefab_ptr(const rglEntity *);
    void update_prefab_pointers_after_entity_duplication(const rglEntity *);
    void copy_skeleton_from(const rglSkeleton *);
    void force_update_skeleton_according_to_distance(const rglMatrix_frame *a2, char a3, float a4);
    void add_script_component(rglScript_component **a2);
    void remove_script_component(rglScript_component **a2);
    void unload_script_components();
    void clear_script_components(char a2);
    void clear_gpu_resources();
    void init_script_components();
    void tick_script_components(float);
    void validate_script_components();
    char has_script_component(const rglString_base *a2);
    bool has_any_script_component();
    char has_any_script_component_that_moves_entity();
    __int64 set_body_flags(unsigned int a2);
    char apply_terrain_alignment();
    void set_occluder_flags(unsigned int);
    void preinit_script_components();
    void add_tag(const rglString_base *);
    __int64 remove_tag(const rglString_base *a2, __int64 a3);
    void expand_boundingbox_with_point(const rglVec3 *);
    void invalidate_cpu_render_buffers(__int64 a2, __int64 a3);
    __int64 get_tags_splitted(_QWORD);
    __int64 get_script_components();
    __int64 get_script_components_recursive(__int64 a2);
    void initialize_guid_of_all_children_with(const rglEntity *);
    __int64 get_entity_with_guid_in_hierarchy(_QWORD);
    void fix_entity_references_of_scripts();
    __int64 get_polygon_count(int);
    __int64 get_lod_count();
    __int64 get_all_components(_QWORD);
    char is_ancestor_of(rglEntity *a2);
    void set_scene_upgrade_level_mask(int);
    void display_mesh_face_normals(rglRender_context *);
    void display_mesh_vertex_normals(rglRender_context *);
    bool is_bounding_box_dirty();
    void change_component(rglEntity_component *, rglEntity_component *);
    void remove_editor_only_components();
    __int64 create_body_from_render_mesh(__int64 a2);
    char is_dynamic_or_game_object();
    void set_as_should_not_be_oroed();
    void update_runtime_parent_visibility_of_entity_tree();
    void update_runtime_parent_visibility_imp(char a2);
    void set_season_mask(int a2);
    void register_script_components_to_undo_stack();
    void deregister_script_components_from_undo_stack();
    bool check_upgrade_level_visibility(int);
    bool should_be_oroed();
    void add_engine_physics();
    void set_local_frame_and_apply_scale_to_local_frame_rot(const rglMatrix_frame *, float);
    void attach_to_navigation_mesh_faces(int a2, char a3, char a4, bool a5);
    void set_animation_sound_activation(char a2);
    void auto_center_physics_desc_center_of_mass();
    void play_animation_sound(__int64 a2);
    void set_previous_frame_invalid();
    void visibility_mask_flags_changed();
    void set_component_factor_color_usage(char a2);
    __int64 get_component_factor_color_usage();
    void set_component_factor_color(const rglVec3 *);
    _OWORD get_component_factor_color(_OWORD *a2);
    void on_managed_script_component_deleted(rglManaged_script_component *a2);
    rglBounding_box get_physics_bounding_box(rglBounding_box *a2, char a3, char a4);
    void clear_only_own_components();
    void clear_components(bool, bool, bool);
    void update_visibility_mask();
    void set_previous_frame_invalid();
    bool remove_component(rglEntity_component *);
    void update_global_bounds();
    bool remove_component_with_mesh(rglMesh *);
    void set_physics_state(bool, bool);
    void remove_engine_physics();
};

class rglPhysics_resource_description
{
public:
    void transform(const rglMatrix_frame *);
    void override_phyiscs_materials(const rglPhysics_material *);
    rglPhysics_resource_description();
    ~rglPhysics_resource_description();
    rglPhysics_resource_description(const rglPhysics_resource_description *);
    rglPhysics_resource_description(_DWORD *a2);
    _DWORD operator=(_DWORD *a2);
    __int64 operator=(_DWORD *a2);
    void recompute_bounding_box();
    void read_from_trf(rglBuffer *);
    void read_head_from_crf(rglBuffer *);
    void read_data_from_crf(rglBuffer *);
    void read_cooked_static(rglBuffer *);
    void read_cooked_dynamic(rglBuffer *);
    void delete_cooked_static();
    void delete_cooked_dynamic();
    void write_head_to_crf(rglBuffer *);
    void write_data_to_crf(rglBuffer *);
    void cook_static_into_stream(struct physx::PxDefaultMemoryOutputStream *);
    void cook_static_and_write_to_crf(rglBuffer *);
    __int64 cook_dynamic_into_stream(struct physx::PxDefaultMemoryOutputStream *a2);
    void cook_dynamic_and_write_to_crf(rglBuffer *a2, __int64 a3);
};

class rglObserver
{
public:
    void register_observable(rglObservable *);
    void operator=(void **a2);
    ~rglObserver();
};

class rglObservable
{
public:
    void register_observer(rglObserver *);
    void unregister_observer(rglObserver *);
};

class rglAtmosphere
{
public:
    float get_sun_size();
    __int64 get_use_env_map();
    float get_winter_time_factor();
    float get_lens_flare_aberration_offset();
    float get_sunshafts_strength();
    void reset();
    __int64 get_module_path_identifier();
    float get_time_of_day();
    float get_skybox_rotation();
    float get_sun_altitude();
    float get_sun_angle();
    float get_sun_rotation();
    float get_sun_intensity();
    float get_sky_brightness();
    float get_shadow_opacity();
    float get_cloud_brightness();
    float get_fog_density();
    float get_fog_falloff();
    float get_cloud_amount();
    float get_temperature();
    float get_snow_density();
    float get_global_envmap_multiplier();
    _OWORD get_global_envmap_color_factor(_OWORD *a2);
    float get_prt_multiplier();
    float get_rayleigh_constant();
    float get_mie_scatter_particle_size();
    float get_fog_scatter();
    float get_scatter_strength();
    float get_middle_gray();
    float get_min_exposure();
    float get_max_exposure();
    float get_target_exposure();
    float get_bloom_strength();
    float get_bloom_amount();
    float get_lens_flare_amount();
    float get_lens_flare_threshold();
    float get_lens_flare_strength();
    float get_lens_flare_dirt_weight();
    float get_lens_flare_diffraction_weight();
    float get_lens_flare_halo_weight();
    float get_lens_flare_ghost_weight();
    float get_lens_flare_halo_width();
    __int64 get_lens_flare_ghost_samples();
    float get_lens_flare_blur_sigma();
    float get_streak_amount();
    float get_streak_threshold();
    float get_streak_strength();
    float get_streak_stretch();
    float get_streak_intensity();
    float get_vignette_inner_radius();
    float get_vignette_outer_radius();
    float get_vignette_opacity();
    float get_aberration_offset();
    float get_aberration_size();
    float get_aberration_smooth();
    float get_lens_distortion();
    float get_grain_amount();
    float get_burnout_threshold();
    float get_contrast_enhancement();
    float get_skybox_distance();
    float get_scene_scale();
    float get_skybox_height();
    float get_horizon_distance();
    float get_fog_falloff_offset();
    float get_fog_falloff_minfog();
    float get_fog_start_distance();
    __int64 is_indoor_();
    __int64 is_do_not_render_envmap();
    __int64 is_forced_snow();
    float get_anti_banding_noise_amount();
    __int64 get_skybox_type();
    float get_cloud_shadow_amount();
    float get_cloud_shadow_contrast();
    float get_cloud_shadow_begin_height();
    float get_cloud_shadow_end_height();
    float get_cloud_shadow_scale();
    float get_cloud_shadow_speed();
    float get_cloud_shadow_range_inv();
    void set_season(int a2);
    __int64 get_season();
    __int64 get_season_mask();
    void set_cloud_shadow_amount(float);
    void set_cloud_shadow_contrast(float);
    void set_cloud_shadow_begin_height(float);
    void set_cloud_shadow_end_height(float);
    void set_cloud_shadow_scale(float);
    void set_cloud_shadow_speed(float);
    void set_name(const rglVarString *);
    void set_module_path_identifier(int);
    void set_winter_time_factor(float);
    void set_dryness_factor(float);
    void set_time_of_day(float);
    void set_flags(int);
    void set_skybox_rotation(float);
    void set_sun_altitude(float);
    void set_sun_angle(float);
    void set_shadow_opacity(float);
    void set_sun_rotation(float);
    void set_sun_intensity(float);
    void set_sun_color(const rglVec3 *);
    void set_sky_brightness(float);
    void set_forced_snow(char a2);
    void set_cloud_brightness(float);
    void set_sun_size(float);
    void set_ambient_color(const rglVec3 *);
    void set_contrast_enhancement(float);
    void set_burnout_threshold(float);
    void set_ambient_color_no_version_update(const rglVec3 *);
    void set_fog_ambient_color(const rglVec3 *);
    void set_global_envmap_color_factor(__int128 *a2);
    void set_fog_color(const rglVec3 *);
    void set_cloud_shadow_color(const rglVec3 *);
    void set_fog_density(float);
    void set_skybox_type(int a2);
    void set_fog_falloff(float);
    void set_cloud_amount(float);
    void set_temperature(float);
    void set_humidity(float);
    void set_fall_density(float);
    void set_snow_density(float);
    void set_color_grade_name(const rglVarString *);
    void set_color_grade_texture(rglMemory_block_typeless **a2);
    void set_color_grade_blend_name(const rglVarString *);
    void set_color_grade_blend_texture(rglMemory_block_typeless **a2);
    void set_color_grade_blend_alpha(float);
    void set_global_envmap_multiplier(float);
    void set_prt_multiplier(float);
    void set_env_cube_map(rglMemory_block_typeless **a2);
    void set_pre_env_cube_map(rglMemory_block_typeless **a2);
    void set_env_map_name(const rglVarString *);
    void set_lens_flare_star_texture_name(const rglVarString *);
    void set_lens_flare_dirt_texture_name(const rglVarString *);
    void set_skybox_background_texture_name(const rglVarString *);
    void set_skybox_cloud_texture_name(const rglVarString *);
    void set_skybox_cloud_normal_texture_name(const rglVarString *);
    void set_skybox_sun_texture_name(const rglVarString *);
    void set_skybox_background_texture(rglMemory_block_typeless **a2);
    void set_skybox_cloud_texture(rglMemory_block_typeless **a2);
    void set_skybox_cloud_normal_texture(rglMemory_block_typeless **a2);
    void set_skybox_sun_texture(rglMemory_block_typeless **a2);
    void set_rayleigh_constant(float);
    void set_mie_scatter_particle_size(float);
    void set_fog_scatter(float);
    void set_scatter_strength(float);
    void set_middle_gray(float);
    void set_sunshafts_strength(float);
    void set_brightpass_threshold(float);
    void set_min_exposure(float);
    void set_max_exposure(float);
    void set_target_exposure(float);
    void set_bloom_strength(float);
    void set_bloom_amount(float);
    void set_lens_flare_star_texture(rglMemory_block_typeless **a2);
    void set_lens_flare_dirt_texture(rglMemory_block_typeless **a2);
    void set_lens_flare_amount(float);
    void set_lens_flare_threshold(float);
    void set_lens_flare_strength(float);
    void set_lens_flare_dirt_weight(float);
    void set_lens_flare_diffraction_weight(float);
    void set_lens_flare_halo_weight(float);
    void set_lens_flare_ghost_weight(float);
    void set_lens_flare_halo_width(float);
    void set_lens_flare_ghost_samples(int);
    void set_lens_flare_aberration_offset(float);
    void set_lens_flare_blur_size(int);
    void set_lens_flare_blur_sigma(float);
    void set_streak_amount(float);
    void set_streak_threshold(float);
    void set_streak_strength(float);
    void set_streak_stretch(float);
    void set_streak_intensity(float);
    void set_streak_tint(const rglVec3 *);
    void set_vignette_inner_radius(float);
    void set_vignette_outer_radius(float);
    void set_vignette_opacity(float);
    void set_aberration_offset(float);
    void set_aberration_size(float);
    void set_aberration_smooth(float);
    void set_lens_distortion(float);
    void set_grain_amount(float);
    void set_anti_banding_noise_amount(float);
    void set_skybox_distance(float);
    void set_scene_scale(float);
    void set_skybox_height(float);
    void set_horizon_distance(float);
    void set_fog_falloff_offset(float);
    void set_fog_falloff_minfog(float);
    void set_fog_start_distance(float);
    void set_indoor(char a2);
    void set_do_not_render_envmap(char a2);
    void set_use_env_map(char a2);
    void set_dirty_status();
    __int64 get_version();
    void set_version(int a2);
    rglAtmosphere(const rglAtmosphere *);
    __int64 operator=(__int64 a2);
    rglAtmosphere();
    ~rglAtmosphere();
    void read(__int64 a2);
    float get_sun_dir(__int64 a2, float a3);
    __int64 read_ambient_values(__int64 a2);
    void read_fog_values(__int64 a2);
    void read_cloud_shadow_values(__int64 a2);
    __int64 read_sun_values(__int64 a2);
    void read_postfx_values(__int64 a2);
    __int64 get_sunlight_for_view_angle(__int64 a2, float a3, float a4, _OWORD *a5);
    void get_season_string();
    __int64 get_season_enum();
    void calculate_effective_lights(__int64 a2);
    void calculate_uniform_ambient_from_cubemap(rglTexture *);
    __int64 get_validity_flags();
    void add_validity_flags(int a2);
    void remove_validity_flags(int a2);
    bool has_validity_flag(int a2);
    void initialize_with(const rglAtmosphere *);
    void flash_lightning(float);
    void restore_lightning();
};

class rglBone_model
{
public:
    void set_ragdoll_body(const rglBone_body *);
    bool has_ragdoll_body();
    void set_collision_body(const rglBone_body *);
    bool has_collision_body();
    void set_collision_max_body(const rglBone_body *);
    _OWORD get_local_rest_transform(_OWORD *a2);
    _OWORD get_entitial_rest_transform(_OWORD *a2);
    __int64 add_joint_index(char a2, int a3);
    __int64 get_joint_index(char a2);
    __int64 get_body_part_type();
    void set_body_part_type(char a2);
    errno_t set_bone_name(rglString_base *a2);
    float get_bone_mass();
    void set_bone_mass(float);
    __int64 get_parent_bone_index();
    void set_parent_bone_index(char a2);
    __int64 get_child_bone_index(char a2);
    __int64 get_num_children();
    char get_bone_body_part_type_enum_from_name();
    ~rglBone_model();
    rglBone_model();
    void reset();
    void write_data(rglBuffer *);
    void read_data(rglBuffer *);
    void read(rglBuffer *);
    __int64 size_of();
    void fix_children_and_parent_related_data();
    void set_local_rest_frame(const rglMatrix_frame *);
    void set_entitial_rest_frame(const rglMatrix_frame *);
};

class rglSkeleton_model
{
public:
    __int64 get_num_bones();
    void set_bone_initial_data(char a2, const rglBone_model *a3);
    __int64 size_of();
    __int64 get_num_joints();
    float get_boundingbox_padding();
    __int64 get_bone_mapping_for(char a2);
    __int64 get_type();
    rglSkeleton_model();
    ~rglSkeleton_model();
    void copy_to(rglSkeleton_model *);
    void create_bones(char a2);
    void update(const rglResource *this);
    void write(rglIO_Stream *);
    void read(rglBuffer *a2);
    void update(rglBuffer *a2, unsigned int a3);
    __int64 write_head(rglBuffer *, unsigned int *);
    __int64 write_data(rglBuffer *a2);
    void read_head(rglCrf_file *, rglBuffer *);
    void read_data();
    void fix_local_rest_frames();
    void fix_children_and_parent_related_data();
    void set_default_bounding_box_via_rest_bones();
    _QWORD write_bone(unsigned int a2, __int64 a3, __int64 a4);
    char get_bone_type_from_type_name(rglString_base *a2);
    void fix_joint_bone_indices();
    void auto_generate_joints();
    void auto_generate_physics_data();
    __int64 get_hierarchy_level_of_bone(char a2);
    float get_hierarchical_total_length_of_bone(char a2);
    double calculate_bone_anim_optimization_coef(char a2);
    __m128i apply_joint_limits_on_rotation(__m128i *a2, char a3, int a4, __m128 *a5, float a6);
    float get_object_bone_transform_in_anim(__int64 a2, __int64 a3, char a4, float a5, char a6);
    float get_object_bone_frame_in_anim_data(__int64 a2, __int64 a3, char a4, int a5);
};

class rglPhysics_engine_body
{
public:
    rglPhysics_engine_body();
    ~rglPhysics_engine_body();
    void add_flags(int);
    void set_entity(const rglEntity *);
    rglPhysics_engine_body(const rglPhysics_engine_body *);
};

class rglPhysics_filter_callback
{
public:
    rglPhysics_filter_callback();
    rglPhysics_filter_callback(int a2, int a3);
    rglPhysics_filter_callback(const rglPhysics_filter_callback *);
    __int64 operator=(__int64 a2);
    bool pre_filter_function(__int64 a2);
};

class rglPhysics_engine_world
{
public:
    rglPhysics_engine_world();
    ~rglPhysics_engine_world();
    __int64 get_num_ragdolls();
    void set_body_removal_callback(__int64 a2);
    rglPhysics_engine_world(const rglPhysics_engine_world *);
    __int64 operator=(__int64 a2);
    void render_statistics();
    _QWORD create_body_for_physics_desc(_QWORD *a2, volatile signed __int32 **a3, __int64 a4, __int64 a5);
};

class rglEntity_component
{
public:
    __int64 get_type_id();
    __int64 get_type_name(__int64 a2);
    rglEntity_component();
    rglEntity_component(rglEntity_component *);
    ~rglEntity_component();
    void set_entity_bounding_box_dirty();
    rglRagdoll_bone create_component_with_type_string(rglString_base *a2);
    void register_component_to_system(rglScene *);
    void deregister_component_to_system(rglScene *);
};

class rglReplay_mesh_data_new
{
public:
    rglReplay_mesh_data_new(const rglReplay_mesh_data_new *);
    __int64 operator=(__int64 a2);
};

class rglLoading_time_profiler
{
public:
    _OWORD operator=(_OWORD *a2);
    rglLoading_time_profiler();
    ~rglLoading_time_profiler();
    void end();
};

class rglPerformance_reporter
{
public:
    rglPerformance_reporter(const rglPerformance_reporter *);
    _BYTE operator=(_BYTE *a2);
    rglPerformance_reporter();
    ~rglPerformance_reporter();
    void add_generic_performance_object(const rglVarString *, const double *);
    __int64 add_new_performance_holder(const rglVarString *);
    __int64 fetch_performance_holder_index(const rglVarString *);
    __int64 get_scene_name_index(const rglVarString *);
    void start_report(void *a2);
    void tick();
    __int64 check_report_state_and_reset();
    void add_scene_renderer_fps_report(const rglVarString *, double);
    void add_scene_main_fps_report(const rglVarString *, double);
    void add_scene_memory_usage_report(const rglVarString *, int);
    void add_scene_video_memory_usage_report(const rglVarString *, int);
    void add_scene_object_report(const rglVarString *, const rglVarString *, double);
    void add_scene_load_report(const rglVarString *, double);
    void add_scene_exit_report(const rglVarString *, double);
    void init_timer(int a2);
    double end_timer(int a2);
    void finalize_report();
};

class rglRender_context
{
public:
    __int64 get_name();
    void attach_oro_list(rglOrol *);
    void set_render_params(const rglRender_params *);
    __int64 get_gbuffer_rt_count();
    void set_render_type_flags(int a2);
    __int64 get_render_type_flags();
    void set_env_map(rglTexture *);
    void set_ggxbrdf_texture(rglTexture *);
    bool require_sorting_visuals();
    float get_time_var();
    void set_time_var(float);
    __int64 get_default_depth_compare_function();
    void set_wireframe_mode(char a2);
    void set_name(const char *a2);
    void set_name(const rglString_base *);
    void set_gbuffer_normal_xy(rglTexture *);
    void set_gbuffer_spec_gloss_ao_shadow(rglTexture *);
    void set_gbuffer_motion_vectors_texture(rglTexture *);
    void set_gbuffer_vt_resolve_texture(rglTexture *);
    void set_additional_render_target_texture(rglTexture *a2);
    void set_render_target_texture(rglTexture *);
    void set_half_res_render_target_texture(rglTexture *);
    void set_water_reflection_texture(rglTexture *);
    void set_water_reflection_depth_texture(rglTexture *);
    void set_depth_stencil_surface(rglTexture *);
    void set_render_target_texture_face(int);
    __int64 get_render_target_texture_face();
    void set_depth_target_texture_face(int);
    __int64 get_depth_target_texture_face();
    void reset_render_targets(char a2);
    void prepare_for_rendering();
    rglRender_context(const rglRender_context *);
    rglRender_context();
    ~rglRender_context();
    void set_camera(const rglCamera *);
    void clear_temporary_buffers();
    void reset_rc();
    void handle_blended_envmap();
    void handle_blended_envmap_face(rglTexture *, rglTexture *, rglTexture *, int, int);
    void print_rendered_meshes_info();
    void add_child(rglRender_context *);
    void remove_child(rglRender_context *);
    char add_mesh(const rglMesh *a2, const rglMatrix_frame *a3, rglScene *a4, const rglEntity_render_params *a5);
    void add_shaded_wireframe_mesh(rglRender_context *a2, const rglMesh *a3, const rglMatrix_frame *a4, const rglEntity_render_params *a5);
    void set_ambient_color(_OWORD *a2);
    void set_effective_ambient_color(_OWORD *a2);
    void set_wind_power(__int64 a2);
    void set_as_active_render_context(char a2, char a3);
    void update_camera_matrix_cache();
    bool is_depth_flipping_enabled();
    float fall_density();
    void set_screen_rt(rglTexture *);
    void handle_rc_shader_enforcement_flags(char a2);
    __int64 get_gpu_profile_name(__int64 a2);
    int get_mesh_and_rc_dependent_system_flags(const rglMesh *a2);
    int get_non_mesh_dependent_system_flags();
    __int64 get_all_system_flags(const rglMesh *a2, const rglMesh_render_record *a3);
    bool have_sun_shadows();
    void init_local_config_params();
    bool environment_map_blending_required();
    void set_inherited_params_from(const rglRender_context *);
};

class rglGPU_device
{
public:
    __int64 get_display_buffer_count();
    void set_debug_last_rendered_mesh_name(const char *a2);
    ~rglGPU_device();
    rglGPU_device(const rglGPU_device *);
    rglGPU_device(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglGPU_device();
    void create_fs_quad_buffer();
    void create_shader_buffers();
    void set_window_size(int a2, int a3);
    void initialize_resources();
    void delete_resources();
    __int64 get_current_width();
    __int64 get_current_height();
    __int64 get_fullscreen_status();
    __int64 get_vertex_input_desc(unsigned __int16 a2);
    void build_input_layout_attribute_type_maps();
    __int64 get_shader_macros(_DWORD, _DWORD, _DWORD, _DWORD, _DWORD, __int64);
    __int64 rgl_string_to_surface_format();
    __int64 rgl_surface_format_size();
    double rgl_sampler_mipmap_bias_to_bias();
    __int64 get_rgl_format_from_vbds();
    bool is_rgl_surface_single_channel();
    __int64 save_texture_to_file(const rglString_base *a2, int a3, __int64 a4);
    _BOOL8 save_texture_to_file_in_memory(void *a2, rglTexture_object *a3);
};

class rglGraphics_command_list
{
public:
    __int64 get_cur_render_target(int a2);
    rglGraphics_command_list(const rglGraphics_command_list *);
    __int64 operator=(__int64 a2);
    rglGraphics_command_list();
    ~rglGraphics_command_list();
    void set_render_target(int a2, _QWORD *a3);
    void set_depth_target(void **a2, int a3);
    void reset_render_states();
    void reset_constant_buffers();
    void reset_render_target_cache();
    void set_gamma(const float *);
    void set_sharpen_amount(const float *);
    void set_brightness(const float *);
    void update_gpu_buffer(rglGPU_buffer *, unsigned int, rglMemory_block_typeless *, unsigned int);
    void update_gpu_buffer_dynamic(rglGPU_buffer *, rglMemory_block_typeless *);
};

class rglGraphics_command_list_d3d11
{
public:
    void set_d3d_device_context(struct ID3D11DeviceContext *);
    rglGraphics_command_list_d3d11(const rglGraphics_command_list_d3d11 *);
    __int64 operator=(__int64 a2);
    rglGraphics_command_list_d3d11();
    ~rglGraphics_command_list_d3d11();
    void clear(char a2, unsigned int a3, __int64 a4, __int64 a5, unsigned int a6);
    void clear_unordered_access_view_as_uint(rglUnordered_access *, const unsigned int *const);
    void reset_gpu_state();
    void reset_active_texture_handles();
    void reset_shader_bindings();
    rglGPU_device set_sampler(int a2, unsigned int a3, char a4);
    void set_pipeline_state(const rglPipeline_state *);
    void set_compute_pipeline_state(const rglCompute_pipeline_state *);
    __int64 set_primitive_type(int a2);
    void set_active_viewports(rglViewport *a2, unsigned int a3);
    void set_scissor_rect(rglRect *);
    void set_texture(int a2, rglTexture *a3, int a4, int a5, int a6);
    void get_binded_texture_name_list(rglVarString *);
    void get_binded_render_target_name_list(rglVarString *);
    __int64 set_unordered_access_view(__int64 a2, char a3, __int64 a4, int a5);
    __int64 set_unordered_access_view(__int64 a2, char a3, __int64 a4);
    void set_indices(const rglIndex_buffer_object *);
    void set_buffer(__int64 a2, __int64 a3, char a4);
    void set_vertex_buffer(__int16 a2, __int64 a3);
    void set_vertex_buffer_direct(rglVertex_buffer_object *);
    __int64 set_constant_buffer(__int64 a2, char a3, __int64 a4);
    void dispatch();
    void commit_render_targets(unsigned int a2);
    void draw_primitive();
    void draw_indexed_primitive(unsigned int a2, int a3);
    void draw_instanced_primitive(__int64 a2, __int64 a3);
    void draw_indexed_instanced_primitive(unsigned int a2, int a3, unsigned int a4);
    void draw_instanced_indirect(rglGPU_buffer_object *a2);
    void draw_fullscreen_quad();
    bool lock_texture(rglTexture *, int, int, void **, int *, unsigned int);
    void unlock_texture(rglTexture *, int, int);
    bool lock_buffer(rglGPU_buffer *a2, void **a3, int a4);
    void unlock_buffer(rglGPU_buffer *);
    void copy_rt_data(rglTexture *, rglTexture *);
    void copy_texture(rglTexture *a2, int a3, int a4, __int64 a5, rglTexture *a6, __int64 a7, __int64 a8, int a9);
    void copy_buffer(rglGPU_buffer *, rglGPU_buffer *);
    void copy_buffer_region(rglGPU_buffer *a2, rglGPU_buffer *a3, int a4, unsigned int a5, unsigned int a6);
    void update_texture(rglTexture *a2, int a3, int a4, int a5, rglMemory_block_typeless *a6);
    void update_texture_with_staging(rglTexture *, __int64, __int64, rglMemory_block_typeless *);
    void update_dynamic_texture(rglTexture *a2, int a3, int a4, int a5, rglMemory_block_typeless *a6);
    void update_gpu_buffer_imp(rglGPU_buffer_object *a2, int a3, void *a4, unsigned int a5);
    void update_gpu_buffer_dynamic_imp(rglGPU_buffer_object *a2, const void *a3, int a4);
    bool get_contents_of_texture(rglTexture *, int, int, void **, unsigned int *);
    void generate_mip_levels(rglTexture *);
    void start_occlusion_query(rglOcclusion_query_object *);
    void end_occlusion_query(rglOcclusion_query_object *);
    __int64 get_occlusion_data(rglOcclusion_query_object *a2);
    void update_stats_with_gpu_profile_data(rglGPU_profile_data *);
    void set_active_effect(rglEffect *a2, char a3, char a4);
    void update_per_draw_params(const rglShader_constants::rgl_shader_constant_per_draw *a2);
    void update_framef_params();
    void update_vt_tileset_params();
    void update_terrainf_params();
    void update_dynamic_single_pass_params();
    void update_custom_params();
    void update_postfx_params();
    void update_bone_frames(const float *a2, int a3);
    void update_instance_buffer(unsigned int a2, unsigned int a3);
    void update_flora_buffer(rglMatrix_frame *a2, int a3);
    void update_clip_planes();
    __int64 update_and_set_constant_buffer(unsigned int a2, rglGPU_buffer *a3, char a4, void *a5, unsigned int a6);
    void set_shader_resource_view(__int64 a2, struct ID3D11ShaderResourceView *a3, char a4);
    void update_constant_buffer(rglGPU_buffer *a2, const void *a3, unsigned int a4);
    rglGPU_device set_input_layout(unsigned __int16 a2);
    void set_rasterizer_state(const rglRasterizer_state *);
    void set_depth_stencil_state(const rglDepth_stencil_state *);
    rglGPU_device set_alpha_blend_mode(int a2);
};

class rglAnim_bone_relative_position_result
{
public:
    rglAnim_bone_relative_position_result();
    void set_bone_to_sample(char a2);
    void set_relative_bone_to_sample(char a2);
    __int64 get_bone_to_sample();
    __int64 get_relative_bone_to_sample();
    void set_bone_entitial_frame(char a2, const rglTransform *a3);
    _OWORD operator=(_OWORD *a2);
    __int64 operator=(__int64 a2);
    void flush_animation(float);
};

class rglSkeleton
{
public:
    __int64 has_child_skeleton();
    __int64 get_type_id();
    void reset_dependency(float);
    bool get_up_to_date();
    void set_up_to_date(char a2);
    bool get_update_every_frame();
    void set_update_every_frame(char a2);
    bool get_use_precise_bounding_volume();
    bool get_frozen();
    void set_frozen(char a2);
    bool get_do_not_deform_components();
    void set_do_not_deform_components(char a2);
    bool get_is_grouped_mesh_active();
    void set_is_grouped_mesh_active(char a2);
    bool get_is_grouped_mesh_dirty();
    void set_is_grouped_mesh_dirty(char a2);
    __int64 get_grouped_lod_mesh_updated_before_frozen();
    void set_grouped_lod_mesh_updated_before_frozen(char a2);
    void set_skeleton_scale(rglSkeleton_scale *);
    __int64 get_skinning_matrices_buffer_index();
    __int64 get_prev_global_bone_buffer_offset();
    void get_override_bounding_box_local_to_bone_zero(rglVec3 *, rglVec3 *);
    void set_override_bounding_box_local_to_bone_zero(const rglVec3 *, const rglVec3 *);
    __int64 get_ragdoll_state();
    bool is_ragdoll_in_active_state();
    bool is_ragdolls_first_tick();
    void set_ragdoll_activation_params(const rglVec3 *, const rglVec3 *);
    void set_has_child_skeleton(char a2);
    void register_bone_needs_tick(char a2);
    void deregister_bone_needs_tick(unsigned __int8 a2);
    void reset_accumulated_update_time();
    void set_max_time_since_last_update(float);
    bool max_time_since_last_update_exceed();
    rglSkeleton(const rglSkeleton *);
    __int64 get_type_name(__int64 a2);
    void reset_cloths();
    void create_from_model(const rglSkeleton_model *, rglAnim_tree *);
    void render(rglRender_context *, const rglEntity_render_params *);
    void tick_states();
    void tick(float a2, const rglMatrix_frame *a3, __int64 a4);
    void simple_tick(float a2, const rglMatrix_frame *a3, __int64 a4);
    __m128 get_object_bone_transform_in_anims_blended(__int64 a2, int a3, __int64 a4, char a5, __int64 a6, __int64 a7);
    void setup_frames(const rglMatrix_frame *, float);
    void construct();
    __int64 try_to_reserve_skinning_matrices();
    void fill_skinning_matrices_from_prev_frame_if_not_filled_before();
    void assign_skeleton_scale(const rglSkeleton_scale *);
    rglSkeleton();
    rglSkeleton(const rglSkeleton_model *, rglAnim_tree *);
    ~rglSkeleton();
    char is_ragdoll_stationary();
    __int64 set_cull_mode(unsigned int a2);
    void set_factor_color(const rglVec3 *);
    void set_factor_alpha(const float *);
    void freeze(const rglMatrix_frame *a2, char a3);
    void freeze_without_setup_frames();
    void reset_frames();
    void update_entitial_frames_from_local_frames();
    void set_normals_inverted(unsigned __int8 a2);
    void add_component_to_bone(char a2, rglEntity_component *a3);
    void add_component_to_bone(char a2, rglEntity_component *a3, const rglMatrix_frame *a4);
    void reloc_component_to_bone(char a2, rglEntity_component *a3, const rglMatrix_frame *a4);
    void apply_flags_to_components(unsigned int);
    void add_light_to_bone(char a2, rglLight *a3);
    char is_component_attached_to_bone(char a2, const rglEntity_component *a3);
    void add_component(rglEntity_component *a2);
    void add_component(rglEntity_component **a2);
    char remove_mesh_component(rglMesh *a2);
    char remove_mesh_component_from_bone(rglMesh *a2, char a3);
    void clear_components();
    void clear_gpu_resources();
    void break_owner_entity_prefab();
    void remove_ragdoll(char a2);
    bool has_component(rglEntity_component *);
    void remove_component(rglEntity_component *);
    void remove_component(rglEntity_component **a2);
    void register_components(rglScene *a2);
    void deregister_components(rglScene *);
    void remove_component_without_delete(rglEntity_component *a2, char a3);
    void set_material_for_all_meshes(rglMemory_block_typeless **a2);
    void setup_frames_ragdoll(const rglMatrix_frame *);
    void compute_bone_velocities(rglVec3 *, rglVec3 *);
    void set_owner_entity(const rglEntity *);
    __int64 get_all_meshes(__int64 a2, unsigned int a3);
    void get_all_components(rglEntity_component **const, int *);
    void setup_ragdoll();
    void end_ragdoll(char a2);
    void get_current_precise_boundingbox(rglBounding_box *);
    void set_as_contour_entity(const rglVec3 *a2);
    void set_contour_state(bool);
    void set_ragdoll_state(__int16 a2);
    void pre_compute_bone_frame(char a2);
    void check_ragdoll_state();
    void set_ragdoll_needs_activation(const rglVec3 *, const rglVec3 *);
    void force_update_according_to_distance(const rglMatrix_frame *a2, const rglMatrix_frame *a3, char a4, float a5);
    bool needs_update(const rglMatrix_frame *a2, const rglMatrix_frame *a3, char a4, float a5);
    void force_update();
    void disable_contour();
    char write(__int64 a2, __int64 a3, __int64 a4, rglString_base *a5);
    char write_components(__int64 a2, __int64 a3, __int64 a4, rglString_base *a5);
    char write_bones(__int64 a2, __int64 a3, __int64 a4, rglString_base *a5);
    void read(__int64 a2, rglString_base *a3);
    __int64 read_components();
    void read_bones(__int64 a2, rglString_base *a3);
    void set_scale_for_bone(char a2, const rglVec3 *a3);
    void reset_scale_for_bones();
    void create_bones(signed __int8);
    void destruct_bones();
    __int64 get_all_meshes_with_frames(__int64 a2, __int64 a3, int a4);
    void handle_debug_render_of_bone(char a2, rglRender_context *a3, const rglMatrix_frame *a4, const rglBone_debug_render_desc *a5);
    void remove_component_from_bone(char a2, rglEntity_component *a3);
    void remove_component_from_bone(rglEntity_component *);
    float compute_update_period(const rglVec3 *a2, char a3, float a4);
    void update_accumulated_update_time(float);
    void read_binary(rglBuffer *);
    void write_binary(rglBuffer *a2);
    void init_bone_map_of_anim_tree();
    void check_and_force_update();
    void set_parent_skeleton(rglSkeleton *);
    __int64 get_component_count(int a2);
    __int64 crossfade_skeleton_animation(__int64 a2, __int64 a3, int a4, int a5, int a6, char a7, int a8);
    void set_use_precise_bounding_volume(char a2);
    void clear_meshes(bool);
    void reset_cloths();
    void reset_frames();
    void clear_components();
    void update_entitial_frames_from_local_frames();
};

class rglAnim_bone_entitial_frame_result
{
public:
    rglAnim_bone_entitial_frame_result();
    void set_sample_flags(int);
    void set_bone0_to_sample(int);
    void set_bone1_to_sample(int);
    __int64 get_bone0_to_sample(int);
    __int64 get_bone1_to_sample(int);
    _OWORD operator=(_OWORD *a2);
    __int64 operator=(__int64 a2);
    void set_bone_entitial_transform(int, const rglTransform *, float);
};

class rglAnim_result
{
public:
    rglAnim_result();
    __int64 get_num_bones();
    void reset_bones_to_sample();
    void add_bone_to_sample(char a2);
    void set_bones_to_sample(__int64 a2);
    void set_bones_to_sample_all();
    void setup(char a2);
    void zero_all();
    void set_out_bone_displacement(char a2, const rglVec3 *a3, const rglSkeleton_model *a4);
    void set_out_quat_no_check(char a2, const rglQuaternion *a3, const rglSkeleton_model *a4);
    _OWORD get_out_local_transform(_OWORD *a2, char a3);
    void normalize_bones_that_need_sampling();
    void normalize_all();
    void set_out_root_pos(const rglVec3 *);
    void set_out_root_displacement(const rglVec3 *);
    bool is_any_quats_sampled();
    void set_bone_hierarchy_dirty(const rglBone_model *);
    bool is_bone_hierarchy_dirty(const rglBone_model *);
    void clear_bone_is_dirty(char a2);
    bool is_any_bone_dirty();
    void set_all_bones_dirty();
    void set_quat_is_sampled(char a2);
    void operator=(const void *a2);
    __int64 operator=(__int64 a2);
    _OWORD get_entitial_out_frame(_OWORD *a2, char a3, const rglSkeleton_model *a4);
    _OWORD get_entitial_out_transform(_OWORD *a2, char a3, const rglSkeleton_model *a4);
    __m128i get_entitial_out_quat_weighted(__m128i *a2, char a3, __int64 a4, float a5);
    __m128i get_entitial_out_quat_read_only(__m128i *a2, int a3, __int64 a4);
    void set_entitial_out_quat(char a2, const rglQuaternion *a3, const rglSkeleton_model *a4);
    void fill_out_bone_displacements_from_local_rest_frames(const rglSkeleton_model *);
};

class rglAnimation_clip_data
{
public:
    rglAnimation_clip_data();
};

class rglAnimation_clip
{
public:
    rglAnimation_clip();
    ~rglAnimation_clip();
    bool operator==(__int64 a2);
    bool operator!=(__int64 a2);
    __int64 get_left_hand_pose();
    __int64 get_right_hand_pose();
    void set_left_hand_pose(char a2);
    void set_right_hand_pose(char a2);
    rglAnimation_clip(const rglAnimation_clip *);
    __int64 operator=(__int64 a2);
    void sample_at_point(rglAnim_result *, rglAnim_playback_record *, float, float, const rglSkeleton_model *);
    void copy_usage_data_from(const rglAnimation_clip_data *);
    void selective_sample_at_point_uniform(rglAnim_result *, rglAnim_playback_record *, float, float, const rglSkeleton_model *);
};

class rglSpin_lock_mutex
{
public:
    rglSpin_lock_mutex();
};

class rglSpin_lock
{
public:
    rglSpin_lock(rglSpin_lock_mutex *);
    void unlock();
    void lock();
};

class rglShared_spin_lock_mutex
{
public:
    rglShared_spin_lock_mutex();
};

class rglShared_spin_lock_shared
{
public:
    rglShared_spin_lock_shared(rglShared_spin_lock_mutex *);
    void unlock_shared();
    void lock_shared();
};

class rglShared_spin_lock_unique
{
public:
    rglShared_spin_lock_unique(rglShared_spin_lock_mutex *);
    void unlock_unique();
    void lock_unique();
};

class rglBone_anim
{
public:
    __int64 get_key_index(float);
    void get_key_indices(int *, int *, float *, float);
    void get_interval_key(int *, float *, float, bool);
    __int64 size_of();
    rglBone_anim operator=(const rglBone_anim *a2, const unsigned int *a3);
    void update(const rglBone_anim *, const unsigned int *);
    rglBone_anim();
    ~rglBone_anim();
    void read(rglBuffer *, const unsigned int *);
    void read(rglIO_Stream *, const unsigned int *);
    void fix_inverse_quaternions();
    void normalize_keys();
    void write(rglIO_Stream *, const unsigned int *);
    void write_data(rglBuffer *a2, char a3);
    void read_data(rglBuffer *);
    __m128i get_quaternion_at(__m128i *a2, float a3);
    float get_position_at(float *a2, float a3);
};

class rglSkeleton_anim
{
public:
    __int64 size_of();
    __int64 has_position_keys();
    __int64 has_scale_keys();
    __int64 get_num_bones();
    rglSkeleton_anim();
    ~rglSkeleton_anim();
    void read(rglBuffer *a2, char a3);
    void update(rglBuffer *a2, unsigned int a3);
    void update(const rglResource *);
    void write(rglIO_Stream *);
    _OWORD get_root_pos_at(_OWORD *a2, int a3);
    _OWORD get_root_scale_at(_OWORD *a2, int a3);
    __int64 write_head(rglBuffer *, unsigned int *);
    __int64 write_data(rglBuffer *a2);
    void read_head(rglCrf_file *, rglBuffer *);
    void read_data();
    __int64 has_position_keys_on_child_bones();
    void fix_different_time_points();
    __int64 get_max_bone_keyframe_count();
    __int64 get_max_bone_keyframe_index();
    __int64 get_entitial_transform_of_bone_for_keys(__int64 a2, char a3, float a4, char a5, __int64 a6);
};

class rglResource_list
{
public:
    void create_copy(rglResource_list *);
    void clear();
    rglResource_list();
    ~rglResource_list();
    void quick_sort(int, int);
    void sort();
    char erase(__int64 *a2);
    __int64 erase(rglResource *a2);
    __int64 erase(const char *a2);
    void insert(rglResource *a2);
    void insert(__int64 *a2);
    __int64 get_closest_point(const char *);
};

class rglApp_platform
{
public:
    HWND get_window_handle();
    void set_window_handle(HWND);
    rglApp_platform(const rglApp_platform *);
    _QWORD operator=(_QWORD *a2);
    rglApp_platform();
    void final_cleanup();
};

class rglResource_loader_task
{
public:
    rglResource_loader_task(rglResource *);
    void run();
    void load_texture();
};

class rglData_texture_creation_task
{
public:
    rglData_texture_creation_task(_QWORD, _QWORD);
    ~rglData_texture_creation_task();
    void run();
};

class rglResource_manager
{
public:
    void ensure_unique_terrain_node_meshes(const rglVarString *);
    __int64 get_number_of_meta_meshes();
    __int64 garbage_collect_render_target_textures();
    __int64 garbage_collect_depth_target_textures();
    __int64 garbage_collect_dynamic_image_textures();
    __int64 garbage_collect_data_textures();
    __int64 garbage_collect_all_textures_lists();
    void wait_async_resource_tasks(int a2);
    _BOOL8 resource_initialization_queues_empty();
    __int64 resource_initialization_queues_count();
    __int64 update_materials_texture_pointers();
    _QWORD get_free_gpu_buffer(__int64 a2, rglString_base *a3, int a4, int a5, int a6, int a7, int a8, __int64 a9, char a10, int a11);
    void print_gpu_buffer_pool_stats(void *a2);
    rglRagdoll_bone get_free_render_target_texture(rglRagdoll_bone *a2, const rglString_base *a3, __int64 a4);
    rglRagdoll_bone get_free_depth_stencil_surface(rglRagdoll_bone *a2, rglString_base *a3, __int64 a4);
    rglRagdoll_bone get_free_data_texture(rglRagdoll_bone *a2, const rglString_base *a3, __int64 a4);
    bool handle_texture_saving_modifications(const rglString_base *);
    __int64 garbage_collect_textures_list(__int64 *a2);
    void apply_material_changes(__int64 a2);
    void get_meshes_with_base_name(rglString_base *a2, __int64 a3);
    void get_all_physics_shapes(__int64 a2);
    _QWORD get_hand_morph_anim_for_pose(_QWORD *a2, int a3, int a4);
    __int64 export_single_resource_xtrf(rglString_base *a2, __int64 *a3, int a4);
    __int64 remove_resource_from_xtrf(rglString_base *a2, const rglString_base *a3, int a4);
    char export_resources_xtrf(rglString_base *a2, _QWORD *a3, int a4, int a5);
    __int64 export_resources(rglString_base *a2, _QWORD *a3, int a4, int a5);
    void check_shader_enforcement_validity();
    void init_resources(const rglString_base *);
    void delete_image_textures_for_newconfig(char a2);
    void delete_image_textures();
    void delete_resources();
    void update_material_shaders();
    void update_referenced_shaders();
    void reset_tableau_contexts();
    void reset();
    ~rglResource_manager();
    void create_hlsl_techniques();
    void reset_hlsl_techniques();
    void init(const rglString_base *);
    __int64 get_number_of_rt_textures();
    __int64 get_number_of_dt_textures();
    __int64 get_number_of_data_textures();
    __int64 get_number_of_dynamic_textures();
    __int64 num_init_resources_step();
    rglResource_manager();
    void add_resource_to_uninitialized_queue(rglResource *);
    void add_resource_to_uninitialized_queue(__int64 *a2);
    void check_resource_queue();
    char try_prepare(rglResource *a2);
    void prepare(rglResource *a2);
    void prepare(rglResource **a2);
    void check_resource_header_queue();
    void clear_old_resources();
    void get_all_animations(__int64 a2);
    void get_all_morph_animations(__int64 a2);
    _QWORD create_material(__int64 a2, const rglString_base *a3, void *a4, rglString_base *a5);
    __int64 create_shader(__int64 *a2, const rglString_base *a3, rglString_base *a4);
    __int64 remove_resource(_QWORD *a2, char a3);
    __int64 save_resource_file(rglString_base *a2, void *a3, int a4);
    void get_all_shader_names(__int64 a2);
    void get_all_material_names(__int64 a2);
    void get_all_textures_with_flag(__int64 a2, int a3, int a4);
    void insert_resource(rglResource *a2);
    void insert_resource(rglHLSLTechnique *);
    void insert_resources(int a2, __int64 **a3);
    __int64 insert_resources(__int64 *a2);
    __int64 resource_list_begin(int a2);
    __int64 resource_list_end(int a2);
    char push_uninitialized_header_resource(rglResource *a2);
    char push_uninitialized_header_resource(__int64 *a2);
    __int64 get_skeleton_model_count();
    void get_all_skeleton_models(__int64 a2);
    void initialize_resources_to_be_deleted();
    void erase_from_resources_to_be_deleted(rglResource *);
    void transform_render_target_to_texture_resource(rglTexture *a2);
    void validate_all_resources_in_loading_queue();
    void delete_techniques();
    void get_all_meshes(rglPath_manager *a2);
    void get_all_materials(char **a2);
    void get_all_textures(rglPath_manager *a2);
    __int64 find_and_insert_meta_meshes_from_meshes(_QWORD);
    void prepare_async(rglResource *this);
    _QWORD get_first_skeleton_model_with_bone_count(_QWORD *a2, char a3);
    __int64 get_active_gpu_texture_memory(char a2, int a3);
    float calculate_valid_gpu_texture_memory();
    void print_valid_gpu_texture_memory_report(rglVarString *);
    void release_all_gpu_textures();
    void insert_templated_generation_shader(rglShader *);
    void remove_meta_mesh(__int64 *a2);
    void mark_resource_as_ignored(rglResource *);
    void get_all_meshes_with_vdecl(__int16 a2, __int64 a3);
    void mark_meta_mesh_as_ignored(rglMeta_mesh *);
    void get_all_meta_meshes(__int64 a2);
    _QWORD get_meta_mesh_copy_with_num_bones(_QWORD *a2, char a3);
};

class rglResource_list_load_wait_task
{
public:
    rglResource_list_load_wait_task(__int64 a2, __int64 a3, __int64 a4);
    ~rglResource_list_load_wait_task();
    void run();
};

class rglGPU_device_d3d11
{
public:
    ~rglGPU_device_d3d11();
    rglGPU_device_d3d11(const rglGPU_device_d3d11 *);
    rglGPU_device_d3d11(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglGPU_device_d3d11();
    void enumerate_devices();
    void init_device();
    void init_main_swap_chain();
    __int64 get_error_messages(_QWORD *a2);
    void on_shutdown();
    void on_config_change();
    void on_resize();
    char present(rglSwap_chain *a2);
    _DWORD max_texture_size(_DWORD *a2);
    char create_gpu_buffer(int a2, int a3, int a4, unsigned int a5, int a6, __int64 a7, _QWORD *a8);
    bool is_device_valid();
    rglEngine_interface create_render_texture(unsigned int *a2, __int64 a3);
    rglEngine_interface create_depth_texture(__int64 a2, __int64 a3);
    __int64 create_data_texture(_QWORD, _QWORD);
    bool create_texture_from_image(__int64 a2, int a3, int a4, __int64 a5);
    void create_occlusion_query_object(rglOcclusion_query_object *);
    void release_occlusion_query_object(rglOcclusion_query_object *);
    char get_image_from_texture(rglTexture_object *a2, rglImage *a3);
    void update_texture_header_from_handle(rglTexture *);
    void get_gpu_memory_stats_summary(rglGpu_memory_stats_summary *);
    void compile_shader(rglString_base *a2, __int64 a3, __int64 a4, unsigned __int16 a5, int a6, __int64 a7, unsigned int *a8, __int64 a9, int a10, int a11, __int64 a12, __int64 a13);
    _BOOL8 create_texture_array(rglTexture *a2, rglTexture_array_creation_desc *a3);
    void initialize_device_resources();
    void delete_device_resources();
    void add_event_marker(const wchar_t *, int);
    rglVarString get_last_executed_marker_name(wchar_t *a2);
    bool is_runtime_format(int a2);
    __int64 device_format_to_rgl_surface_format();
    __int64 rgl_surface_format_to_device_format();
    __int64 rgl_lock_flag_to_device_flag();
    __int64 rgl_comp_func_to_device_type();
    __int64 rgl_stencil_op_to_device_type();
    __int64 rgl_blend_to_device_type();
    __int64 rgl_blend_op_to_device_type();
    __int64 rglSampler_addressing_to_device_type();
    __int64 rgl_primitive_type_to_device_type();
    __int64 rgl_usage_type_to_device_type();
    _DWORD get_formats_from_rgl_format_for_depth_stencil_texture(_DWORD *a2, _DWORD *a3, _DWORD *a4, _DWORD *a5);
    bool has_format_stencil();
    __int64 rgl_sampler_filter_type_to_device_type();
    __int64 create_blend_state(unsigned __int8 *a2, int a3);
    void create_input_layouts();
    void create_sampler_states();
    void create_depth_stencil_states();
    void create_blend_states();
    void create_rasterizer_states();
    bool handle_lost_device();
};

class rglAnim_foot_visual_data
{
public:
    void set_toe_entitial_position(const rglVec3 *);
    void set_toe_global_snap_position(const rglVec3 *);
    void backup_toe_global_snap_position_as_last();
    __int64 get_toe_next_snap_position_overriden();
    void set_toe_next_snap_position_overriden(char a2);
    __int64 get_toe_last_snap_position_overriden();
    void backup_toe_next_snap_position_overriden_as_last();
    void set_toe_last_difference_to_correct(const rglVec3 *);
    void set_toe_position_error_from_snapping(const rglVec3 *);
    float get_move_ratio();
    void set_move_ratio(float);
    void set_is_snap_render(char a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglAnim_foot_visual_data();
    void reset_ik_data();
    void reset_non_ik_data();
    void copy_from(const rglAnim_foot_visual_data *);
    void add_ik_data_toe_entitial_position(const rglVec3 *);
};

class rglSkeleton_scale
{
public:
    float get_mount_radius_adder();
    void set_mount_radius_adder(float);
    __int64 get_num_bones();
    rglSkeleton_scale(char a2);
    rglSkeleton_scale(const rglSkeleton_scale *);
    void set_scale_for_bone(char a2, const rglVec3 *a3);
    void reset_bone_scales();
    void resize_bone_count(char a2);
    ~rglSkeleton_scale();
    void copy_from(const rglSkeleton_scale *);
};

class rglComposite_component
{
public:
    __int64 get_type_id();
    __int64 get_type_name(__int64 a2);
    rglComposite_component();
    ~rglComposite_component();
    __int64 set_policy(unsigned int a2);
    void copy_to(rglComposite_component *a2);
    void check_deform_to_time();
    char render(rglRender_context *a2, rglScene *a3, const rglMatrix_frame *a4, const rglEntity_render_params *a5);
    char render_into_oro(rglOrol *a2, unsigned int a3, const rglMatrix_frame *a4);
    char is_optimizable();
    void set_factor_color(const rglVec3 *);
    __int64 set_factor2_color(_OWORD *a2);
    void set_factor_alpha(float);
    __int64 set_vertex_color(unsigned int a2);
    void set_vector_argument(const rglVec3 *);
    void deform_to_time(const float *);
    __int64 set_material(__int64 a2);
    __int64 get_visibility_mask();
    void set_visibility_mask(const unsigned int *);
    void recompute_bounding_box();
    void recompute_bounding_box();
    void scale_vertices(const rglVec3 *a2, char a3, float a4);
    __int64 set_cull_mode(unsigned int a2);
    void compute_tangents();
    void hint_vertices_dynamic();
    void hint_vertices_static();
    void hint_indices_dynamic();
    void hint_indices_static();
    __int64 check_resources(const rglCheck_resource_params *);
    void clear_gpu_resources();
    void set_mesh_render_order(const unsigned int *);
    __int64 add_mesh_flag(unsigned int a2, unsigned int a3);
    bool is_empty();
    __int64 get_all_meshes(__int64 a2, unsigned int a3);
    void init();
    void set_frame(const rglMatrix_frame *);
    __int64 get_face_count();
    void add_entity(rglScene *, const rglEntity *);
    void clear_meshes();
    void add_component(rglEntity_component *this);
    char remove_component(rglEntity_component *a2);
    __int64 get_meshes_for_lod(unsigned int a2, __int64 a3);
    void create_decal_on_skeletal_entities(rglSkinned_decal_buffer *a2, const rglVec3 *a3, const rglVec3 *a4, __int64 a5, int a6, const rglEntity *a7, signed __int8 a8, bool *a9);
    void tick(float, const rglMatrix_frame *);
    void set_using_season(unsigned __int8 a2);
    void set_using_environment_decals(unsigned __int8 a2);
    void set_using_smooth_lod(unsigned __int8 a2);
    void set_contour_color(const rglVec3 *);
    void set_contour_state(bool);
    void disable_contour();
    __int64 get_all_meshes_with_frames(__int64 a2, __int64 a3, float *a4, int a5);
    void set_entity(const rglEntity *);
    rglVarString get_type_string(rglVarString *a2);
    char needs_tick();
};

class rglRagdoll_bone
{
public:
    rglRagdoll_bone(const rglRagdoll_bone *);
    void set_engine_body(rglPhysics_engine_body *);
    __int64 get_current_frame(__int64 a2);
    __int64 get_current_visual_frame(__int64 a2);
    __int64 get_velocity(__int64 a2);
    __int64 get_angular_velocity(__int64 a2);
    void set_velocity(const rglVec3 *);
    void set_angular_velocity(const rglVec3 *);
    void set_current_frame(const rglMatrix_frame *);
    void reset_motion_state();
    void apply_force(const rglVec3 *, const rglVec3 *);
    void apply_torque(const rglVec3 *);
    void apply_impulse(const rglVec3 *, const rglVec3 *);
    rglRagdoll_bone(__int64 *a2);
    void set_mass(float);
    void get_mass();
    __int64 is_sleeping();
};

class rglRagdoll
{
public:
    void add_constraint_aux(rglPhysics_engine_constraint *);
    rglRagdoll(const rglRagdoll *);
    __int64 operator=(__int64 a2);
    rglRagdoll(rglPhysics_engine_world *);
    ~rglRagdoll();
    void clear();
    char is_sleeping();
    void debug_render_physics();
    void reset_root_global_frame(const rglMatrix_frame *);
    void setup_physics_world(rglScene *, rglSkeleton *);
};

class rglMesh_merge_task
{
public:
    ~rglMesh_merge_task();
    rglMesh_merge_task(_QWORD, _QWORD, _QWORD);
    void run();
};

class rglMesh_merge_cache_manager
{
public:
    rglMesh_merge_cache_manager(const rglMesh_merge_cache_manager *);
    _DWORD operator=(_DWORD *a2);
    rglMesh_merge_cache_manager();
    ~rglMesh_merge_cache_manager();
    __int64 get_merged_mesh(__int64 *a2, _QWORD *a3, _QWORD *a4, __int64 a5);
    void reset();
};

class rglCloth_simulator_component
{
public:
    __int64 get_all_meshes_with_frames();
    __int64 get_all_meshes();
    __int64 get_face_count();
    rglCloth_simulator_component(rglCloth_simulator_component *);
    void tick(float, const rglMatrix_frame *);
    void simulate_cloth(rglRender_context *, rglScene *, const rglMatrix_frame *, signed __int8, int, int, int);
    __int64 render(rglRender_context *a2, rglScene *a3, const rglMatrix_frame *a4, const rglEntity_render_params *a5);
    void set_mesh(rglMeta_mesh *);
    rglCloth_simulator_component(rglMeta_mesh *a2, char a3);
    ~rglCloth_simulator_component();
    void set_using_season();
    __int64 set_cull_mode(int a2);
    void set_factor_color(const rglVec3 *);
    void set_factor_alpha(float);
    void set_visibility_mask(const unsigned int *);
    __int64 get_visibility_mask();
    void set_frame(const rglMatrix_frame *);
    void set_collision_body_to_all_meshes(__int64 *a2);
    __int64 write(__int64 a2, __int64 a3, __int64 a4, int a5);
    void read(__int64 a2);
    __int64 check_resources(const rglCheck_resource_params *);
    void clear_gpu_resources();
    rglVarString get_type_string(rglVarString *a2);
    void read_binary(rglBuffer *);
    void invalidate_static_data();
    void write_binary(rglBuffer *);
    void set_reset_required();
    void set_entity(const rglEntity *);
    void set_forced_local_wind(const rglVec3 *);
    void set_forced_global_wind(const rglVec3 *);
};

class rglCloth_simulation_manager
{
public:
    __int64 compute_simulation_state_id(int a2, int a3, int a4);
    bool can_use_thread_group_shared_memory();
    __int64 compute_dispatch_thread_group_size();
    ~rglCloth_simulation_manager();
    rglCloth_simulation_manager();
    void tick(float);
    void validate_global_simulation_buffers();
    void process_cloth_simulation_context(const rglRender_context *);
    void init();
    void display_constraints(rglRender_context *, rglMesh *);
    char check_cooked_data(const rglCloth_simulation_cooked_data *a2);
    void load_clothing_materials();
    void validate_global_cooked_data_buffer();
    void validate_global_collision_data_buffer();
    void validate_global_mapping_data_buffer();
    void validate_global_simulated_data_buffer();
    void prepare_state(rglCloth_simulator_component *);
    void invalidate_states(rglCloth_simulator_component *);
    void bind_simulation_buffers();
    void unbind_simulation_buffers();
    void get_new_descriptor_handle(int a2, _DWORD *a3);
    void free_descriptor_handle(int a2, int *a3);
    void set_cooked_data_for_handle(int, rglCloth_simulation_cooked_data *);
    void set_collision_data_for_handle(int, rglCloth_simulation_body_definition *);
    void set_simulated_data_for_handle(int, int);
    void set_mapping_data_for_handle(int, rglCloth_simulation_mapping_data *, int);
    char check_descriptor_handle(int a2, int a3);
    bool save_cooked_cloth_data(rglMeta_mesh *);
    bool save_mapped_cloth_data(rglMeta_mesh *);
    _QWORD get_clothing_body(_QWORD *a2, rglString_base *a3);
    void save_clothing_materials(__int64 a2, __int64 a3);
    void load_clothing_bodies();
    void fix_clothing_properties_of_all_meshes();
    void save_clothing_bodies(__int64 a2, __int64 a3);
    void reset_all_meshes();
    void set_parameters_of_all_tres_files();
    void cook_and_save_all_meshes();
    char prepare_component(rglCloth_simulator_component *a2, char a3);
};

class rglAnim_node_human_movement
{
public:
    void set_terrain_factor_on_walking_speed(float);
    float get_walking_cycle();
    float get_idle_cycle();
    float get_standing_weight();
    float get_target_turning_weight();
    __int64 get_next_movement_layer_key();
    float get_walking_speed_limit();
    float get_crouch_walking_speed_limit();
    __int64 get_left_stance();
    void set_maximum_step_size(float);
    bool has_movement_layers();
    rglAnim_node_human_movement();
    void operator=(const void *a2);
    ~rglAnim_node_human_movement();
    void setup(const rglSkeleton_model *, float, float, float);
    void set_inputs(const rglVec2 *, const rglVec2 *, float, float, float);
    void set_inputs_for_ik(float, float, float);
    void tick(float a2, const rglSkeleton *a3, char a4, bool a5, bool a6);
    void integrate_with_adder_animations(const rglSkeleton *a2, rglAnim_result *a3, rglAnim_result *a4, bool a5);
    void post_integrate_skeleton(const rglSkeleton *a2, rglAnim_result *a3, float a4);
    void get_enforcements(const rglSkeleton_model *a2, float *const a3, char a4);
    float get_enforcement_of_bone(const rglSkeleton_model *a2, unsigned __int8 a3);
    float get_smooth_standing_weight();
    float get_adjusted_turning_weight();
    float get_running_weight();
    void set_left_stance(char a2);
    float get_movement_cycle_adder(__int64 a2);
    float get_snapping_range_for_animation(float *a2, int a3, int a4, int a5);
    float get_snapping_period_for_animation(int, int, int);
    float get_local_speed_limit_according_to_next_snap_position(const rglSkeleton *);
    float get_cycle_multiplier_according_to_next_snap_position(const rglSkeleton *);
    __int64 set_next_movement_layer(int a2, __int64 a3, int a4, __int64 a5);
    void update_movement_mode();
    float get_maximum_step_size(int);
    __int64 get_next_movement_layer_movement_mode();
    void add_movement_layer(const rglAnim_human_movement_layer *);
    void clean_unused_movement_layers();
    void print_debug_messages();
    void on_manual_position_set();
};

class rglCloth_mapping_task
{
public:
    ~rglCloth_mapping_task();
    rglCloth_mapping_task(rglMeta_mesh *a2);
};

class rglSound_event_oneshot_parameters
{
public:
    rglSound_event_oneshot_parameters();
    ~rglSound_event_oneshot_parameters();
    rglSound_event_oneshot_parameters(const rglSound_event_oneshot_parameters *);
    __int64 operator=(__int64 a2);
    void set_string_parameter(const rglString_base *, float);
    void set_string_parameter(const rglString_base *a2, char a3);
    void set_int_parameter(int, float);
    void set_int_parameter(int a2, char a3);
    void write_data(rglBuffer *);
    void read_data(rglBuffer *);
};

class rglAnim_node
{
public:
    rglAnim_node();
};

class rglAnim_node_layer_system
{
public:
    float get_current_weight();
    float get_channel_speed();
    __int64 get_num_layers();
    const Anim_layer(int);
    float cur_anim_clip_target_weight();
    ~rglAnim_node_layer_system();
    rglAnim_node_layer_system(const rglAnim_node_layer_system *);
    rglAnim_node_layer_system(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    void setup(const rglSkeleton_model *);
    void reset();
    void set_channel_animation_speed(float);
    __int64 set_channel_animation(_QWORD, _QWORD);
    void set_channel_parameter(float);
    void set_channel_parameter_keep_old(float);
    void set_layer_parameter(int, float);
    float get_channel_parameter();
    float get_channel_old_parameter();
    float get_starting_parameter();
    float get_channel_time_left_for_fading_in();
    float get_channel_total_time_for_fading_in();
    bool action_channel_at_end();
    bool action_channel_at_fade_out(float);
    __int64 add_layer(__int64 (__fastcall *a2);
    void remove_layer(int);
    float get_current_weight_of_current_action();
    float get_current_action_fade_elapsed_time();
    char channel_has_enforcement();
    void fade_all(float a2, const float *a3, __int64 (__fastcall *a4);
    void tick(float, const rglSkeleton *);
    void integrate_layer_into_garbage_layer(int, const rglSkeleton_model *);
    void integrate(rglAnim_result *, rglAnim_bone_relative_position_result *, rglAnim_bone_entitial_frame_result *, int, const rglSkeleton_model *, bool);
    float get_enforcement_of_bone(const rglSkeleton_model *a2, char a3);
    void get_enforcements(const rglSkeleton_model *a2, float *const a3, float a4);
    float get_channel_duration_left(float);
    rglAnim_node_layer_system();
    void set_layer_target_weight(int, float, float, bool);
    float get_current_weight_of_animation(const rglAnimation_clip *);
    float get_current_progress_of_animation(const rglAnimation_clip *);
    void check_and_update_sound_times(float);
};

class rglAnim_tree
{
public:
    __int64 get_bone_mapping_for(char a2);
    void init_bone_mapping_cache(const signed __int8 *a2, char a3);
    __int64 set_post_integrate_callback(__int64 *a2);
    void clear_post_integrate_callback();
    bool has_post_integrate_callback();
    rglAnim_tree();
    rglAnim_tree(const rglAnim_tree *);
    __int64 operator=(__int64 a2);
    ~rglAnim_tree();
    void integrate_skeleton(rglSkeleton *);
    void handle_post_integrate_callback(const rglAnim_result *);
    void get_anim_result_from_current_pose(const rglSkeleton *a2, rglAnim_result *a3);
};

class rglBone
{
public:
    void set_entitial_rest_frame_transposed(const rglMatrix_frame *);
    void set_local_transform(const rglTransform *);
    void set_local_frame_origin(const rglVec3 *);
    void set_local_frame_quaternion(const rglQuaternion *);
    __int64 get_parent_bone_index();
    __int64 get_child_bone_index(char a2);
    __int64 get_num_children();
    void set_local_delta_quat(const rglQuaternion *);
    __int64 get_components_size();
    __int64 get_ticked_components_size();
    void set_ragdoll_bone_ref(rglRagdoll_bone *);
    __int64 get_ticked_components();
    rglBone(const rglBone *);
    __int64 operator=(__int64 a2);
    void set_entitial_transform_wo_precomputing_bone_transforms(const rglTransform *);
    rglBone();
    ~rglBone();
    void init();
    void add_component(rglEntity_component *a2, rglSkeleton *a3);
    void apply_flags_to_components(unsigned int);
    void set_factor_color(const rglVec3 *);
    void set_factor_alpha(float);
    void set_material_for_all_meshes(rglMemory_block_typeless **a2);
    void clear_particle_systems(rglSkeleton *);
    void add_light(rglLight *, rglSkeleton *);
    void clear_lights(rglSkeleton *);
    void clear_meshes(rglSkeleton *);
    void clear_gpu_resources();
    __int64 get_component_index(int a2);
    bool has_component(rglEntity_component *);
    void tick(float, rglSkeleton *, const rglMatrix_frame *);
    void remove_component(__int64 *a2, rglSkeleton *a3);
    void set_as_contour_entity(const rglVec3 *a2);
    void set_contour_state(bool);
    void disable_contour();
    char write(__int64 a2, __int64 a3, __m128 *a4, _DWORD *a5, rglString_base *a6, char a7);
    char write_components(__int64 a2, __int64 a3, __int64 a4, rglString_base *a5);
    void read(__int64 a2, _QWORD *a3, rglString_base *a4);
    void read_components(__int64 a2, _QWORD *a3, rglString_base *a4);
    void copy_frames(const rglBone *);
    void read_binary(rglBuffer *, rglSkeleton *);
    void write_binary(rglBuffer *);
    void refresh_needs_tick_state(rglSkeleton *);
    void set_entitial_transform(const rglTransform *a2, rglSkeleton *a3);
    void create_from_model(const rglBone_model *);
};

class rglScript_component
{
public:
    __int64 get_type_id();
    rglScript_component();
    void set_entity(rglEntity *);
    rglScript_component(const rglScript_component *);
    __int64 get_type_name(__int64 a2);
    ~rglScript_component();
    void read_variables(__int64 a2);
    void write_variables(__int64 a2, __int64 a3, __int64 a4);
    void copy_variables_from(const rglScript_component *a2, char a3);
    void handle_entity_references();
    void init_script_component();
    void write_binary(rglBuffer *);
    void read_binary(rglBuffer *);
};

class rglGround_contact
{
public:
    rglGround_contact(_OWORD *a2, __int128 *a3, __int64 a4, char a5, __int64 a6, int a7);
    rglGround_contact();
    void reset();
    bool is_valid();
    bool is_terrain();
    bool is_body_part();
    void set_as_terrain(const rglVec3 *, float, const rglPhysics_material *);
    void set_height(float);
    __int64 get_body_flags();
    bool is_feasible();
    __int64 get_plane_ray_intersection(__int64 a2, float *a3, float *a4);
    __int64 operator=(__int64 a2);
    void set_minimum_and_maximum_normal_z(float);
    void handle_body_removal(const rglPhysics_engine_body *);
};

class rglShader_manager
{
public:
    rglVarString get_custom_shader_cache_name(rglVarString *a2, const rglString_base *a3, int a4, int a5, int a6, const rglString_base *a7, int a8);
    void register_shader_compile_start();
    void register_shader_compile_end();
    __int64 get_active_shader_compilation_count();
    __int64 is_compiling_active();
    rglShader_manager();
    ~rglShader_manager();
    void validate_shader_mapping(rglShader_compile_extensions_instance *);
    void compile_all_shaders_automated();
    void read_shader_mapping_file(rglShader_compile_extensions_instance *);
    bool check_shader_cache_version();
    void initialize_shader_cache_file(rglShader_compile_extensions_instance *);
    void add_new_shader_cache(const rglString_base *, unsigned __int8 *, int, const rglString_base *);
    void commit_shader_mappings_and_caches();
    __int64 get_cache_path(_QWORD, _QWORD, _QWORD, _QWORD);
    void get_shader_cache_name(void *a2, const rglString_base *a3, __int64 a4, const rglString_base *a5, unsigned __int16 a6, int a7, unsigned __int64 a8, __int64 a9);
    void output_missing_effect(const rglShader_manager::rglShader_compile_desc_internal *);
    void fetch_readable_data_from_shader_compile_request(__int64 a2, __int64 a3, __int64 a4, __int64 a5);
    void get_vdecl_name_from_enum(rglVarString *);
    char reload_shaders();
    __int64 load_shader_cache(__int64);
    void get_shader_combination_id_from_cache_line(const rglString_base *, rglShader_compile_extensions_instance *, enum rglShader_types *, rglShader **, rglShader_identifier *);
    void restore_effect(__int64 a2, __int64 a3);
    void create_fallback_shaders();
    char reload_shaders_Imp();
    __int64 get_shader_cache_count();
    void tick_shader_cache();
    void release_shader_compile_tools();
    void clear_cache_mask_map();
    _BOOL8 check_shader_mapping_validity(rglShader_compile_extensions_instance *a2);
    void print_shader_identifiers(const char *);
    void print_shader_combinations(const char *);
    bool can_be_dynamic_instanced();
    void compile_shader_combinations();
    void fetch_bake_shader_combinations(int a2, __int64 a3, __int64 a4);
    void recompile_single_shader(const rglString_base *);
    __int64 compile_terrain_shaders(int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, void *);
    void wait_for_batched_shader_compilation();
    void wait_active_shader_compilations();
    __int64 get_last_modification_date_of_shader_sources();
    void get_possible_systemflag_configurations(int a2, __int64 a3, _DWORD *a4, __int64 a5);
    __int64 uncommitted_shader_cache_count();
    void clear_uncomitted_shader_caches();
    void get_total_shader_bytecode_cache_size(rglVarString *);
    __int64 get_shader_compilation_mask_from_function_name(const rglString_base *a2);
    __int64 get_shader_type_from_function_name(rglString_base *a2);
    void write_compressed_shader_cache_package(rglShader_compile_extensions_instance *);
    void read_compressed_shader_cache_package(rglShader_compile_extensions_instance *);
    __int64 get_technique_name_from_cache_line(const rglString_base *, rglVarString *);
    void get_terrain_node_indexes_from_cache_name(const rglString_base *, int *, int *);
    __int64 fetch_compute_shader_combinations(__int64 a2);
    char create_shader_stage_device_object(int *a2, int a3, __int64 a4);
};

class rglShader_manager_task
{
public:
    __int64 get_status();
    rglShader_manager_task(rglShader_manager *);
    void run();
};

class rglPrefab_manager
{
public:
    void get_file_name_with_index(void *a2, int a3, int a4);
    __int64 get_file_record_count(int);
    void add_prefabs_file(const char *);
    void save_prefab_file(int, int);
    __int64 remove_display_thumbnails_of_prefabs(__int64 *a2);
    __int64 find_and_remove_prefab_entity(const rglVarString *a2);
    char is_prefab_entity_exist(const rglEntity *a2, char a3);
    __int64 get_closest_prefab_to_entity(_DWORD, char, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD, _DWORD);
    _QWORD get_all_prefab_entities_with_module_ids(__int64 a2, char a3);
    _QWORD get_all_prefab_entities(__int64 a2, char a3);
    void get_all_prefabs_and_child_with_tag(void *a2, const rglString_base *a3);
    __int64 get_prefab_entities_with_file_index(int a2, int a3, __int64 a4);
    __int64 get_num_scene_prop_prefabs();
    void get_prefab_names_with_tag(void **a2, const rglString_base *a3);
    void reset();
    void save_all_files();
    __int64 is_prefab_file_index_visible_at_editor(int a2, int a3);
    __int64 get_first_entity(__int64 a2);
    void get_next_prefab(rglPrefab_manager::iterator *);
    void give_level_to_entities_and_save(const rglString_base *a2, const rglString_base *a3, __int64 *a4);
    rglPrefab_manager();
    ~rglPrefab_manager();
    _QWORD find_prefab_record_in_module(_QWORD *a2, const rglString_base *a3, int a4, _DWORD *a5, _DWORD *a6);
    void get_prefab_record_information(const rglEntity *, int *, int *, int *);
    __int64 get_prefab_record_information(__int64);
    void register_prefab_entity_managed_script_components();
    void deregister_prefab_entity_managed_script_components();
    void fix_entity_references_of_scripts_of_prefabs();
    void register_all_managed_script_components();
    rglVarString get_file_name_containing_prefab(rglVarString *a2, __int64 a3);
};

class rglNav_mesh_edge
{
public:
    _OWORD operator=(_OWORD *a2);
    __int64 operator=(__int64 a2);
    void toggle_selection();
    rglNav_mesh_edge();
    void reset();
    void add_face(rglNav_mesh_face *);
    void remove_face(const rglNav_mesh_face *);
    __int64 calculate_mid_point(__int64 a2);
    void fix_face_references();
    void intersect_with_ray(const rglVec3 *, const rglVec3 *, float *, float *);
    __int64 get_normal_with_one_face(__int64 a2);
    void get_counterclockwise_vertices_with_one_face(rglNav_mesh_vertex **, rglNav_mesh_vertex **);
};

class rglPath_edge
{
public:
    void set_move_index_on_path(__int16 a2);
    __int64 get_move_index_on_path();
    void set_is_used(char a2);
    __int64 get_is_used();
    rglPath_edge();
    _OWORD operator=(_OWORD *a2);
    __int64 operator=(__int64 a2);
};

class rglNav_mesh_face
{
public:
    bool is_enabled_for_pathing();
    ~rglNav_mesh_face();
    rglNav_mesh_face(const rglNav_mesh_face *);
    rglNav_mesh_face(__int64 a2);
    _QWORD operator=(_QWORD *a2);
    _QWORD operator=(_QWORD *a2);
    char is_enabled_for_pathing(__int64 a2, __int64 a3, int a4);
    rglNav_mesh_face();
    void reset();
    void update_center();
    void toggle_selection();
    void set_edge(const int *, rglNav_mesh_edge *);
    void recompute_face_normal();
    void combine_level_masks_from_neighbors();
    void create_quad(struct ftlQuad_data *);
    char is_concave();
    bool is_inverted();
    char is_invalid();
    void update_neighbours_and_center();
    void set_direction_type(int a2);
    bool is_bridge();
    __int64 get_ignored_edge_index();
    __int64 get_exit_position_for_segment(__int64 a2, float *a3, float *a4);
    void intersect_with_ray(const rglVec3 *, const rglVec3 *, float *);
    void get_min_max(rglVec2 *, rglVec2 *);
    __int64 contains_position(const rglVec2 *a2);
    bool contains_position_with_z(const rglVec3 *, float);
    float get_height_at_point(const rglVec2 *);
    float get_distance_to_position(const rglVec3 *);
    float get_distance_sq_to_position(const rglVec2 *);
};

class rglNav_mesh
{
public:
    bool is_not_empty();
    void update_centers_of_faces();
    char is_quad_concave();
    void make_quads_when_possible(float);
    rglNav_mesh();
    void safe_remove_face(rglNav_mesh_face *);
    ~rglNav_mesh();
    __int64 dump_to_stream(__int64 a2, char a3, float *a4);
    void read_stream(rglIO_binary_stream *);
    __int128 add_vertex(__int128 *a2, __int128 *a3, _BYTE *a4);
    __int64 get_vertex_index(rglNav_mesh_vertex *);
    __int64 get_edge_index(rglNav_mesh_edge *);
    __int64 get_face_index(rglNav_mesh_face *);
    void add_face(int a2, const int *a3, const int *a4, const int *a5, const int *a6, const int *a7, const int *a8, const int *a9, const int *a10);
    void add_face_with_new_vertices(const int *a2, const rglVec3 *a3, const rglVec3 *a4, const rglVec3 *a5, const rglVec3 *a6);
    void clear_all();
    void select_any(int a2, int a3, char a4);
    __int64 select_all(int a2, int a3, char a4);
    void compute_face_normals();
    void get_edges_in_circle(__int64 a2, float *a3, float a4, char a5, __int64 a6, __int64 a7);
    __int64 get_edges_in_circle_aux(__int64 a2, float *a3, float a4, char a5, __int64 a6, int a7, int a8, int a9);
    void toggle_select_vertex(rglNav_mesh_vertex *);
    __int64 scale_selected_elements(int a2, float *a3);
    __int64 rotate_selected_elements(int a2, float *a3);
    __int64 move_selected_elements(int a2, float *a3);
    void tag_all_vertices();
    void untag_all_edges();
    void untag_all_vertices();
    __int64 tag_vertices_for_selected_elements(int a2);
    __int64 tag_edges_for_selected_elements(int a2);
    __int64 tag_faces_for_selected_elements(int a2);
    void check_edge_references_by_face(rglNav_mesh_face *a2);
    void tag_referenced_vertices_by_edges();
    void check_vertex_references_by_edges();
    void delete_edges_with_vertex(rglNav_mesh_vertex *);
    void delete_face(rglNav_mesh_face *a2, char a3);
    void delete_edge(rglNav_mesh_edge *a2, char a3);
    void delete_vertex(rglNav_mesh_vertex *);
    void delete_selected_vertices();
    void delete_selected_elements();
    void convert_selection_to_vertices();
    void convert_selection_to_edges();
    void convert_selection_to_faces();
    void grow_selection();
    char connect_vertices();
    void extrude();
    char weld();
    void recompute_face_neighbours();
    char remove_edge(rglNav_mesh_edge *a2);
    void increment_white_point(int);
    __int64 optimize_path(__int64 a2, __int64 *a3, float a4, char a5);
    __int16 construct_path_edges_list(int a2, rglNav_mesh_face *a3, rglNav_mesh_face *a4, rglVec2 *a5, rglVec2 *a6, _QWORD *Src, char a8);
    __int64 mark_island(rglNav_mesh_face *, int);
    void build_islands();
    char import_stream(rglIO_binary_stream *a2, rglScene_spatial_grid *a3, char a4, int a5, float *a6, char a7);
    void render_debug(const rglVec3 *, int);
    void separate_faces_with_id(int, int, rglScene_spatial_grid *);
    void merge_faces_with_id(int, int, int, rglScene_spatial_grid *);
    void swap_face_connections_with_id(int a2, int a3, int a4);
    __int64 get_path_distance_between_positions(_DWORD, _DWORD, _DWORD, _DWORD, __int64);
    char find_path_between_positions(rglNav_mesh_face *a2, __int64 a3, float *a4, __int64 a5, int a6, _BYTE *Src, void *a8, int a9, int a10, __int64 a11);
    char get_path_bwn_faces(rglNav_mesh_face *a2, __int64 a3, float *a4, __int64 a5, int a6, __int64 a7, int a8, __int64 a9);
    char line_to_point_is_clear(rglNav_mesh_face *a2, __int64 a3, float *a4, float *a5, int a6, void *a7, char Src, int a9, void *a10);
    char line_to_point_is_clear_aux(__int64 a2, __int64 a3, float *a4, float *a5, void *Src, __int64 a7, _DWORD *Srca, __int64 a9, __int64 a10, __int64 a11, __int64 *a12);
    __int64 fill();
    char vertex_fill_3_or_4_vertices();
    __int64 vertex_fill_3_vertices(rglNav_mesh_vertex **const a2);
    void break_selected_faces();
    char subdivide_edge();
    void create_new_face(const rglVec3 *, float);
    __int64 set_selected_faces_id(int a2, __int64 a3, __int64 a4);
    __int64 set_selected_faces_cost(float a2, __int64 a3, __int64 a4);
    void set_ability_of_faces_with_id(int a2, char a3);
    char is_any_face_with_id(int a2);
    void draw_debug_edges(const rglVec3 *, float);
    char pin_closest_edges_of_faces(int a2, int a3);
    char weld_vertices(rglNav_mesh_vertex *a2, rglNav_mesh_vertex *a3);
    void set_nav_mesh_face_cost_with_id_around_position(int, const rglVec3 *, float, rglScene_spatial_grid *);
    __int64 get_all_nav_mesh_faces_for_position(float *a2, __int64 a3, int a4, __int64 a5);
    void get_neighbour_nav_mesh_face_for_position_aux(int, const rglVec3 *, const rglNav_mesh_face *, const int *, int, rglNav_mesh_face **, float *);
    void calculate_auto_weld_points();
    void apply_auto_welds();
    void update_auto_weld_points_mesh(rglEntity *a2);
    void add_body(rglPhysics_shape *);
    void ensure_face_neighbour_info_valid(rglNav_mesh_face *);
    char subdivide_face(rglNav_mesh_face *a2, __int64 a3, __int64 a4);
    char is_nav_mesh_excluded(__int64 a2, __int64 a3);
    __int64 get_not_excluded_neighbor_aux(__int64 a2, __int64 a3, __int64 *a4, float *a5, __int64 a6, int a7, float *a8, __int64 a9, _DWORD *a10);
    __int64 get_not_excluded_neighbor(__int64 a2, __int64 a3, float *a4);
    __int64 get_white_point_index();
    void release_white_point_index(char a2);
    void delete_unconnected_vertices();
    bool line_to_point_has_navigation_face_id(rglNav_mesh_face *a2, rglNav_mesh_face *a3, float *a4, float *a5, int a6, __int64 a7);
    bool line_to_point_has_navigation_face_id_aux(rglNav_mesh_face *a2, rglNav_mesh_face *a3, float *a4, float *a5, __int64 a6, __int64 a7, __int64 a8, __int64 a9);
    bool are_navigation_faces_on_same_island(const rglNav_mesh_face *, const rglNav_mesh_face *);
};

class rglScene_object_manager
{
public:
    __int64 root_entities_to_be_added();
    __int64 root_entities();
    bool is_empty();
    __int64 get_game_entity(__int64 a2);
    __int64 get_id_of_game_entity(rglEntity *);
    __int64 game_entities_begin(__int64 **a2);
    __int64 game_entities_end(__int64 a2);
    __int64 game_entities_cbegin(__int64 *a2);
    __int64 game_entities_next(__int64 *a2);
    __int64 game_entities_cnext(__int64 *a2);
    __int64 iterator_at(__int64 **a2, int a3);
    bool is_valid_object_id(int);
    __int64 number_of_entries();
    float get_occupancy();
    ~rglScene_object_manager();
    __int64 find_game_entity_with_name(const rglString_base *a2, int a3);
    void compact();
    void clear();
    __int64 get_game_entities_with_tags(const rglString_base *a2, __int64 a3);
    __int64 are_tags_matching(const rglString_base *a2);
    __int64 get_game_entities_as_regular_list(__int64 a2);
    void register_game_entity(rglEntity *);
    void deregister_game_entity(rglEntity *);
    void remove_from_root_list(rglEntity *);
    void add_to_root_list(rglEntity *);
    void add_to_entity_as_to_be_added(rglEntity *);
    void ensure_root_list_valid();
    void register_game_entity_for_replay(rglEntity *);
    void deregister_game_entity_for_replay(rglEntity *);
};

class rglOro_task
{
public:
    rglOro_task(rglScene *a2, rglRender_context *a3, char a4, rglSignal_event *a5, rglSignal_event *a6);
    void run();
};

class rglOrol
{
public:
    void reset_cull_result_array_index();
    __int64 get_free_cull_result_array_index();
    __int64 set_cull_results_per_entity_for_scene_id(int a2, char **a3);
    __int64 get_cull_results_per_entity_for_scene_id(int a2);
    __int64 set_cull_results_per_component_for_scene_id(int a2, char **a3);
    __int64 get_cull_results_per_component_for_scene_id(int a2);
    __int64 get_oro_count();
    rglOrol(const rglOrol *);
    void operator=(__int64 *a2);
    __int64 check_resources(const rglCheck_resource_params *);
    void clear();
    void clear_entities_from_scene(rglScene *);
    void prepare_for_culling(const rglScene_view *, const rglRender_context *);
    void calculate_visibility(const rglScene_view *, const rglRender_context *, const rglScene *);
    __int64 compute_lod_level_plus_one(const rglOro_cull_object *, const rglScene *, const rglVec3 *, const rglRender_context *);
    void update_lod_qualities(const rglScene_view *, const rglRender_context *, const rglScene *, const rglVec3 *);
    void force_update_lod_qualities(const rglScene_view *, const rglRender_context *, const rglScene *, int);
    ~rglOrol();
    __int64 add_cull_object_per_entity(__int64 a2);
    __int64 add_cull_object_per_component(__int64 a2);
    void add_oro(const rglOro_lod_data *, const rglOro_render_data *);
    void render_oros(rglRender_context *a2, rglRender_context *a3);
    void create_oros(rglScene *);
    __int64 add_mesh_to_shadow_rc(const rglMesh *, const rglMatrix_frame *);
    __int64 add_mesh_to_rc_w_gbuffer(const rglMesh *, const rglMatrix_frame *);
    __int64 add_mesh_to_rc(const rglMesh *, const rglMatrix_frame *);
    bool add_mesh(const rglMesh *, int, const rglMatrix_frame *, int, int);
};

class rglTerrain_map_node
{
public:
    rglTerrain_map_node(const rglTerrain_map_node *);
    __int64 operator=(__int64 a2);
    rglTerrain_map_node();
    ~rglTerrain_map_node();
    void clear();
    void remove_physics_engine_body();
    void init(rglScene *, int, int, float);
    float get_height_at(const rglInt_vec2 *, const rglVec2 *, const rglPhysics_material **, bool);
    void get_vertices_at(const rglInt_vec2 *, const rglVec2 *, rglVec3 *, rglVec3 *, rglVec3 *, const rglPhysics_material **, const rglPhysics_material **, const rglPhysics_material **);
    char check_point_can_see_point(const rglVec3 *a2, const rglVec3 *a3, rglVec3 *a4);
    void invalidate_physics_materials();
    float get_normal_at(float *a2, _DWORD *a3, float *a4);
    char get_triangle_corner_indexes(const void **a2);
};

class rglTerrain_map
{
public:
    rglTerrain_map(const rglTerrain_map *);
    void get_height_normal_material_at(const rglVec2 *, float *, rglVec3 *, const rglPhysics_material **);
    float get_normal_at(float *a2, const rglVec2 *a3, _QWORD *a4);
    float get_height_at(const rglVec2 *a2, const rglPhysics_material **a3, bool a4);
    void get_vertices_at(const rglVec2 *a2, rglVec3 *a3, rglVec3 *a4, rglVec3 *a5, const rglPhysics_material **a6, const rglPhysics_material **a7, const rglPhysics_material **a8);
    void get_normal_at_area(const rglVec2 *, const rglVec2 *, int *, rglVec3 *const);
    void get_vertices_at_area(const rglVec2 *, const rglVec2 *, int *, rglVec3 *const);
    void get_vertices_at_area_with_normal_limit(const rglVec2 *, const rglVec2 *, float, int *, rglVec3 *const, const rglPhysics_material **const);
    char check_point_can_see_point(const rglVec3 *a2, const rglVec3 *a3, rglVec3 *a4, rglInt_vec2 *a5);
    int get_grid_index(int *a2, float *a3);
    rglTerrain_map(const rglVec3 *, float, int, const rglInt_vec2 *);
    ~rglTerrain_map();
    void clear();
    void create_nodes();
    void clamp_u(const rglVec3 *, float *, const rglVec2 *, const rglVec2 *, int, int);
    void get_triangle_corners_of_point_list(int, int, int *const);
    void add_skirt_to_occluder_body_of_node(int a2, int a3, char a4, rglPhysics_shape *a5);
    void calculate_occluder_bodies_for_all_lods();
    void update_min_max_min_heights();
};

class *rglResource_cache
{
public:
    const get_default_texture_name();
};

class rglAnim_node_inverse_kinematics
{
public:
    float get_target_weight();
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_foot *);
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_ladder_foot *);
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_rider_foot *);
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_hand_global *);
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_hand_global_with_distance *);
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_hand_entitial_displacement *);
    void rglIK_solver_definition(const rglAnim_node_inverse_kinematics::rglIK_solver_definition::rglIK_solver_definition_hand_relative_to_bone *);
    void set_target_weight(float a2, float a3, char a4);
    void set_ik_blend_weight(float);
    __int128 rglIK_solver_definition(__int128 *a2);
    __int64 rglIK_solver_definition(__int64 a2);
    rglAnim_node_inverse_kinematics(const rglAnim_node_inverse_kinematics *);
    __int64 operator=(__int64 a2);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, int a6);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, _OWORD *a6, int a7);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, _OWORD *a6, int a7);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, __int64 a6, int a7);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, _OWORD *a6, int a7);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, _OWORD *a6, int a7);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, _OWORD *a6, int a7);
    __int64 rglIK_solver_definition(char a2, char a3, char a4, int a5, __int64 a6, int a7);
    rglAnim_node_inverse_kinematics();
    void update_solver(const rglAnim_node_inverse_kinematics::rglIK_solver_definition *);
    __int64 ik_analytic(float *a2, float a3, float a4, float a5, float a6);
    void solve_ik_ccd_fabrik(rglAnim_result *a2, const rglMatrix_frame *a3, const rglSkeleton_model *a4, int a5, float a6, float a7, bool a8, bool a9);
    void solve_ik(rglAnim_result *a2, const rglMatrix_frame *a3, const rglSkeleton_model *a4, float a5);
    void integrate(rglAnim_result *a2, const rglMatrix_frame *a3, const rglSkeleton *a4, float a5, bool a6);
    void initialize(const rglSkeleton *);
    void tick(float a2, const rglSkeleton *a3);
    void update_relative_bone_distance(const rglVec3 *);
};

class rglOrbiting_camera_controller
{
public:
    float get_camera_distance_move_speed();
    void set_orbit_center(const rglVec3 *);
    void set_camera_distance(float);
    void set_orbit_center_offset(const rglVec3 *);
    void set_camera_move_speed(float);
    void set_scene_bounding_box_affects_distance(char a2);
    rglOrbiting_camera_controller(const rglOrbiting_camera_controller *);
    rglOrbiting_camera_controller(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    void reset();
    void scene_bounding_box_updated(const rglVec3 *, const rglVec3 *);
    void set_camera_frame(const rglMatrix_frame *);
    void update_camera(float);
    void look_at(const rglVec3 *, const rglVec3 *, const rglVec3 *);
    void handle_pan_camera(float, float);
    void handle_orbit_camera(float, float);
    void handle_control_key_aux(float);
    void handle_mouse_movement(float, float *, float *);
    void copy_from(const rglCamera_controller *);
};

class rglTerrain_node
{
public:
    _QWORD get_node_index(_QWORD *a2);
    __int64 get_node_index_y();
    __int64 get_lowest_detail_level();
    __int64 get_materialmap_detail_level(int);
    void set_vertex_count_along_axis_of_highest_detail_level(int);
    __int64 get_vertex_count_along_axis_of_highest_detail_level();
    __int64 get_vertex_count_along_axis_of_normalmap();
    __int64 size_of();
    char get_is_layer_used(char a2, int a3);
    __int64 set_is_layer_used(char a2, int a3);
    __int64 reset_is_layer_used(char a2, int a3);
    rglTerrain_node(const rglTerrain_node *);
    __int64 operator=(__int64 a2);
    rglTerrain_node(const rglTerrain *, rglScene *, int, int);
    ~rglTerrain_node();
    void create_textures_from_folder(const rglVarString *, int, int);
    void create_textures_from_folder_v2(__int64 a2, __int64 a3, rglBuffer *a4);
    void create_textures_from_folder_v3(int, int, rglBuffer *);
    void read_terrain_node_layers_and_heightmap_version1(char *DstBuf, int, int, int, const rglVarString *);
    void read_terrain_node_layers_and_heightmap_version0(char *DstBuf, int, int, int, const rglVarString *);
    void set_terrain_mesh_params(int, int);
    void set_detail_level(float);
    __int64 get_point_index_of_heightmap(unsigned int a2);
    float get_quad_len_of_highest_detail_level();
    void build_physics(rglScene *a2, rglTerrain_map_node *a3);
    void set_layer_image(int, rglImage *);
    void update_layer_mip_image(int);
    void set_normalmap_image(rglImage *);
    __int64 get_heightmap_texture();
    void set_heightmap_texture(__int64 *a2);
    void set_normalmap_texture(__int64 *a2);
    void set_heightmap_image(rglImage *);
    void transfer_to_physics_engine(rglScene *a2, rglTerrain_map_node *a3);
    bool get_is_layer_used_in_any_season(char a2);
    void set_weightmap_indices_to_render_mesh();
    float get_max_height();
    bool is_at_highest_detail_level();
    void adjust_scale();
    float get_quad_len_of_heightmap();
    void finalize();
    void delete_terrain_points_material_only();
    float get_ao_of_point(int);
    void init_from_desc_v2_3(const rglVarString *, const rglTerrain_node_desc *, int, int, rglTerrain_layer_instance **const, rglBuffer *, int);
    void init_from_desc_v4(const rglVarString *a2, const rglTerrain_node_desc *a3, __int64 a4, int a5, rglTerrain_layer_instance **const a6, rglBuffer *a7, int a8);
    void init_from_desc(const rglVarString *a2, const rglTerrain_node_desc *a3, unsigned int a4, int a5, rglTerrain_layer_instance **const a6);
};

class rglEnvironment_map_manager
{
public:
    __int64 get_water_probe_index();
    void update_global_probe_index_cache();
    void update_water_probe_index_cache();
    rglEnvironment_map_manager(const rglEnvironment_map_manager *);
    __int64 operator=(__int64 a2);
    void update(rglRender_context *);
    void update_parameters_to_gpu(char a2);
    void render_scattermap_at_position(rglRender_context *, const rglVec3 *, rglTexture *, rglTexture *, rglEnvironment_map_probe_record *, int);
    void render_env_map_at_position(__int64 a2, __int128 *a3, rglPhysics_engine_body *a4, unsigned __int16 *a5, __int64 a6, int a7, rglPhysics_engine_body **a8, __int64 a9, char a10);
    rglEnvironment_map_manager(rglScene *);
    void write_gbuffer_textures(const rglString_base *);
    char remove_probe(rglEnvironment_map_probe_record *a2);
    __int64 get_ideal_probe_position(__int64 a2);
    char probes_ready();
    void ensure_global_environment_map();
    rglEntity create_probe_at_position(rglEntity **a2, __int128 *a3, char a4);
    __int64 create_water_probe(__int64 *a2);
    void enable_default_probe();
    ~rglEnvironment_map_manager();
    double phi();
    void generate_hammersley_samples(int);
    void filter_cubemap_face(rglTexture *, int, int);
    rglRagdoll_bone filter_cubemap(rglTexture *a2);
    __int64 get_hammersley_texture();
    void save_envmap_textures();
    void set_update_enmap_at_runtime(char a2);
    __int64 get_update_enmap_at_runtime();
    void set_env_maps_of_rc(rglRender_context *);
};

class rglController
{
public:
    rglController(const rglController *);
    rglController(__int64 a2);
    __m128i operator=(__m128i *a2);
    __int64 operator=(__int64 a2);
    void register_button_event(char a2, char a3);
    rglController();
    void check_connection();
    void update_state();
    bool is_connected();
    __int64 register_event(char a2, __int64 a3);
    void vibrate_motors(float, float, float);
};

class rglMouse
{
public:
    float get_mouse_one_dent_scroll_value();
    ~rglMouse();
    rglMouse(const rglMouse *);
    rglMouse(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglMouse();
    void lock_cursor_at_pixel_pos(unsigned int a2, unsigned int a3);
    void unlock_cursor();
    void update_state();
    void handle_wheel_event(int);
    void handle_move_event(float, float);
    void handle_mouse_button_event(char a2, char a3);
    float get_move_x();
    float get_move_y();
    __int64 get_mouse_scroll();
};

class rglKeyboard
{
public:
    rglKeyboard(const rglKeyboard *);
    rglKeyboard(__int64 *a2);
    __m128i operator=(__m128i *a2);
    __int64 operator=(__int64 *a2);
    ~rglKeyboard();
    rglKeyboard();
};

class rglInput
{
public:
    void `default();
    rglInput(char a2);
    ~rglInput();
    void update_keys();
    __int16 update_key_state(unsigned __int8 a2, __int64 a3);
    void clear_event_queues();
    void tick(float);
    _QWORD key(_QWORD *a2, int a3);
    void set_key_handled(int a2, char a3);
    bool key_down(int);
    bool key_pressed(int);
    bool key_released(int);
    __int64 is_mouse_active();
    float mouse_move_x();
    float mouse_move_y();
    __int64 get_mouse_scroll();
    void reset_async_keys();
    void reset_event_accumulators();
    void reset_messages_received_this_frame_data();
    void clear_keys();
    void handle_event(int a2, float *a3);
    void fill_default_key_descriptions();
    rglVarString get_key_description(rglVarString *a2, __int64 a3);
};

class rglWorld_position
{
public:
    rglWorld_position();
    rglWorld_position(const rglWorld_position *);
    void set_scene(rglScene *);
    __int64 operator=(__int64 a2);
    bool operator==(__int64 a2);
    bool operator!=(__int64 a2);
    float get_x();
    float get_y();
    float get_ground_z();
    float get_nav_mesh_z();
    void on_navigation_mesh_face_removed(const rglNav_mesh_face *);
    __int64 invalid();
    bool is_valid();
    void validate_z(int a2);
    _DWORD get_nav_mesh_vec3(_DWORD *a2);
    _DWORD get_ground_vec3(_DWORD *a2);
    rglWorld_position(rglScene *, const rglVec3 *, const rglNav_mesh_face *, const rglNav_mesh_face *, bool);
    void set_vec2(const rglVec2 *);
};

class rglPath_node
{
public:
    void set_color(const rglVec3 *);
    rglPath_node(const rglPath_node *);
    __int64 operator=(_OWORD *a2);
    __int64 get_closest_point_to_position(__m128 *a2, __m128 *a3, float *a4, int a5);
    __int64 hermite_interpolate_two_point(__m128 *a2, __m128 *a3, float a4);
    __int64 linear_interpolate_two_point(_QWORD, _QWORD);
    rglPath_node(const rglMatrix_frame *, void *);
    rglPath_node();
    void set_frame(const rglMatrix_frame *a2, int a3, char a4);
    ~rglPath_node();
};

class rglPath
{
public:
    ~rglPath();
    void set_is_visible(char a2);
    rglPath(rglScene *);
    rglPath(const rglString_base *, rglScene *);
    rglPath(const rglPath *);
    float get_total_length_hermite();
    float get_total_length_linear();
    float get_arc_length_hermite(unsigned int);
    float get_arc_length_linear(unsigned int);
    __int64 get_frame_wrt_distance_linear(__int64 a2, float a3);
    __int64 get_frame_wrt_distance_cubic(_QWORD *a2, float a3, __int128 *__struct_ptr a4);
    rglVarString get_interpolation_type_name(rglVarString *a2);
    __int64 get_interpolation_type_from_name(rglString_base *a2);
    __int64 append_node(const rglMatrix_frame *a2, void *a3);
    __int64 insert_node(const rglMatrix_frame *a2, void *a3, unsigned int a4);
    void delete_node(unsigned int);
    __int64 get_node_frames(__int64 a2);
    void get_nodes(__int64 a2);
    void set_node_frame(const rglMatrix_frame *a2, __int64 a3);
    __int128 get_node_frame(__int64 a2);
    void set_node_custom_data(unsigned int, void *);
    float get_arc_length(unsigned int);
    __int64 get_arc_index(float);
    float get_total_length();
    _OWORD get_closest_frame_to_position(__int64 a2, float *a3);
    __int64 get_frame_wrt_distance(__int64 a2, float a3, unsigned int a4);
    __int64 get_frame_wrt_distance(rglPath *a2, float a3, __int128 *a4);
    void get_data_wrt_distance(void *, float, unsigned int);
    bool get_data_wrt_distance(void *, float);
    __int64 get_intersecting_point(__int64 a2, float *a3, float *a4);
    void intersect_point_with_ray(const rglVec3 *, const rglVec3 *, const rglVec3 *, float *);
    void read(__int64 a2);
    void write(__int64 a2, __int64 a3);
    void ensure_cache_valid();
    void recompute_cache();
    void ensure_debug_mesh_cache_valid();
    void recompute_rendered_debug_mesh_cache();
    void calculate_distances();
    void snap_all_points_to_terrain(char a2, __int64 a3);
    void auto_tangent_for_bezier();
    bool flag_exists(int a2);
    void add_flag(int a2);
    void remove_flag(int a2);
    bool check_valid();
    bool check_if_debug_meshes_valid();
    void set_name(const rglString_base *);
    __int64 get_interpolation_type();
    void set_interpolation_type(int a2);
    __int64 get_node_count();
    void set_node_color(int, const rglVec3 *);
    void prepare_render_meshes();
    __int64 get_path_version();
    void read_flags(__int64 a2);
    void read_binary(rglBuffer *);
    void write_binary(rglBuffer *);
    void set_owner_scene(rglScene *);
};

class rglPath_manager
{
public:
    void set_scene(rglScene *);
    void add_path(rglPath *);
    char operator=(__int64 **a2);
    void clear();
    ~rglPath_manager();
    _QWORD get_path_with_name(_QWORD *a2, const rglString_base *a3);
    void add_path(const rglString_base *a2);
    __int64 write(__int64 a2, __int64 a3);
    void read(__int64 a2);
    void get_all_paths(__int64 **a2);
    bool change_name_of_path(rglPath *, const rglString_base *);
    void delete_path_with_name(const rglString_base *);
    __int64 get_number_of_path_with_name_prefix(const rglString_base *a2);
    __int64 get_paths_with_name_prefix(__int64 a2, const rglString_base *a3);
    void write_binary(rglBuffer *);
    void read_binary(rglBuffer *a2);
    __int64 get_intersecting_point(__int64 a2, float *a3, float *a4);
};

class rglFlora_entity
{
public:
    __int64 get_flora_kind_id();
    __int64 get_variation_no();
    _QWORD get_body(_QWORD *a2);
    rglFlora_entity(const rglFlora_entity *);
    rglFlora_entity();
    ~rglFlora_entity();
    void initialize(const rglMatrix_frame *a2, int a3, int a4, const rglColor *a5);
    __int64 get_meta_mesh(int a2);
    void fix_frame();
    void set_frame(const rglMatrix_frame *);
    _QWORD write(__int64 a2, __int64 a3);
    void read(__int64 a2);
    void align_to_terrain(float a2, __m128 *a3);
    void recompute_bounds();
    void read_binary(rglBuffer *, rglVarString *);
    void write_binary(rglBuffer *);
};

class rglSoftware_occlusion_rasterizer
{
public:
    rglSoftware_occlusion_rasterizer(const rglSoftware_occlusion_rasterizer *);
    __int64 operator=(_QWORD *a2);
    rglSoftware_occlusion_rasterizer();
    __int64 rasterize(__int64 a2);
    ~rglSoftware_occlusion_rasterizer();
    void init();
    __int64 add_occluder(_QWORD *a2);
    __int64 get_occluder_count();
    void debug_render_occluders(rglRender_context *);
    void display_rasterization_result();
    void remove_occluder(void *);
    void set_occluder_frame(void *, const rglMatrix_frame *);
    void set_occluder_flags(void *a2);
    void dispatch_rasterization_tasks(const rglSoftware_occlusion_rasterization_params *);
    void wait_rasterization_tasks();
    char check_bounding_box_visibility(const rglBounding_box *a2, const rglMatrix_frame *a3);
    char check_bounds_visibility(const rglObject_bounds_cache *a2);
};

class rglParticle_emitter_editer
{
public:
    rglParticle_emitter_editer(const rglParticle_emitter_editer *);
    void finalize_editing();
    rglParticle_emitter_editer(rglPhysics_engine_body **a2);
    ~rglParticle_emitter_editer();
};

class rglParticle_effect
{
public:
    __int64 get_root_emitter_count();
    _OWORD get_guid(_OWORD *a2);
    __int64 get_version();
    void increment_version();
    _QWORD get_base_effect(_QWORD *a2);
    __int64 is_original();
    char has_always_emit_emitter();
    void set_base_efect(rglMemory_block_typeless **a2);
    ~rglParticle_effect();
    __int64 read();
    _BYTE write(__int64 a2, __int64 a3, __int64 a4);
    void write_simple(__int64 a2, __int64 a3);
    _QWORD create_copy(__int64 a2);
    char remove_root_emitter(const rglParticle_emitter_definition *a2);
    _QWORD get_root_emitter(_QWORD *a2, int a3);
    void update(void *a2);
    void break_prefab();
    __int64 get_all_emitter_definitions(__int64 a2);
    _BOOL8 get_is_decal_creation_active();
    void set_sound_code(const rglString_base *);
    char check_prefab_pointer_correctness();
    char check_xml_hierarchy_correctness(__int64 a2);
    void add_root_emitter(__int64 *a2);
    rglParticle_effect();
};

class rglParticle_cluster
{
public:
    rglParticle_cluster(rglScene *);
    ~rglParticle_cluster();
    bool is_alive();
    bool should_create_decal();
    rglParticle_cluster(const rglParticle_cluster *);
    __int64 operator=(__int64 a2);
    void set_bbox_external(const rglBounding_box *);
};

class rglParticle_emitter
{
public:
    void clear_child_emitters();
    void set_enable(char a2);
    void clear_particles();
    rglParticle_emitter(const rglParticle_emitter *);
    __int64 operator=(__int64 a2);
    void tick(float, const rglMatrix_frame *, const rglMatrix_frame *);
    void tick(float, rglParticle_cluster *);
    void tick_internal(float, const rglMatrix_frame *, const rglMatrix_frame *);
    rglParticle_emitter(rglScene *, rglParticle_system_instanced *, const rglParticle_emitter_definition *);
    ~rglParticle_emitter();
    bool is_alive();
    void reset();
    char has_alive_particle();
    __int64 set_collision_entities(__int64 **a2);
};

class rglNative_script_component
{
public:
    __int64 get_type_id();
    void add_variable_definition(const rglString_base *, void *, int);
    rglNative_script_component(const rglNative_script_component *);
    __int64 get_type_name(__int64 a2);
    rglNative_script_component(rglEntity *, rglScript_component_definition *);
    void copy_variables_from(rglScript_component *a2, char a3);
    void get_field_value_of_type(const rglString_base *, rglScript_component_field_holder *, int);
    __int64 get_type_of_field(const rglString_base *);
    rglVarString get_field_class_name(rglVarString *a2, const rglString_base *a3);
    void set_field_value_of_type(const rglString_base *, rglScript_component_field_holder *, int, bool);
};

class rglTrail
{
public:
    rglTrail();
    __int64 circular_index(char a2, char a3);
    ~rglTrail();
    rglTrail(const rglTrail *);
    rglTrail(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    void reset();
    void tick(const rglVec3 *, const rglVec3 *, float);
    void update_mesh(float, const rglMatrix_frame *);
};

class rglTrail_manager
{
public:
    ~rglTrail_manager();
    rglTrail_manager(_QWORD *a2);
    rglTrail_manager();
    __int64 get_new_trail(char a2);
    void free_trail(int);
    void clear_all();
    void update_trail_position(int a2, const rglVec3 *a3, const rglVec3 *a4);
    void update_meshes(float);
    void render_meshes(rglScene *a2, rglRender_context *a3);
    _QWORD get_mesh(_QWORD *a2, int a3);
    void set_manual_render(int a2, char a3);
};

class rglStartup_info
{
public:
    void add_param(const rglVarString *a2, const rglVarString *a3, char a4);
    char get_param(const rglVarString *a2, rglVarString *a3);
    __int64 is_test();
    bool is_render_on();
    void toggle_render();
    bool this_process_created_to_pack_a_specific_crf();
    ~rglStartup_info();
    rglStartup_info(const rglStartup_info *);
    rglStartup_info(char *a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglStartup_info();
    void all_startup_info_gathered();
};

class rglFace_anim_record
{
public:
    ~rglFace_anim_record();
    rglFace_anim_record();
    rglFace_anim_record(const rglFace_anim_record *);
    rglFace_anim_record(char *a2);
    __int64 operator=(__int64 a2);
    __int64 read(__int64 a2);
    void set_flag_with_name(const rglString_base *);
};

class rglAsset_import_definition
{
public:
    rglAsset_import_definition::Import_operation_parameter Import_operation_parameter();
    rglAsset_import_definition::Import_operation_parameter Import_operation_parameter(const rglAsset_import_definition::Import_operation_parameter *a2);
    _DWORD Import_operation_parameter(_DWORD *a2);
    _DWORD Import_operation_parameter(_DWORD *a2);
    void Import_operation();
    rglAsset_import_definition::Import_operation Import_operation(const rglAsset_import_definition::Import_operation *a2);
    __int64 Import_operation(__int64 a2);
    _DWORD Import_operation(_DWORD *a2);
    __int64 Import_operation(_DWORD *a2);
    rglAsset_import_definition::Import_operation_group Import_operation_group();
    void Import_operation_group();
    rglAsset_import_definition::Import_operation_group Import_operation_group(const rglAsset_import_definition::Import_operation_group *a2);
    __int64 Import_operation_group(rglString_base *a2);
    __int64 Import_operation_group(rglString_base *a2);
    __int64 Import_operation_group(rglString_base *a2);
    rglAsset_import_definition::Reader Reader(const rglAsset_import_definition::Reader *a2);
    ~rglAsset_import_definition();
    rglAsset_import_definition(_QWORD *a2);
    __int64 operator=(char **a2);
    __int64 operator=(__int64 *a2);
    __int64 get_import_operation_code();
    __int64 get_import_operation_parameter_code(const char *);
    __int64 get_operation_group_for_resource(const rglString_base *a2, int a3);
    rglAsset_import_definition::Reader Reader(const rglString_base *a2, rglAsset_import_definition *a3);
    bool operation_exists(const rglString_base *a2, int a3, int a4, int *a5, int *a6);
    void delete_operation(const rglString_base *a2, int a3, int a4, char a5);
    char Writer(const rglString_base *a2);
};

class rglCollision_effect_info
{
public:
    ~rglCollision_effect_info();
    rglCollision_effect_info();
    rglCollision_effect_info(const rglCollision_effect_info *);
    rglCollision_effect_info(_DWORD *a2);
    _DWORD operator=(_DWORD *a2);
};

class rglResource_compiler
{
public:
    char is_mesh_file();
    __int64 load_image_from_resource_file(_QWORD, _QWORD, _QWORD, _DWORD, _DWORD);
    __int64 load_image_from_memory(unsigned int a2, char **a3, rglBuffer *a4);
    char save_image(__int64 a2, int a3);
    __int64 find_full_texture_path(char a2);
    __int64 load_image_header(rglImage_header *a2);
    __int64 get_image_format();
    rglVarString get_tch_filename(rglString_base *a2);
    _BOOL8 texture_cache_should_be_updated(int a2);
    __int64 is_image_format_supported();
    char assign_vertex_colors_from_material();
    void convert_to_vertex_color_shaded_mesh();
    void whiten_vertex_color_shaded_mesh(float *a2);
    void assign_face_normals_to_vertices();
    bool ensure_image_runtime_support();
    bool create_normalmap_from_heightmap(rglImage *this, const rglVec2 *, float, unsigned int, rglBuffer *);
};

class rglManaged_interface
{
public:
    rglManaged_interface(const rglManaged_interface *);
    _QWORD operator=(_QWORD *a2);
    rglManaged_interface();
    ~rglManaged_interface();
    void on_init();
    void pass_managed_engine_callback_method_pointers(void *);
    __int64 get_type_of_field(const rglString_base *, const rglString_base *);
    void set_object_field_value(ftdnManaged_object_reference *a2, rglString_base *a3, __int64 a4, unsigned int a5, unsigned __int8 a6);
    void get_object_field_value(ftdnManaged_object_reference *a2, rglString_base *a3, __int64 a4, unsigned int a5);
    void get_class_editable_fields(rglString_base *a2, void **a3);
    bool check_managed_enabled();
};

class rglParallel_for_task
{
public:
    __int64 init(_QWORD, _QWORD, _QWORD, _DWORD, _DWORD, _QWORD, _QWORD, _QWORD);
    void run();
};

class rglFlora_render_task
{
public:
    __int64 get_render_patches();
    double get_computation_time();
    rglFlora_render_task(rglFlora_renderer *, rglSignal_event *);
    ~rglFlora_render_task();
    void initialize(rglRender_context *, int);
    void reset();
    void run();
};

class rglFlora_renderer
{
public:
    __int64 compute_flora_patch_lod_level(const rglVec3 *, const rglFlora_kind *, int, const rglVec3 *);
    void finalize_optimized_flora(rglTerrain_map *);
    __int64 get_flora_layers(int a2);
    _QWORD get_fading_out_grid_dimension(_QWORD *a2);
    float get_fading_out_grid_node_size();
    int get_billboard_grid_dimension(int *a2);
    float get_billboard_grid_node_size();
    __int64 get_flora_entities_size();
    rglFlora_renderer(rglScene *);
    ~rglFlora_renderer();
    void reset_all();
    void create_flora_nodes(const rglVec2 *a2, char a3);
    void create_billboard_entities_for_nodes(rglPlaced_flora_set *, int);
    void create_billboard_cache_nodes_without_billboards(rglPlaced_flora_set *a2);
    void create_billboard_cache_nodes(rglPlaced_flora_set *a2);
    void reset_flora_nodes();
    void validate_node_bounding_caches();
    void pre_render(rglRender_context *a2);
    void post_render(rglRender_context *);
    void process_render_patch(rglRender_context *, const rglFlora_render_patch *);
    void create_flora_system_render_patch_for_layer_set(rglRender_context *, const rglPlaced_flora_set *, rglFlora_render_patch *);
    void check_flora_sets_divide_into_nodes();
    __int64 get_flora_layers_assigned_to_terrain_layer(__int64 a2, int a3, int a4);
    __int64 get_flora_layers_assigned_to_terrain_layer_all_seasons(__int64 a2, int a3);
    void add_flora_layer_with_terrain_layer_index(rglFlora_renderer::Flora_layer *, int);
    void update_all_layers_procedural_floras(const rglTerrain *a2, int a3, char a4, bool a5);
    void update_all_procedural_flora(const rglTerrain *a2, int a3, char a4);
    __int64 check_resources(const rglCheck_resource_params *);
    void move_flora_entities_to_layers();
    __int64 get_billboard_meta_mesh_for_layer();
    __int64 get_current_flora_kind_names(_QWORD *a2, char a3, int a4);
    bool save_flora_billboard_to_file(rglMeta_mesh *);
    void on_billboard_albedo_render_complete();
    void on_billboard_normalmap_render_complete();
    void wait_for_cur_frame_render_task();
    __int64 add_flora_entity(_QWORD);
    void add_flora_entities(__int64 **a2);
    void remove_flora_entity(__int64 *a2);
    __int64 write_flora_entities(__int64 a2, __int64 a3);
    void write_flora_entities_binary(rglBuffer *);
    void clear_temporary_loaded_flora_entities();
    void update_procedural_flora_for_layer(__int64 a2, int a3, int a4, __int64 a5, int a6);
    void delete_flora_layers_assigned_to_layer(int, int);
    void remove_flora_layer(rglFlora_renderer::Flora_layer *, int);
    void write_batched_flora_data(const rglVarString *, int);
    void get_ao_from_flora_meshes(float *a2, __int64 a3);
    __int64 fill_sparse_flora_bounds_grid(float *a2, float *a3, __int64 a4);
    void update_billboard_textures_of_meta_mesh_imp(rglRender_context *, rglFlora_renderer::Billboard_generation_record *);
    void handle_pending_billboard_generations(rglRender_context *);
};

class rglWindow_manager
{
public:
    rglWindow_manager::Message_line_manager Message_line_manager();
    void Message_line_manager();
    __int64 Message_line_manager();
    void Message_line_manager();
    void add_overlay_meta_mesh_line(const rglVarString *a2, float a3, int a4, bool a5);
    void set_overlay_meta_mesh(rglMeta_mesh *a2, char a3);
    void set_overlay_meta_mesh_position(const rglVec2 *);
    float get_mouse_position_x();
    float get_mouse_position_y();
    float get_mouse_position_in_pixels_x();
    float get_mouse_position_in_pixels_y();
    float get_mouse_position_in_pixels(float *a2);
    float get_aspect_x();
    float get_aspect_y();
    float get_aspect_factor();
    bool is_chat_mode();
    void active_main_window_rendering();
    void deactive_main_window_rendering();
    void Message_line_manager();
    void Message_line_manager(float);
    void Message_line_manager(const rglVarString *, const int *);
    void Message_line_manager(rglRender_context *, float *);
    void Message_line_manager(const rglVarString *, int);
    __int64 Message_line_manager();
    void begin_frame();
    void end_frame();
    void post_qued_msg_line(const rglVarString *, int);
    void pop_msg_line_que();
    void post_message_line_non_debug(const rglVarString *, const int *);
    rglWindow_manager();
    void reset_double_click_timers();
    ~rglWindow_manager();
    void tick(float);
    void lock_cursor_at_position(float, float);
    void lock_cursor_position();
    void unlock_cursor_position();
    void pre_display();
    void display();
    void on_content_update(const rglString_base *);
    void print_used_postfx_memory(rglVarString *);
    void init();
    void clear_all_events();
    float get_screen_resolution_x();
    float get_screen_resolution_y();
    void on_window_size_change();
    void update_screen_info();
    void set_real_resolution(int, int);
    __int64 add_event_message(int a2);
    void set_mouse_visibility(__int64 a2);
    __int64 get_mouse_visibility();
    void set_application_mouse_visibility(unsigned __int8 a2);
    __int64 get_application_mouse_visibility();
    void copy_overlay_rc_properties(rglRender_context *a2);
    float world_to_screen_with_fixed_z(const rglCamera *a2, const rglVec3 *a3, const rglVec3 *a4, float *a5, float *a6, float *a7);
    float world_to_screen(const rglCamera *a2, const rglVec3 *a3, float *a4, float *a5, float *a6);
    void screen_to_world(const rglCamera *, float, float, float, rglVec3 *);
    float world_to_screen(const rglMatrix_frame *a2, const rglVec3 *a3, float *a4, float *a5, float *a6);
    void screen_to_world(const rglMatrix_frame *, float, float, float, rglVec3 *);
    float world_to_viewport(const rglVec3 *, float *, float *, __int64, int, float *);
    void setup_aspect();
    void render_mesh_to_rc(rglRender_context *a2, rglMesh *a3, const rglMatrix_frame *a4);
    void render_mesh_to_rc_sized(rglRender_context *a2, rglMesh *a3, const rglMatrix_frame *a4, const rglVec2 *a5);
    void add_cur_frame_debug_render_objects(rglRender_context *);
    void add_view(const rglView *);
    void get_main_window_viewport(rglViewport *);
    void on_shader_compile();
    void fetch_all_alive_view_descs(rglVarString *);
    __int64 get_view_count();
    void on_config_change();
    void on_physics_related_resource_change();
    void set_cursor_pos(int a2, int a3);
    bool is_mouse_on_screen();
    void enable_beta_indicator();
    void set_fps_limit(float);
    void enable_global_loading_window();
    void disable_global_loading_window();
    __int64 get_global_loading_window_state();
    bool is_game_window_focused();
    bool is_mouse_over_game_window();
    __int64 clip_cursor(const rglRect *a2);
    __int64 unclip_cursor();
    void tick_and_process_locked_cursor();
};

class rglInterpolation_manager
{
public:
    float get_value_at_frame(const rglVarString *, float);
};

class rglAnim_node_human_adjustments
{
public:
    void set_whole_body_position_difference(const rglVec2 *);
    void set_feet_correction_abdomen_body_rotation(float);
    void set_upper_body_position_difference(const rglVec2 *);
    rglAnim_node_human_adjustments(const rglAnim_node_human_adjustments *);
    __int64 operator=(__int64 a2);
    void integrate(rglAnim_result *, const rglSkeleton *, float, float, const rglQuaternion *, signed __int8, const rglVec3 *, float, float, signed __int8, const rglVec3 *, float, float, const rglVec3 *);
    void blend_bone_quat_to_target_quat_to_anim_result(const rglSkeleton_model *a2, rglAnim_result *a3, char a4, const rglQuaternion *a5, float a6);
    rglAnim_node_human_adjustments();
};

class rglAnim_foot_logical_data
{
public:
    float get_snapping_period();
    float get_adjusting_period();
    float get_cycle_left_until_next_snap_moment();
    bool get_snaps_to_ground();
    bool get_snaps_to_ground_for_sound();
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglAnim_foot_logical_data();
    void reset_ik_data();
    void reset_non_ik_data();
    void add_ik_data(float, const rglVec2 *, float, float, float);
    void initialize_from(const rglAnim_foot_logical_data *);
    void copy_from(const rglAnim_foot_logical_data *);
};

class rglAnim_subnode_human_walking
{
public:
    rglAnim_subnode_human_walking();
    rglAnim_subnode_human_walking(rglAnim_subnode_human_walking *);
    __int64 get_sound_points_of_anim(int a2);
    float get_maximum_upper_body_speed();
    float get_side_forward_loop_displacement();
    float get_side_backward_loop_displacement();
    float get_backward_loop_displacement();
    float get_forward_loop_displacement();
    float get_idle_root_bone_rotation();
    __int64 operator=(__int64 a2);
    float get_loop_displacement_of_anim(int a2);
    void setup(const rglSkeleton_model *a2, char a3, const rglAnimation_clip **const a4, float a5, float a6);
    void integrate(const rglSkeleton *, rglAnim_result *, rglAnim_result *, const float *const, const rglVec2 *, float, float, float, float, float, float, rglAnim_playback_record *const, rglAnim_foot_visual_data *const, bool);
    void create_ik_period_data(const float *const, float, float, float, rglAnim_foot_logical_data *const);
    float get_cycle_adder(const rglVec2 *, float);
    float get_speed_multiplier_for_quick_switch();
    float get_snapping_range(float *a2, int a3, int a4);
    float get_snapping_period(int, int);
    float get_adjusting_period(int, int);
    float get_anim_clip_duration(int a2);
    __int64 get_snap_position_for_bone(__int64 a2, __int64 a3, char a4, float *a5, float *a6, float a7, float a8, float a9, float a10, float a11);
};

class rglAnim_subnode_human_riding
{
public:
    rglAnim_subnode_human_riding();
    _QWORD operator=(_QWORD *a2);
    __int64 get_animation_clip(int a2);
    void get_enforcements(const rglSkeleton_model *a2, float *const a3, char a4);
    void setup(const rglAnimation_clip **const, const rglAnimation_clip **const);
    void integrate(const rglSkeleton *a2, rglAnim_result *a3, rglAnim_result *a4, rglAnim_bone_entitial_frame_result *a5, float a6, float a7, rglAnim_node_human_riding *a8, const float *a9);
};

class rglAnim_subnode_human_riding_set
{
public:
    rglAnim_subnode_human_riding_set();
    ~rglAnim_subnode_human_riding_set();
    void setup(const rglAnimation_clip *(*const);
};

class rglVirtual_data_reader
{
public:
    _QWORD operator=(_QWORD *a2);
    rglVirtual_data_reader(const rglVirtual_data *);
};

class rglAnim_human_movement_layer
{
public:
    rglAnim_human_movement_layer();
    __int64 get_key();
    void set_key(int);
    bool is_valid();
    bool same_as(const rglAnim_human_movement_layer *);
    bool same_as(int);
    void operator=(const void *a2);
    _DWORD operator=(__int64 a2);
    void tick(float a2, float a3, const float *const a4, float a5, float a6, float a7);
    void reset();
    void copy_from(const rglAnim_human_movement_layer *);
    void initialize_from(const rglAnim_human_movement_layer *, const rglAnim_human_movement_layer *);
    __int64 get_toe_position_at_snap_moment(__int64 a2, __int64 a3, int a4, float *a5, float *a6, float a7, float a8, float a9, float a10, float a11);
    void on_manual_position_set();
};

class rglAnim_node_horse_adjustments
{
public:
    float get_body_slope();
    float get_entitial_height_difference();
    void set_target_body_rotation(float);
    rglAnim_node_horse_adjustments(const rglAnim_node_horse_adjustments *);
    _DWORD operator=(_DWORD *a2);
    rglAnim_node_horse_adjustments();
    void integrate(rglAnim_result *a2, const rglSkeleton *a3, float a4, bool a5);
    void tick(float, const rglSkeleton *);
};

class rglAnim_node_horse_movement
{
public:
    float get_idle_cycle();
    float get_walking_cycle();
    float get_turn_strafe_cycle();
    __int64 get_num_paces();
    __int64 operator=(__int64 a2);
    rglAnim_node_horse_movement();
    rglAnim_node_horse_movement(const rglAnim_node_horse_movement *);
    ~rglAnim_node_horse_movement();
    void setup(int, rglAnim_subnode_horse_walking *);
    void set_inputs(char a2, const rglVec2 *a3, float a4);
    __int64 find_new_pace(float);
    void tick(float, const rglSkeleton *);
    void integrate(rglAnim_result *a2, const rglSkeleton *a3);
    void get_enforcements(const rglSkeleton_model *a2, float *const a3, char a4);
    __int64 get_strongest_clip_id();
    float get_pace_limit(int a2, char a3);
    float get_idle_duration();
    void copy_from_base_for_reference(const rglAnim_node_horse_movement *);
    float get_walking_speed_limit();
    void print_debug_messages();
};

class rglAnimation_clip_quadrupedal_movement_data
{
public:
    rglAnimation_clip_quadrupedal_movement_data();
    void deserialize(__int64 a2);
    rglAnimation_clip_quadrupedal_movement_data(const rglAnimation_clip_quadrupedal_movement_data *);
    _DWORD operator=(_DWORD *a2);
};

class rglAnimation_clip_bipedal_movement_and_ik_data
{
public:
    rglAnimation_clip_bipedal_movement_and_ik_data();
    void deserialize(__int64 a2);
    rglAnimation_clip_bipedal_movement_and_ik_data(const rglAnimation_clip_bipedal_movement_and_ik_data *);
    _DWORD operator=(_DWORD *a2);
};

class rglAnimation_clip_displacement_data
{
public:
    rglAnimation_clip_displacement_data();
    _QWORD serialize(__int64 a2, __int64 a3, char a4);
    __int64 deserialize(__int64 a2);
    rglAnimation_clip_displacement_data(const rglAnimation_clip_displacement_data *);
    __int64 operator=(__int64 a2);
};

class rglAnimation_clip_blend_data
{
public:
    rglAnimation_clip_blend_data();
    void deserialize(__int64 a2);
    rglAnimation_clip_blend_data(const rglAnimation_clip_blend_data *);
};

class rglEmbree_scene
{
public:
    rglEmbree_scene();
    __int64 current_face_count();
    rglEmbree_scene(const rglEmbree_scene *);
    void operator=(void **a2);
    ~rglEmbree_scene();
    void add_vertices(char **a2);
    __int64 add_triangles(__int64 *a2);
};

class rglAnim_subnode_horse_walking
{
public:
    _QWORD operator=(_QWORD *a2);
    __int64 get_anim_movement_data(int a2);
    void setup(const rglAnimation_clip **const);
    void integrate(rglAnim_result *a2, const rglVec2 *a3, float a4, float a5, float a6, float a7, float a8, float *const a9, rglAnim_playback_record *const a10, float a11, float a12, float a13, bool a14, const rglSkeleton *a15);
    float get_forward_cycle_duration(float);
    float get_turn_cycle_adder(float);
    float get_strafe_cycle_duration(float);
};

class rglAnim_node_human_riding
{
public:
    void operator=(const void *a2);
    rglAnim_node_human_riding();
    ~rglAnim_node_human_riding();
    void setup(const rglAnim_subnode_human_riding_set *);
    void integrate_with_horse_node(const rglSkeleton *, rglAnim_result *, rglAnim_result *, rglAnim_bone_entitial_frame_result *, rglAnim_node_horse_movement *);
};

class *rglAnimation_clip
{
public:
    struct get_default_hand_animation();
};

class rglWindows_platform
{
public:
    ~rglWindows_platform();
    rglWindows_platform(const rglWindows_platform *);
    _QWORD operator=(_QWORD *a2);
    rglWindows_platform();
    void initialize(rglEngine_interface *, void *);
    void frame_move();
    void final_cleanup();
    char clipboard_paste_string(const char *a2);
    char clipboard_get_string(rglVarString *a2);
    void show_window();
    void hide_window();
    HIMC get_input_context_of_current_window();
    HIMC associate_input_context_to_current_window(HIMC);
    BOOL set_cursor_pos(__int64 a2);
    __int64 monitor_enum_proc(HDC a2, LPRECT a3);
    LRESULT static_msg_proc(UINT Msg, WPARAM wParam, LPARAM lParam);
    LRESULT msg_proc(HWND hWnd, UINT Msg, __int64 a4, LPARAM lParam);
    void create_window();
    void enumerate_monitors();
    void register_raw_input_devices();
    void process_raw_event(const struct tagRAWINPUT *);
    void handle_wm_input(__int64 a2, HRAWINPUT a3);
    void process_window_messages();
    _DWORD get_client_window_resolution(_DWORD *a2);
    BOOL change_window_state(int a2, LONG a3, LONG a4);
    void set_window_title(const rglVarString *);
    int get_desktop_dimensions(int *a2);
    bool clip_cursor(const rglRect *);
    char set_cursor(int a2);
    int show_cursor(char a2, unsigned int a3);
    void load_cursor(int a2, char *a3);
    void save_window_rect();
    void save_window_repositioning();
    void load_window_repositioning();
    bool is_extended_key();
    UINT get_key_code(int a2);
};

class rglAtmosphere_info
{
public:
    __int64 operator=(__int64 a2);
};

class rglAtmosphere_manager
{
public:
    rglAtmosphere_manager();
    __int64 get_atmosphere_count();
    void set_enforced_atmosphere_name(const rglString_base *);
    ~rglAtmosphere_manager();
    rglAtmosphere_manager(const rglAtmosphere_manager *);
    rglAtmosphere_manager(_DWORD *a2);
    __int64 operator=(rglString_base *a2);
    __int64 operator=(unsigned __int64 a2);
    void load_atmospheres(__int64 a2, __int64 a3, int a4);
    void reset();
    void update_atmosphere_template(int, const rglAtmosphere *);
    __int64 get_atmosphere_index(const rglString_base *);
    __int64 setup_atmosphere_from_game(__int64 a2, float *a3);
    __int64 setup_atmosphere(__int64 a2, float *a3, float a4, int a5, unsigned __int8 a6);
    void init();
    void load_skyboxes();
    void sort_atmospheres();
};

class rglCamera_controller
{
public:
    void set_size(int, int);
    __int64 get_viewport_width();
    __int64 get_viewport_height();
    float get_viewport_size(float *a2);
    float get_aspect_ratio();
    void set_camera_frame(const rglMatrix_frame *);
    void set_input(rglInput *);
    void set_client_cursor_pos(int, int);
    void set_screen_cursor_pos(int, int);
    void enable();
    void disable();
    void look_at(const rglVec3 *, const rglVec3 *, const rglVec3 *);
    void set_name(const rglVarString *);
    void set_fov_vertical(float);
    float get_fov_vertical();
    void set_near(float);
    void set_far(float);
    rglCamera_controller(const rglCamera_controller *);
    rglCamera_controller(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglCamera_controller();
    void reset();
    void copy_from(const rglCamera_controller *);
};

class rglOrthographic_camera_controller
{
public:
    ~rglOrthographic_camera_controller();
    void set_zoom_limits(float, float);
    void set_position(const rglVec3 *);
    void set_aspect_ratio(float);
    rglOrthographic_camera_controller(const rglOrthographic_camera_controller *);
    rglOrthographic_camera_controller(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglOrthographic_camera_controller();
    void reset();
    void update_camera(float);
    void set_side(int a2);
    void set_size(float);
    void copy_from(const rglCamera_controller *);
};

class rglFree_camera_controller
{
public:
    void set_cam_speed_multiplier(float);
    void set_position(_OWORD *a2);
    void set_rotate_about_offset(char a2);
    _OWORD get_euler_angles(_OWORD *a2);
    _OWORD get_position(_OWORD *a2);
    _OWORD get_local_position(_OWORD *a2);
    void set_local_position(_OWORD *a2);
    rglFree_camera_controller(const rglFree_camera_controller *);
    rglFree_camera_controller(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglFree_camera_controller();
    void reset();
    void set_camera_frame(const rglMatrix_frame *);
    void update_camera(float a2, __int64 a3);
    void look_at(const rglVec3 *, const rglVec3 *, const rglVec3 *);
};

class rglHotkey_manager
{
public:
    rglHotkey_manager(const rglHotkey_manager *);
    void operator=(void **a2);
    rglHotkey_manager();
    ~rglHotkey_manager();
    __int64 register_hotkey(int a2, _DWORD *a3);
    void unregister_hotkey(int a2);
    bool is_hotkey_triggered(int a2);
    bool is_control_down();
    bool is_alt_down();
    bool is_shift_down();
    bool is_editor_key_triggered(rglInput *a2, int a3, int a4);
    void remove_input(rglInput *);
    bool check_hotkey(rglInput *, const rglHotkey_manager::Hotkey *);
    char is_modifier(int a2);
};

class rglCamera_object
{
public:
    __int64 get_type_id();
    ~rglCamera_object();
    rglCamera_object(const rglCamera_object *);
    rglCamera_object(const rglReference_counted_object *a2);
    __int64 get_type_name(__int64 a2);
    _QWORD get_entity(_QWORD *a2);
    void set_entity(rglMemory_block_typeless **a2);
    __int64 look_at(__int128 *a2, __int128 *a3, __int128 *a4);
    void set_frame(const rglMatrix_frame *);
    rglCamera_object();
    void render_frustrum();
    void set_rgl_camera(const rglCamera *);
};

class rglCloth_cooking_task
{
public:
    void compute_misc_values(int a2, __int64 a3, __int64 *a4, _QWORD *a5, void *a6, char *a7, _BYTE *a8, _BYTE *a9, int a10, int a11, __int64 a12, __int64 a13);
    char compute_anchor_constraints(int a2, int a3, _DWORD *a4, __int64 a5, __int64 a6, __int64 a7, char **a8, __int64 *a9);
    __int64 fix_dummy_particle_indices(_QWORD *a2);
    __int64 compute_vertex_map(_DWORD *a2, _DWORD *a3, char **a4, int a5, __int64 a6, __int64 a7);
    rglCloth_cooking_task(rglMemory_block_typeless **a2);
};

class rglCloth_cook_read_task
{
public:
    rglCloth_cook_read_task(rglMeta_mesh *a2);
    void run();
};

class rglCloth_map_read_task
{
public:
    rglCloth_map_read_task(rglMeta_mesh *a2);
    void run();
};

class rglParticle_system_manager
{
public:
    _QWORD get_hardcoded_particle_effect_by_name(_QWORD *a2, const char *a3);
    ~rglParticle_system_manager();
    rglParticle_system_manager(const rglParticle_system_manager *);
    rglParticle_system_manager(rglString_base *a2);
    __int64 operator=(_DWORD *a2);
    __int64 operator=(unsigned __int64 a2);
    void load_particle_effects();
    _QWORD get_particle_effect_by_name(_QWORD *a2, const rglString_base *a3);
    _QWORD get_particle_effect_by_guid(_QWORD *a2, __int64 a3);
    _QWORD get_particle_effect_by_network_id(_QWORD *a2, int a3);
    _QWORD get_all_effect_names(void **a2);
    __int64 get_runtime_id_by_name(const rglString_base *);
    _QWORD create_particle_system(_QWORD *a2);
    rglParticle_system_manager();
    void init();
    void refresh_guid_map();
    void refresh_network_id_map();
    void clean_up();
    void save_particle_effects();
    rglParticle_effect create_particle_effect_from_old_parameters(_QWORD *a2);
    __int64 create_particle_emitter_from_old_parameters(__int64 a2);
    char register_particle_effect(void *a2, __int64 a3);
};

class rglCommand_line_manager
{
public:
    rglCommand_line_manager(const rglCommand_line_manager *);
    _QWORD operator=(__int64 *a2);
    ~rglCommand_line_manager();
    void toggle_imgui_console_visibility();
    void setup_item_tree();
    void execute_command(void *a2, const rglString_base *a3);
    __int64 get_arguments_of_command(rglString_base *a2);
    __int64 get_possible_commands_starting_with(__int64 a2, const rglString_base *a3, char a4);
    void get_all_possible_commands(void **a2);
    __int64 get_command_history_count();
    void get_command_from_history_with_index(void *a2, int a3);
    char add_managed_command(const rglVarString *a2);
};

class rglSound_manager
{
public:
    bool sounds_disabled_or_volume_low();
    __int64 scene_sounds_are_started();
    __int64 scene_sounds_are_playing();
    bool sound_can_be_heard_from_pos(const rglVec3 *);
    bool sound_can_be_heard_from_pos(const rglVec3 *, float);
    void get_sound_device_name(void *a2);
    void process_cur_frame_deleted_events();
    rglSound_manager();
    void load_event_file(const rglVarString *);
    void tick();
    void reset();
    void set_param_for_scene_sounds(rglScene *, const rglString_base *, float);
    ~rglSound_manager();
    _QWORD create_event(_QWORD *a2, const rglString_base *a3, __int64 a4, char a5);
    _QWORD create_event(_QWORD *a2, int a3, __int64 a4, char a5);
    _QWORD create_programmer_event(_QWORD *a2, const rglString_base *a3, __int64 a4, __int64 a5, __int64 a6, char a7);
    __int64 create_programmer_event(_QWORD, _QWORD, _QWORD, _QWORD, _DWORD);
    void release_event(int);
    __int64 start_event(int a2);
    __int64 check_event(int a2);
    void stop_event(int);
    _QWORD get_event(_QWORD *a2, int a3);
    __int64 is_event_playing(int a2);
    void set_event_parameter(int, const rglString_base *, float);
    void set_event_position(int, const rglVec3 *);
    __int64 free_event(int a2);
    void pause_scene_sounds(rglScene *);
    void resume_scene_sounds(rglScene *);
    void start_scene_sounds(rglScene *);
    void finish_scene_sounds(rglScene *);
    _QWORD check_and_get_free_sound_event_from_pool(_QWORD *a2);
    void add_sound_event_to_pool(rglSound_event *);
    void set_event_min_max_distance(int a2, __int128 *a3);
    void reload_sounds();
    __int64 get_sound_data_path(_QWORD);
    rglVarString get_sound_guids_file_path(rglVarString *a2);
    rglVarString get_sound_events_data_file_path(rglVarString *a2);
    void show_info_with_imgui();
};

class rglReplay_component_data
{
public:
    rglReplay_component_data();
    ~rglReplay_component_data();
    rglReplay_component_data(const rglReplay_component_data *);
    void write_data(rglBuffer *);
    void read_data(rglBuffer *a2, char a3);
    _QWORD operator=(__int64 a2);
};

class rglReplay_meta_mesh_data
{
public:
    ~rglReplay_meta_mesh_data();
    rglReplay_meta_mesh_data(const rglReplay_meta_mesh_data *);
    __int64 operator=(__int64 a2);
    void write_data(rglBuffer *);
    void read_data(rglBuffer *a2, char a3);
    void clear();
    rglReplay_meta_mesh_data();
    __int64 compare_data(rglReplay_component_data *a2);
};

class rglReplay_light_data
{
public:
    ~rglReplay_light_data();
    rglReplay_light_data(const rglReplay_light_data *);
    __int64 operator=(__int64 a2);
    void write_data(rglBuffer *);
    void read_data(rglBuffer *a2, char a3);
    void clear();
    rglReplay_light_data();
};

class rglReplay_particle_system_data
{
public:
    rglReplay_particle_system_data(const rglReplay_particle_system_data *);
    void write_data(rglBuffer *);
    void read_data(rglBuffer *a2, char a3);
    ~rglReplay_particle_system_data();
    void clear();
    rglReplay_particle_system_data();
    __int64 operator=(__int64 a2);
};

class rglReplay_unique_edit_data
{
public:
    rglReplay_unique_edit_data();
    ~rglReplay_unique_edit_data();
    rglReplay_unique_edit_data(const rglReplay_unique_edit_data *);
    __int64 operator=(__int64 a2);
    void clear();
    void write_data(rglBuffer *);
    void read_data(rglBuffer *);
};

class rglReplay_gpu_particle_data
{
public:
    ~rglReplay_gpu_particle_data();
    void clear();
    rglReplay_gpu_particle_data();
    rglReplay_gpu_particle_data(const rglReplay_gpu_particle_data *);
    __int64 operator=(__int64 a2);
};

class *rglReplay_gpu_particle_data
{
public:
    struct create_instance();
};

class rglReplay_composite_data
{
public:
    ~rglReplay_composite_data();
    rglReplay_composite_data(const rglReplay_composite_data *);
    __int64 operator=(__int64 a2);
    void write_data(rglBuffer *);
    void read_data(rglBuffer *a2, char a3);
    void clear();
    rglReplay_composite_data();
};

class rglReplay_cloth_simulator_data
{
public:
    rglReplay_cloth_simulator_data();
    ~rglReplay_cloth_simulator_data();
    rglReplay_cloth_simulator_data(const rglReplay_cloth_simulator_data *);
};

class *rglReplay_cloth_simulator_data
{
public:
    struct create_instance();
};

class *Morph_anim_player
{
public:
    struct get_global_morph_buffer();
};

class rglTerrain
{
public:
    void set_terrain_material_index_texture(rglTexture *);
    void set_terrain_mesh_blend_diffuse_texture_array(rglTexture *);
    void set_terrain_mesh_blend_normal_texture_array(rglTexture *);
    void set_terrain_mesh_blend_height_texture_array(rglTexture *);
    __int64 get_terrain_textures_detail_level();
    void set_terrain_textures_detail_level(int);
    void set_dynamic_params(const rglVec3 *);
    float get_terrain_node_pos(float *a2, int a3, int a4);
    float get_terrain_total_size(float *a2);
    rglTerrain();
    ~rglTerrain();
    bool get_position_layer_properties(const rglVec2 *, int, rglTerrain_layer_property *, int);
    char get_height_property(const rglVec2 *a2, float *a3);
    void clear_all();
    void build_terrain_finalize(char a2);
    void update_terrain_textures();
    void build_terrain(rglScene *a2, unsigned __int8 a3, unsigned __int8 a4);
    void finalize_terrain_nodes();
    void set_lod_multiplier(float);
    void refresh_dynamic_terrain_shader_params();
    float find_ideal_detail_level_of_node(int, int, const rglVec3 *);
    void update_lod(const rglVec3 *a2, char a3);
    void apply_season_change();
    void validate_weightmap_locations_for_nodes();
    bool scene_needs_colormap_textures();
    void refresh_node_vista_diffuse_state();
    void update_vista_state();
    __int64 get_layer_version();
    void delete_terrain_points_height_only();
    void delete_terrain_points_ao_only();
    void delete_terrain_points_material_only();
    void invalidate_physics_materials();
    __int64 size_of();
    void set_detail_level_of_node(int, int, float);
    void init_variables(rglScene *);
    void transfer_to_physics_engine();
    void initialize_terrain_layers();
    void build_nodes_height_and_material_maps();
    void build_physics();
    void copy_shader_cache_to_new_folder(const rglString_base *a2);
    void adjust_shadow_map_boundaries(rglShadowmap *a2, rglScene *a3);
    void build_terrain_nodes(char a2);
    void release_textures();
    void create_texture_arrays();
    void set_needs_rebuild_baked_data();
    char needs_rebuild_baked_data(char a2);
    bool is_skyaccess_rendered_this_frame();
    __int64 get_colormap_texture(int a2);
    void init_single_pass_shader_cache(__int64 a2);
    void kickstart_terrain_shaders();
    void init_single_pass_shader_cache_imp();
    void validate_shader_cache_directory();
    void write_terrain_header_data_bin();
    void initialize_terrain_shader_cache(rglScene *);
    void get_terrain_shader_cache_directory(rglScene *);
    void ensure_baked_textures();
    void set_terrain_mesh_params();
};

class Command_line_item
{
public:
    Command_line_item(const rglVarString *);
    rglVarString on_called(rglVarString *a2, const rglString_base *a3);
    rglVarString get_full_command(rglVarString *a2);
};

class rglView_base
{
public:
    __int64 get_type_id();
    void set_render_target(rglTexture *);
    rglView_base();
    ~rglView_base();
    rglView_base(const rglView_base *);
    rglView_base(const rglReference_counted_object *a2);
    __int64 get_type_name(__int64 a2);
};

class rglShadowmap
{
public:
    void set_shadowmap_size(int);
    __int64 get_shadowmap_size();
    void set_scene(rglScene *);
    void set_dynamic_shadowmap_cascades_radius_multiplier(float);
    float dynamic_shadowmap_cascades_radius_multiplier();
    bool shadows_are_enabled();
    bool dynamic_shadows_are_enabled();
    void invalidate_static_world_min_max();
    rglShadowmap(const rglShadowmap *);
    void release_shadowmap_resources();
    rglShadowmap();
    ~rglShadowmap();
    void init(rglScene *);
    void set_needs_rebuild_static();
    bool needs_rebuild_static(rglScene *);
    void build_static_shadows_common();
    void filter_occluded_entities(rglRender_context *);
    void reset_scene_static_shadow_coords();
    void add_vertex(const rglVec3 *);
    __int64 get_uv_coord(__int64 a2, float *a3);
    void setup_size();
    void check_shadowmap_quality_change();
    __int64 get_shadow_render_contexts(rglRender_context *, rglRender_context ***);
    void validate_no_static_shadow_texture();
    char check_static_shadow_texture_target_validness();
    void set_shadowmap_resolution_multiplier(float);
    __int64 get_atlas_size_for_config();
};

class rglData_compression_result
{
public:
    rglData_compression_result();
    bool is_ok();
    ~rglData_compression_result();
    rglData_compression_result(const rglData_compression_result *);
    rglData_compression_result(__int64 a2);
    __int64 operator=(__int64 a2);
};

class rglCompressor_interface
{
public:
    rglCompressor_interface();
};

class rglData_compressor_lzo
{
public:
    rglData_compressor_lzo();
    __int64 compress_data();
    __int64 decompress_data();
};

class rglData_compressor_lz4hc
{
public:
    void use_high_compression(char a2);
    rglData_compressor_lz4hc(const rglData_compressor_lz4hc *);
    __int64 operator=(__int64 a2);
    __int64 get_type();
    __int64 compress_data(__int64 a2, __int64 a3, unsigned __int64 a4, __int64 a5, unsigned int a6);
    __int64 decompress_data(_QWORD, _QWORD, _QWORD, _QWORD, _QWORD);
};

class rglData_decompressor
{
public:
    rglData_decompressor(const rglData_decompressor *);
    void operator=(void **a2);
    __int64 process_data(_QWORD, _QWORD, _QWORD);
};

class rglData_compressor
{
public:
    __int64 process_data(__int64 a2, __int64 a3, unsigned __int64 a4, __int64 a5);
};

class rglConvex_polygon3d
{
public:
    rglConvex_polygon3d();
    __int64 get_normal(__int64 a2, float *a3);
    float get_longest_dist_sq();
    ~rglConvex_polygon3d();
    rglConvex_polygon3d(const rglConvex_polygon3d *);
    rglConvex_polygon3d(const rglConvex_polygon *a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    char initialize(_OWORD *a2, __int64 *a3);
    char interior_check_with_scale(const rglVec2 *a2);
    bool intersect_with_capsule(const rglMatrix_frame *, const struct ftlCapsule_data *, rglVec3 *, bool);
    __int64 debug_render(float *a2, unsigned int a3, char a4, int a5);
    void apply_scale_to_points(float);
    void apply_addition_to_points(float);
    float get_directional_boundary_distance(const rglVec3 *);
};

class rglCRC_calculator
{
public:
    void CalcCrc32(unsigned int *);
    __int64 StringCrc32(unsigned int *a2);
    __int64 FileCrc32(unsigned int *a2, unsigned __int64 *a3);
};

class rglCrf_file
{
public:
    rglCrf_file(const rglString_base *);
    ~rglCrf_file();
    bool open_file(const rglString_base *, unsigned int *const, rglBuffer *, rglBuffer *, unsigned int *);
    __int64 close_file();
    __int64 read_head(int a2, __int64 a3, rglBuffer *a4, rglBuffer *a5, char a6, __int64 a7);
    void read_data_end(rglBuffer *a2, rglBuffer *a3);
    bool validate_crf_file_handle();
    bool close_crf_file_handle();
    void set_delete_on_exit();
    void cleanup();
};

class rglCRF_packer
{
public:
    char pack_crf_file(__int64 *a2, __int64 a3);
    __int64 write_resource_data(rglNative_file *a2, rglBuffer *a3, const char *a4, char *a5, int a6);
    __int64 write_resource_header(rglBuffer *a2, rglBuffer *a3, unsigned int a4, rglNative_file *a5, char *a6, int a7, const char *a8);
    char write_crf_file_header(rglBuffer *a2, _QWORD *a3, __int64 *a4, __int64 a5);
    bool write_resource_head_to_temp(rglResource *, unsigned int *, rglBuffer *, unsigned int *);
    char write_resource_data_to_temp(unsigned int *a2, int a3, rglBuffer *a4, rglBuffer *a5, int *a6, int *a7, unsigned int *a8, rglNative_file *a9);
    __int64 create_crf_files();
    __int64 create_crf_packing_process_for_content(const rglString_base *a2, const rglString_base *a3, void **a4);
    char pack_crf_file_in_memory(__int64 a2, __int64 a3, int a4);
    bool pack_crf_file_in_memory();
    bool write_resource_head_to_memory(unsigned int *, rglBuffer *, unsigned int *, rglBuffer *);
    char write_crf_file_header_to_memory(__int64 a2, __int64 *a3, __int64 a4, rglBuffer *a5);
    bool write_resource_headers_to_memory(rglBuffer *, unsigned int, const rglBuffer *, char *, __int64, const char *, rglBuffer *);
};

class rglDebug
{
public:
    rglDebug();
    ~rglDebug();
    void init(const rglString_base *a2, __int64 a3, __int64 a4, int a5);
    void deinit();
    __int64 is_initialized();
    void format_va(int a2, __int64 a3, int a4, __int64 a5, __int64 a6);
    void set_filter(__int64 a2, __int64 a3);
    void set_filter(__int64 a2);
    void set_system_filter(__int64 a2);
    void set_user_filter(__int64 a2);
    void flush();
    void set_console_screen_size(__int16 a2, __int16 a3);
    void wait_until_all_messages_are_processed();
    __int64 operator>>(__int64 a2);
    __int64 operator>>(float *a2);
    __int64 operator>>(double *a2);
    __int64 operator>>(int *a2);
    __int64 operator>>(unsigned int *a2);
    __int64 operator>>(__int64 a2);
    void print_system_time();
};

class rglDebug_render_extentions
{
public:
    void add_debug_line_ex(rglScene *a2, __int64 a3, float *a4, char a5, __int64 a6, int a7, char a8, int a9);
    void add_debug_coordinate_arc(rglScene *a2, float *a3, __int64 a4, float a5, float a6, float a7, unsigned int a8, int a9, char a10, char a11, char a12);
    void add_debug_coordinate_circle(rglScene *a2, float *a3, __int64 a4, float a5, unsigned int a6, int a7, char a8, char a9, char a10);
};

class rglDefault_anim_system
{
public:
    __int64 set_sound_play_callback(__int64 *a2);
    void clear_sound_play_callback();
    bool has_sound_play_callback();
    _QWORD operator=(__int64 a2);
    rglDefault_anim_system();
    ~rglDefault_anim_system();
    void setup(const rglSkeleton_model *a2);
    void tick(float, const rglSkeleton *);
    void check_for_animation_sound(float);
    __int64 set_channel_animation(__int64 a2, __int64 a3, __int64 a4);
    void fade_channel_layers(__int64 (__fastcall *a2);
    float get_channel_speed();
    float get_channel_parameter();
    void set_channel_parameter(__int64 a2, float a3);
    void get_channel_current_action_strength();
    float get_channel_current_action_fade_elapsed_time();
    float get_channel_duration_left();
    bool action_channel_at_end();
    void integrate_tree(const rglSkeleton *a2, float *const a3, rglAnim_result *a4);
    void integrate_channel(__int64 a2, rglAnim_result *a3, rglAnim_bone_relative_position_result *a4, rglAnim_bone_entitial_frame_result *a5, const rglSkeleton_model *a6);
};

class rglManaged_script_component
{
public:
    __int64 get_type_id();
    bool is_tickable();
    bool on_hit_callable();
    ftdnManaged_object_reference get_behaviour(ftdnManaged_object_reference *a2);
    rglManaged_script_component(const rglManaged_script_component *);
    __int64 get_type_name(__int64 a2);
    rglManaged_script_component(rglEntity *, rglScript_component_definition *);
    ~rglManaged_script_component();
    void on_pre_init();
    void on_init();
    void on_editor_init();
    void on_removed();
    void on_tick(float);
    void on_editor_tick(float);
    void on_editor_validate();
    void on_editor_variable_changed(const rglString_base *);
    void on_scene_save(const rglString_base *);
    void get_variables(void **a2);
    void set_field_value_of_type(const rglString_base *a2, rglScript_component_field_holder *a3, unsigned int a4, bool a5);
    void get_field_value_of_type(const rglString_base *a2, rglScript_component_field_holder *a3, unsigned int a4);
    void get_enum_names_of_field(rglString_base *a2, __int64 a3);
    __int64 get_type_of_field(const rglString_base *);
    __int64 get_field_class_name(__int64 a2, __int64 a3);
    __int64 get_field_size(const rglString_base *);
    __int64 is_field_exists(const rglString_base *a2);
    void set_scene(rglScene *);
    __int64 is_only_visual();
    __int64 moves_entity();
    void on_physics_collision(const rglPhysics_contact *);
    void on_edit_mode_visibility_changed();
    __int64 is_method_overridden(const char *a2);
    void init_callback_flags();
};

class rglGuid_generator
{
public:
    rglGuid_generator(const rglGuid_generator *);
    __int64 operator=(rglString_base *a2);
    __int64 get_guid(_QWORD, _QWORD);
    rglGuid_generator();
    ~rglGuid_generator();
    __int64 guid_to_string(unsigned int *a2);
    char is_valid_guid(const rglString_base *a2);
    void register_guid(void *, const rglString_base *);
    void deregister_guid(void *, const rglString_base *);
};

class rglEntity_view
{
public:
    void set_delete_after_rendering(char a2);
    void set_continous_rendering(char a2);
    void add_entity(__int64 *a2, _DWORD *a3);
    rglEntity_view(const rglEntity_view *);
    rglEntity_view();
    void set_rc_params(rglRender_context *);
    ~rglEntity_view();
};

class rglTableau_view
{
public:
    __int64 release_reference();
    __int64 get_type_id();
    void set_render_target(rglTexture *);
    void set_delete_after_rendering(char a2);
    void set_continous_rendering(char a2);
    void set_sort_meshes(char a2);
    void set_set_do_not_render_this_frame(char a2);
    rglTableau_view(const rglTableau_view *);
    void add_reference();
    __int64 get_type_name(__int64 a2);
    rglTableau_view();
    rglVarString get_desc(rglVarString *a2);
    void set_rc_params(rglRender_context *);
    bool needs_rendering();
    ~rglTableau_view();
};

class rglRay_extensions
{
public:
    char intersects_with_quad_data(const struct ftlQuad_data *a2, __int64 a3);
    char intersects_with_capsule_data(const struct ftlCapsule_data *a2, __int64 a3);
    char intersects_with_sphere_data(float *a2, __int64 a3);
    char intersects_with_quad_2d(const struct ftlQuad_data *a2);
};

class rglConvex_polygon_extensions
{
public:
    void render_debug_polygon();
};

class rglFile_difference_cacher
{
public:
    bool compute_file_crc_value(rglFile_difference_cache *);
    char check_folder_last_modified_date_is_newer_than_file(const rglString_base *a2);
    char check_folder_last_modified_date_is_newer_than(__int64 a2, char a3);
    _BOOL8 check_file_crc_value_is_different(const rglFile_difference_cache *a2);
};

class rglFlora_group
{
public:
    rglFlora_group(const rglFlora_group *);
    __int64 operator=(__int64 a2);
    rglFlora_group();
    ~rglFlora_group();
    void read(__int64 a2);
    void normalize_flora_record_densities();
    rglEntity get_display_entity(rglEntity **a2, int *a3);
};

class rglFMOD_Sound_manager
{
public:
    float get_event_max_distance(struct FMOD::Studio::EventDescription *);
    __int64 get_user_property_count(const struct FMOD::Studio::EventDescription *);
    bool get_user_property(const struct FMOD::Studio::EventDescription *, const char *, struct FMOD_STUDIO_USER_PROPERTY *);
    bool get_parameter_by_index(const struct FMOD::Studio::EventDescription *, int, struct FMOD_STUDIO_PARAMETER_DESCRIPTION *);
    bool get_parameter(const struct FMOD::Studio::EventDescription *, const char *, struct FMOD_STUDIO_PARAMETER_DESCRIPTION *);
    __int64 get_parameter_count(const struct FMOD::Studio::EventDescription *);
};

class rglFont
{
public:
    rglFont();
    ~rglFont();
    rglFont(const rglFont *);
    rglFont(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    void read_font_data(const rglVarString *, const rglVarString *, const rglVarString *);
    void add_character_to_mesh(int a2, const rglVec3 *a3, rglColor *a4, const float *a5, const rglVec2 *a6, rglMesh *a7, const rglColor *a8);
    __int64 get_next_word_first_char_index(unsigned int *const, int, const int *, bool *);
    float get_uv_width(int);
    float get_text_width(unsigned int *const a2, const int *a3, int a4, const int *a5, const float *a6, float a7);
    float add_text(float *a2, const rglString_base *a3, rglColor *a4, __int64 a5, rglColor *a6, _QWORD *a7, const rglColor *a8, __int64 a9, __int64 a10, __int64 a11, __int64 *a12, _DWORD *a13, int *a14);
    __int64 get_text_size(__int64 a2, __int64 a3, float *a4, float *a5, __int64 a6, int a7, __int64 *a8);
    float draw_text(float *a2, const rglString_base *a3, rglColor *a4, __int64 a5, rglColor *a6, int a7, int a8, int a9, int a10, __int64 a11, __int64 a12);
    float get_text_auto_spacing_factor(float);
};

class rglThumbnail_creator
{
public:
    __int64 operator=(__int64 a2);
    rglThumbnail_creator();
    ~rglThumbnail_creator();
    void wait_all_tasks();
    void on_render_callback();
    void remove_thumbnail_request(int a2, const rglString_base *a3);
};

class rglGPU_buffer
{
public:
    __int64 read_data(rglBuffer *a2);
};

class rglHash_map_index
{
public:
    rglHash_map_index();
    ~rglHash_map_index();
    rglHash_map_index(const rglHash_map_index *);
    rglHash_map_index(__int64 a2);
    __int64 operator=(rglHash_map_index *a2);
    rglHash_map_index operator=(rglHash_map_index *a2);
    __int64 operator[](int *a2);
    _DWORD set(int *a2, _DWORD *a3);
    __int64 get(__int64 a2);
    char remove(__int64 a2);
    void clear();
};

class rglHighlights
{
public:
    ~rglHighlights();
    rglHighlights(__int64 *a2);
    rglHighlights();
    void Init(const char *Src, const char *);
    void DeInit();
    void OnTick();
    void OnNotification(int a2, __int64 a3);
    __int64 OnOpenGroup(_QWORD);
    __int64 OnCloseGroup(_QWORD, _QWORD);
    void OnSaveScreenshot(rglString_base *a2, rglString_base *a3);
    __int64 OnSaveVideo(_QWORD, _QWORD, _QWORD, _DWORD);
    void OnOpenSummary(const char **const, unsigned __int64);
    void add_highlight(void *a2, void *a3, int a4, int a5);
    void remove_highlight(const rglString_base *a2);
};

class rglShader_compile_task
{
public:
    ~rglShader_compile_task();
    rglShader_compile_task(rglEffect *, const rglShader_manager::rglShader_compile_desc_internal *);
    void run();
};

class rglInterpolated_atmosphere
{
public:
    void set_frame_id(float);
    float get_frame_id();
    __int64 operator=(__int64 a2);
    void on_scene_save(void *a2, void *a3);
    rglInterpolated_atmosphere();
    ~rglInterpolated_atmosphere();
    void read(const rglString_base *);
    void apply_to_atmosphere(rglAtmosphere *);
    void initialize_interpolator();
    void add_atmosphere_as_key_frame(const rglAtmosphere *, float);
    __int64 change_data_at_frame(void *a2, int a3, int a4, int a5, int a6, __int64 a7);
    void apply_envmap_blend(rglScene *);
    void disable_envmap_blend(rglScene *);
    void read_from_scene(rglScene *);
    void read_from_atmosphere_prefab(const rglVarString *);
};

class rglInter_Context_Blur
{
public:
    void set_params_to_render_context();
};

class rglIpo_optimizer<rglQuaternion>
{
public:
    bool interpolate_and_test_for_nearly_equals(__int64 a2, float *a3, double a4, float *a5, double a6);
    bool compare_keys(__int64 *a2, int a3, int a4);
};

class rglIpo_optimizer<rglVec3>
{
public:
    bool interpolate_and_test_for_nearly_equals(float *a2, float *a3, double a4, float *a5, double a6);
    bool compare_keys(__int64 *a2, int a3, int a4);
};

class rglTest_script
{
public:
    rglTest_script(rglTest_script_definition *);
    ~rglTest_script();
    rglTest_script(const rglTest_script *);
};

class rglPhysX_physics_engine_body
{
public:
    rglPhysX_physics_engine_body();
    rglPhysX_physics_engine_body(struct physx::PxRigidActor *);
    void set_actor(struct physx::PxRigidActor *);
    void set_enabled(unsigned __int8 a2);
    void disable_simulation(__int64 a2, __int64 a3);
    rglPhysX_physics_engine_body(const rglPhysX_physics_engine_body *);
    void set_world_transform(const rglMatrix_frame *);
    __int64 get_world_transform(__int64 a2);
    __int64 get_visual_world_transform(__int64 a2);
    __int64 is_sleeping();
    bool is_rigid_body();
    char ray_cast(float *a2, __int64 a3);
    rglBounding_box get_global_bounds(rglBounding_box *a2);
    _DWORD get_linear_velocity(_DWORD *a2);
    void set_linear_velocity(const rglVec3 *a2, __int64 a3);
    _DWORD get_angular_velocity(_DWORD *a2);
    void set_angular_velocity(const rglVec3 *a2, __int64 a3);
    void apply_force_local(const rglVec3 *, const rglVec3 *);
    void apply_torque(const rglVec3 *a2, __int64 a3, __int64 a4);
    void apply_impulse_local(const rglVec3 *, const rglVec3 *);
    void set_mass(float);
    void get_mass();
    void set_damping(float, float);
    bool is_rigid_body_active();
    void force_activation();
    void set_shape(const rglPhysics_engine_shape *);
    bool capsule_intersection(__int64 a2, __int64 a3);
};

class rglLibrary_interface
{
public:
    rglLibrary_interface();
    rglLibrary_interface(const rglLibrary_interface *);
    rglLibrary_interface();
    char error(const char *a2, char a3);
    char warning(const char *a2, char a3);
    char content_warning(const char *a2, char a3);
    char failed_assert(const char *a2, unsigned int a3, const char *a4, bool a5, bool a6);
    void log(const char *);
    __int64 get_assert_on_exceptions();
    bool get_enable_deterministic_mode();
    bool get_disable_gui_messages();
    bool delete_later_queue_has_element(rglReference_counted_object *);
    void add_delete_later_queue(rglReference_counted_object *);
    __int64 unhandled_exception_handler(void *);
};

class rglLoading_screen_view
{
public:
    __int64 get_type_id();
    rglLoading_screen_view(const rglLoading_screen_view *);
    __int64 get_type_name(__int64 a2);
    rglLoading_screen_view();
    ~rglLoading_screen_view();
    rglVarString get_desc(rglVarString *a2);
    __int64 get_random_loading_background_texture(_QWORD);
    void check_slideshow_texture();
};

class rglBeta_indicator_view
{
public:
    __int64 get_type_id();
    rglBeta_indicator_view(const rglBeta_indicator_view *);
    __int64 get_type_name(__int64 a2);
    rglBeta_indicator_view();
    ~rglBeta_indicator_view();
    rglVarString get_desc(rglVarString *a2);
};

class rglStreaming_texture
{
public:
    const constant_buffer(int);
};

class rglMesh_morph_cache_manager
{
public:
    __int64 get_cache_size();
    void get_morphed_copy_to(rglMeta_mesh *, const rglMeta_mesh *, int);
    ~rglMesh_morph_cache_manager();
    rglMesh_morph_cache_manager();
    void reset();
};

class rglFace_animation_record_manager
{
public:
    rglFace_animation_record_manager();
    ~rglFace_animation_record_manager();
    void reset();
    __int64 get_face_animation_record_index_by_name(const rglString_base *);
    __int64 operator=(_QWORD *a2);
    __int64 read_and_store_rhubarb_data(__int64 a2, __int64 a3);
    void read(__int64 a2, _QWORD *a3, __int64 a4, _QWORD *a5);
};

class rglModule_data
{
public:
    __int64 get_nav_mesh_prefab_module_id();
    void add_nav_mesh_prefab(int a2, char a3);
    void write_decal_textures();
    void read_additional_skeleton_data();
    void write_additional_skeleton_data();
};

class rglMorph_anim
{
public:
    rglMorph_anim();
    void read(rglBuffer *a2);
    void update(rglBuffer *a2, unsigned int a3);
    void update(const rglResource *);
    void write(rglIO_Stream *);
    __int64 write_head(rglBuffer *, unsigned int *);
    void read_head(rglCrf_file *, rglBuffer *);
    __int64 write_data(rglBuffer *a2);
    void read_data();
    __int64 get_num_keyframes();
    float get_total_time();
    void get_keyframes_for_time(rglMorph_anim::Morph_anim_keyframe **, rglMorph_anim::Morph_anim_keyframe **, float *, float);
};

class Morph_anim_player
{
public:
    void add_mesh(rglMeta_mesh *);
    void add_mesh_with_vertex_map(rglMeta_mesh *, const struct Vertex_map_rec *, rglMesh *, const rglMatrix_frame *);
    void set_animation(const rglString_base *a2, char a3);
    void set_animation(rglMorph_anim *a2, char a3);
    void integrate(rglScene *, rglMorph_anim::Morph_target *const, int);
    __int64 get_gpu_morph_animation_texture_for_mesh(__int64 a2, __int64 a3, __int64 a4, _DWORD *a5, _DWORD *a6, unsigned __int64 *a7);
    __int64 create_gpu_morph_animation_texture_for_mesh(__int64);
    void get_animation_keyframes_list(rglMorph_anim *, int *, rglMorph_anim::Morph_target *, float);
};

class rglPerlin
{
public:
    void turbulance(const rglVec3 *, rglVec3 *);
    void recursive_turbulance(float, int, int, const rglVec3 *, rglVec3 *);
    void set_seed();
    float fixed_rand();
    __int64 fixed_rand_int();
    _DWORD random_vec3();
};

class rglPostfx_graph
{
public:
    __int64 get_user_config_flag();
    void set_user_config_flag(int);
};

class rglQuick_union
{
public:
    rglQuick_union(int a2);
    bool find(int a2, __int64 a3);
    __int64 get_element_count_of_group(int);
    rglQuick_union(const rglQuick_union *);
    void operator=(void **a2);
    void resize_and_invalidate(int);
    void unite(int, int);
    __int64 compute_group_count();
    __int64 compute_group_root_by_group_index(int);
    __int64 get_group_roots_that_have_more_than_one_item(_QWORD *a2);
    __int64 root_with_merge(__int64 a2);
    __int64 root(unsigned int a2);
};

class *rglReplay_meta_mesh_data
{
public:
    struct create_instance();
};

class *rglReplay_light_data
{
public:
    struct create_instance();
};

class *rglReplay_particle_system_data
{
public:
    struct create_instance();
};

class *rglReplay_composite_data
{
public:
    struct create_instance();
};

class *rglReplay_unique_edit_data
{
public:
    struct create_instance();
};

class rglResource_buffer_manager
{
public:
    rglResource_buffer_manager();
    ~rglResource_buffer_manager();
    void release_pooled_memories();
    void dealloc(rglMemory_block_typeless *);
    void init();
};

class rglMemory_block_typeless
{
public:
    __int64 release_reference();
};

class rglResource_cache
{
public:
    rglResource_cache();
    ~rglResource_cache();
    void reset();
    void initialize_runtime_resources();
    _QWORD get_ui_font_material(rglMemory_block_typeless *a2);
    _QWORD get_ui_font_outline_material(rglMemory_block_typeless *a2);
    _QWORD get_matte_material(rglMemory_block_typeless *a2);
    _QWORD get_default_particle_material(rglMemory_block_typeless *a2);
    _QWORD get_data_graph_material(rglMemory_block_typeless *a2);
    _QWORD get_enemy_circle_material(rglMemory_block_typeless *a2);
    void set_hammersley_texture(rglMemory_block_typeless **a2);
    __int64 get_default_shader(unsigned __int16 a2);
    _QWORD get_default_ui_mesh(__int64 a2);
    _QWORD get_two_dimensional_ui_mesh(__int64 a2);
    _QWORD get_detailed_sphere_mesh(rglMemory_block_typeless *a2);
    _QWORD get_sphere_mesh(rglMemory_block_typeless *a2);
    _QWORD get_detailed_cylinder_mesh(rglMemory_block_typeless *a2);
    _QWORD get_capsule_mesh(rglMemory_block_typeless *a2);
    _QWORD get_simple_box_mesh(rglMemory_block_typeless *a2);
    _QWORD get_portal_area_box_mesh(rglMemory_block_typeless *a2);
    _QWORD get_portal_link_mesh(rglMemory_block_typeless *a2);
    _QWORD get_skybox_mesh(rglMemory_block_typeless *a2);
    _QWORD get_decal_mesh(rglMemory_block_typeless *a2);
    _QWORD get_decal_mesh_flipped(rglMemory_block_typeless *a2);
    _QWORD get_unit_xy_mesh(__int64 a2);
    _QWORD get_snow_material(rglMemory_block_typeless *a2);
    _QWORD get_rain_material(rglMemory_block_typeless *a2);
    _QWORD get_infantry_step_material(_QWORD *a2, __int64 a3, rglString_base *a4);
    _QWORD get_mount_step_material(_QWORD *a2, __int64 a3, rglString_base *a4);
    __int64 get_terrain_material(_QWORD);
    void set_skinning_position_offset_texture(rglMemory_block_typeless **a2);
};

class rglTableau_cache_manager
{
public:
    void get_folder_name();
    void export_new_texture();
};

class rglRhubarb_data
{
public:
    __int64 alpha_to_rhubarb_char();
    __int64 rhubarb_char_to_alpha();
    bool read(const rglVarString *);
    __int64 find_index(float);
    __int64 get_cue_pair_and_interpolator(__int64 a2, float a3);
};

class rglModule_data_checker
{
public:
    __int64 check_tres_files();
};

class rglScript_component_helper
{
public:
    void add_managed_script_component_definition(char **a2);
    __int64 add_native_script_component_definition(_QWORD);
    __int64 is_script_component_exists();
    __int64 get_script_component_names();
    __int64 get_script_component_and_base_class_names(void **a2);
    void get_using_script_component_name(__int64 a2);
};

class rglSound_event
{
public:
    void set_daytime(float);
};

class rglTest_lib
{
public:
    void wait_for_async();
    void add_test_script_definition(__int64 a2);
    __int64 is_test_script_exists();
    __int64 get_test_script_names();
    __int64 get_test_script_and_base_class_names(char **a2);
    rglVarString get_using_test_script_name(__int64 a2);
};

class rglTwo_dimension_view
{
public:
    __int64 get_type_id();
    rglTwo_dimension_view(const rglTwo_dimension_view *);
    __int64 get_type_name(__int64 a2);
    rglTwo_dimension_view();
    ~rglTwo_dimension_view();
    void begin_frame();
    void end_frame();
    void add_new_mesh(rglMesh *, int);
    void define_new_mesh(__int64 a2, __int64 a3, __int64 a4, __int64 a5, rglTwo_dimension_mesh_draw_data *a6, __int64 *a7, __int64 a8);
    void add_custom_mesh(__int64 a2, __int64 a3, __int64 a4, __int64 a5, rglTwo_dimension_mesh_draw_data *a6, __int64 *a7, rglTwo_dimension_mesh_draw_data *a8);
    void prepare_nine_patch_mesh(__int64 a2, __int64 a3, __int64 *a4, rglTwo_dimension_mesh_draw_data *a5);
    void fill_gpu_params(rglMesh *, rglTwo_dimension_mesh_draw_data *);
    void begin_frame();
};

class rglTexture_array_load_task
{
public:
    rglTexture_array_load_task(rglTexture *a2, const rglTexture_array_creation_desc *a3);
    ~rglTexture_array_load_task();
};

class rglTexture_view
{
public:
    __int64 get_type_id();
    rglTexture_view(const rglTexture_view *);
    rglTexture_view(const rglView *a2);
    __int64 get_type_name(__int64 a2);
    rglTexture_view();
    void set_texture(rglTexture *);
    void refresh_render_mesh();
    rglVarString get_desc(rglVarString *a2);
};

class rglVideo_player_view
{
public:
    ~rglVideo_player_view();
    __int64 get_type_id();
    rglVideo_player_view(const rglVideo_player_view *);
    rglVideo_player_view(const rglView *a2);
    __int64 get_type_name(__int64 a2);
    rglVideo_player_view();
    rglVarString get_desc(rglVarString *a2);
    void play_file(_QWORD *a2, __int64 a3, _QWORD *a4);
};

class rglFrame_move_task
{
public:
    rglFrame_move_task(rglSignal_event *);
    void run();
};

class rglPhysics_shape
{
public:
    rglPhysics_shape();
    ~rglPhysics_shape();
    void update(const rglResource *);
    void read(rglBuffer *a2);
    void update(rglBuffer *a2, unsigned int a3);
    __int64 get_data_count();
    __int64 write_head(rglBuffer *, unsigned int *);
    __int64 write_data(rglBuffer *a2, int a3);
    void read_head(rglCrf_file *, rglBuffer *);
    void read_data();
    void read_static_cooked_data();
    void read_dynamic_cooked_data(float *a2);
    __int64 create_copy();
    __int64 create_debug_visual_mesh(_QWORD);
};

class rglEngine_async_loader_task
{
public:
    rglEngine_async_loader_task(bool *);
    void run();
};

class disable_cloth_script
{
public:
    disable_cloth_script(rglEntity *, rglScript_component_definition *);
};

class show_component_bbox_radius_script
{
public:
    show_component_bbox_radius_script(rglEntity *, rglScript_component_definition *);
};

class rglTimer
{
public:
    float delta_time();
};

class rglManaged_message_interface
{
public:
    ~rglManaged_message_interface();
    rglManaged_message_interface(const rglManaged_message_interface *);
    rglManaged_message_interface(__int64 a2);
    __int64 operator=(__int64 a2);
    __int64 operator=(__int64 a2);
    rglManaged_message_interface(ftdnManaged_object_reference *a2);
    void post_warning_line(const char *);
    void post_success_line(const char *);
    void post_message_line_formatted(unsigned int, const char *);
    void post_message_line(const rglVarString *, const int *);
};

class ambient_sound_emitter
{
public:
    ambient_sound_emitter(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
    void get_enum_names_of_field(rglString_base *a2, void **a3);
};

class animation_instance
{
public:
    animation_instance(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class decal_instance
{
public:
    decal_instance(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class water_body
{
public:
    water_body(rglEntity *, rglScript_component_definition *);
    void get_enum_names_of_field(rglString_base *a2, void **a3);
    void on_editor_variable_changed(const rglString_base *);
};

class mesh_bender
{
public:
    mesh_bender(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
    void get_physics_bb_for_mesh_bending(rglEntity *, rglEntity **, rglBounding_box *);
    void ensure_mesh_material_is_valid(rglMesh *);
};

class mesh_seasonal_material
{
public:
    mesh_seasonal_material(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class multi_material_paint
{
public:
    multi_material_paint(rglEntity *, rglScript_component_definition *);
    void apply_second_material(rglMaterial *);
    void on_editor_variable_changed(const rglString_base *);
};

class object_mover
{
public:
    object_mover(rglEntity *, rglScript_component_definition *);
};

class path_navigator
{
public:
    path_navigator(rglEntity *, rglScript_component_definition *);
};

class path_spline_sound_emitter
{
public:
    void on_editor_variable_changed(const rglString_base *);
};

class path_converger
{
public:
    void on_editor_variable_changed(const rglString_base *);
};

class reflection_assigner
{
public:
    reflection_assigner(rglEntity *, rglScript_component_definition *);
    void set_field_value_for_entity(const rglString_base *a2, rglEntity *a3, char a4);
};

class reflection_capturer
{
public:
    reflection_capturer(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class skeletal_mesh_editer
{
public:
    skeletal_mesh_editer(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class reverb_instance
{
public:
    reverb_instance(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
    void get_enum_names_of_field(rglString_base *a2, void **a3);
};

class road_instance
{
public:
    road_instance(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class sound_emitter
{
public:
    sound_emitter(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class camera_instance
{
public:
    camera_instance(rglEntity *, rglScript_component_definition *);
    void fill_dof_params(rglVec3 *);
};

class face_visual_test_script
{
public:
    face_visual_test_script(rglEntity *, rglScript_component_definition *);
};

class physics_test
{
public:
    physics_test(rglEntity *, rglScript_component_definition *);
    void get_enum_names_of_field(rglString_base *a2, void **a3);
    void on_editor_variable_changed(const rglString_base *);
};

class physics_test_manager_script
{
public:
    physics_test_manager_script(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class barrier_builder
{
public:
    barrier_builder(rglEntity *, rglScript_component_definition *);
    void on_editor_variable_changed(const rglString_base *);
};

class rglDelete_later_tick_task
{
public:
    rglDelete_later_tick_task();
    void run();
};

class rglFinal_cleanup_task
{
public:
    void run();
    rglFinal_cleanup_task();
};

class rglInitialization_task
{
public:
    rglInitialization_task(const char *, void *);
    ~rglInitialization_task();
    void run();
};

